/*
 * *** Please do not edit ! ***
 * @(#) AnyConflicts_1.cs
 * @procedure any_conflicts/1 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class AnyConflicts_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate AnyConflicts_1_1 = new Predicates.AnyConflicts_1_1();
    static internal readonly Predicate AnyConflicts_1_2 = new Predicates.AnyConflicts_1_2();
    static internal readonly Predicate AnyConflicts_1_var = new Predicates.AnyConflicts_1_var();

    public Term arg1;

    public AnyConflicts_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public AnyConflicts_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   AnyConflicts_1_var,
                                   dollar_fail_0,
                                   AnyConflicts_1_1,
                                   dollar_fail_0,
                                   AnyConflicts_1_2
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "any_conflicts(" + arg1 + ")";
    }
}

sealed class AnyConflicts_1_var : AnyConflicts_1 {
    static internal readonly Predicate AnyConflicts_1_var_1 = new Predicates.AnyConflicts_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(AnyConflicts_1_1, AnyConflicts_1_var_1);
    }
}

sealed class AnyConflicts_1_var_1 : AnyConflicts_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(AnyConflicts_1_2);
    }
}

sealed class AnyConflicts_1_1 : AnyConflicts_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class AnyConflicts_1_2 : AnyConflicts_1 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        p1 = new Predicates.AnyConflicts_1(a5, cont);
        p2 = new Predicates.dollar_dummyDca2__7_1(a4, p1);
        p3 = new Predicates.Setdiff_3(a3, a4, a5, p2);
        return new Predicates.FilterConflicts_3(a2, a3, a4, p3);
    }
}
}

