/*
 * *** Please do not edit ! ***
 * @(#) BroadcastAllFacts_1.cs
 * @procedure broadcast_all_facts/1 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class BroadcastAllFacts_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate BroadcastAllFacts_1_1 = new Predicates.BroadcastAllFacts_1_1();
    static internal readonly Predicate BroadcastAllFacts_1_2 = new Predicates.BroadcastAllFacts_1_2();
    static internal readonly Predicate BroadcastAllFacts_1_var = new Predicates.BroadcastAllFacts_1_var();

    public Term arg1;

    public BroadcastAllFacts_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public BroadcastAllFacts_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   BroadcastAllFacts_1_var,
                                   dollar_fail_0,
                                   BroadcastAllFacts_1_1,
                                   dollar_fail_0,
                                   BroadcastAllFacts_1_2
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "broadcast_all_facts(" + arg1 + ")";
    }
}

sealed class BroadcastAllFacts_1_var : BroadcastAllFacts_1 {
    static internal readonly Predicate BroadcastAllFacts_1_var_1 = new Predicates.BroadcastAllFacts_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(BroadcastAllFacts_1_1, BroadcastAllFacts_1_var_1);
    }
}

sealed class BroadcastAllFacts_1_var_1 : BroadcastAllFacts_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(BroadcastAllFacts_1_2);
    }
}

sealed class BroadcastAllFacts_1_1 : BroadcastAllFacts_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class BroadcastAllFacts_1_2 : BroadcastAllFacts_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("Broadcast: ");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("DCAServer.DCAServer");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("BroadcastAssertTerm", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h4 = {a2};
        a4 = new StructureTerm(f3, h4);
        p1 = new Predicates.BroadcastAllFacts_1(a3, cont);
        p2 = new Predicates.dollar_csMethod_3(s2, a4, engine.makeVariable(), p1);
        p3 = new Predicates.dollar_nl_0(p2);
        p4 = new Predicates.Write_1(a2, p3);
        return new Predicates.Write_1(s1, p4);
    }
}
}

