/*
 * *** Please do not edit ! ***
 * @(#) Conflict_3.cs
 * @procedure conflict/3 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Conflict_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("pred", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("key");

    public Term arg1, arg2, arg3;

    public Conflict_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public Conflict_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        a5 = engine.makeVariable();
        a4 = new ListTerm(engine.makeVariable(), a5);
        a7 = engine.makeVariable();
        a6 = new ListTerm(engine.makeVariable(), a7);
        a9 = engine.makeVariable();
        Term[] h2 = {a1, a9};
        a8 = new StructureTerm(f1, h2);
        p1 = new Predicates.dollar_dummyDca2__6_3(a5, a7, a9, cont);
        p2 = new Predicates.CheckForConflict_4(a5, a7, a9, s3, p1);
        p3 = new Predicates.ThereAreSomeKeys_1(a9, p2);
        p4 = new Predicates.GlobalCall_1(a8, p3);
        p5 = new Predicates.eq_stop_stop_2(a3, a6, p4);
        return new Predicates.eq_stop_stop_2(a2, a4, p5);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "conflict(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

