/*
 * *** Please do not edit ! ***
 * @(#) CopyRetractToConnected_1.cs
 * @procedure copy_retract_to_connected/1 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class CopyRetractToConnected_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("DCAServer.DCAServer");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("BroadcastRetract", 1);

    public Term arg1;

    public CopyRetractToConnected_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public CopyRetractToConnected_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        a1 = arg1.dereference();

        Term[] h3 = {a1};
        a2 = new StructureTerm(f2, h3);
        return new Predicates.dollar_csMethod_3(s1, a2, engine.makeVariable(), cont);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "copy_retract_to_connected(" + arg1 + ")";
    }
}
}

