/*
 * *** Please do not edit ! ***
 * @(#) DcaAssertPred_3.cs
 * @procedure dca_assert_pred/3 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DcaAssertPred_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("pred", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);

    public Term arg1, arg2, arg3;

    public DcaAssertPred_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public DcaAssertPred_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        Term[] h3 = {a1, a2};
        a5 = new StructureTerm(f2, h3);
        Term[] h4 = {a5, a3};
        a4 = new StructureTerm(f1, h4);
        return new Predicates.GlobalAssert_1(a4, cont);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "dca_assert_pred(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

