/*
 * *** Please do not edit ! ***
 * @(#) DcaInit_0.cs
 * @procedure dca_init/0 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DcaInit_0 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("fact");
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);
    static internal readonly Term[] h7 = {s2, s3};
    static internal readonly StructureTerm s4 = new StructureTerm(f1, h7);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("pred");
    static internal readonly Term[] h8 = {s5, s3};
    static internal readonly StructureTerm s6 = new StructureTerm(f1, h8);

    public DcaInit_0(Predicate cont) {
        this.cont = cont;
    }

    public DcaInit_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Predicate p1;

        p1 = new Predicates.GlobalAbolish_1(s6, cont);
        return new Predicates.GlobalAbolish_1(s4, p1);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "dca_init";
    }
}
}

