/*
 * *** Please do not edit ! ***
 * @(#) DcaRetractOnServer_1.cs
 * @procedure dca_retract_on_server/1 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DcaRetractOnServer_1 : Predicate {
    static internal readonly Predicate DcaRetractOnServer_1_1 = new Predicates.DcaRetractOnServer_1_1();
    static internal readonly Predicate DcaRetractOnServer_1_2 = new Predicates.DcaRetractOnServer_1_2();
    static internal readonly Predicate DcaRetractOnServer_1_sub_1 = new Predicates.DcaRetractOnServer_1_sub_1();

    public Term arg1;

    public DcaRetractOnServer_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public DcaRetractOnServer_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(DcaRetractOnServer_1_1, DcaRetractOnServer_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "dca_retract_on_server(" + arg1 + ")";
    }
}

sealed class DcaRetractOnServer_1_sub_1 : DcaRetractOnServer_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(DcaRetractOnServer_1_2);
    }
}

sealed class DcaRetractOnServer_1_1 : DcaRetractOnServer_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("fact", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        a2 = engine.makeVariable();
        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h3 = {a4, a5};
        a7 = new StructureTerm(f2, h3);
        Term[] h4 = {a7, a3};
        a6 = new StructureTerm(f1, h4);
        p1 = new Predicates.GlobalRetract_1(a6, cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_functor_3(a3, a4, a5, p2);
        p4 = new Predicates.GetTermJjc_2(a1, a3, p3);
        return new Predicates.dollar_getLevel_1(a2, p4);
    }
}

sealed class DcaRetractOnServer_1_2 : DcaRetractOnServer_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("fact", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly IntegerTerm s3 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        a2 = engine.makeVariable();
        Term[] h4 = {a2, s3};
        a4 = new StructureTerm(f2, h4);
        Term[] h5 = {a4, a2};
        a3 = new StructureTerm(f1, h5);
        p1 = new Predicates.GlobalRetract_1(a3, cont);
        return new Predicates.GetTermJjc_2(a1, a2, p1);
    }
}
}

