/*
 * *** Please do not edit ! ***
 * @(#) DcaSpecialRetract_1.cs
 * @procedure dca_special_retract/1 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DcaSpecialRetract_1 : Predicate {
    static internal readonly Predicate DcaSpecialRetract_1_1 = new Predicates.DcaSpecialRetract_1_1();
    static internal readonly Predicate DcaSpecialRetract_1_2 = new Predicates.DcaSpecialRetract_1_2();
    static internal readonly Predicate DcaSpecialRetract_1_sub_1 = new Predicates.DcaSpecialRetract_1_sub_1();

    public Term arg1;

    public DcaSpecialRetract_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public DcaSpecialRetract_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(DcaSpecialRetract_1_1, DcaSpecialRetract_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "dca_special_retract(" + arg1 + ")";
    }
}

sealed class DcaSpecialRetract_1_sub_1 : DcaSpecialRetract_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(DcaSpecialRetract_1_2);
    }
}

sealed class DcaSpecialRetract_1_1 : DcaSpecialRetract_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("fact", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        a2 = engine.makeVariable();
        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        Term[] h3 = {a3, a4};
        a6 = new StructureTerm(f2, h3);
        Term[] h4 = {a6, a1};
        a5 = new StructureTerm(f1, h4);
        p1 = new Predicates.GlobalRetract_1(a5, cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_functor_3(a1, a3, a4, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class DcaSpecialRetract_1_2 : DcaSpecialRetract_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("fact", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly IntegerTerm s3 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        Term[] h4 = {a1, s3};
        a3 = new StructureTerm(f2, h4);
        Term[] h5 = {a3, a1};
        a2 = new StructureTerm(f1, h5);
        return new Predicates.GlobalRetract_1(a2, cont);
    }
}
}

