/*
 * *** Please do not edit ! ***
 * @(#) GetTermJjc_2.cs
 * @procedure get_term_jjc/2 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GetTermJjc_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("DCAServer.DCAServer");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("GetStringReader", 1);

    public Term arg1, arg2;

    public GetTermJjc_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public GetTermJjc_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        Term[] h3 = {a1};
        a3 = new StructureTerm(f2, h3);
        a4 = engine.makeVariable();
        p1 = new Predicates.Read_2(a4, a2, cont);
        return new Predicates.dollar_csMethod_3(s1, a3, a4, p1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "get_term_jjc(" + arg1 + ", " + arg2 + ")";
    }
}
}

