/*
 * *** Please do not edit ! ***
 * @(#) ResetAllAgents_0.cs
 * @procedure reset_all_agents/0 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ResetAllAgents_0 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("DCAServer.DCAServer");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("BroadcastAllRetract");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("ResetAllPorts", 1);

    public ResetAllAgents_0(Predicate cont) {
        this.cont = cont;
    }

    public ResetAllAgents_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3;
        Predicate p1, p2, p3;

        a1 = engine.makeVariable();
        a2 = engine.makeVariable();
        Term[] h4 = {a2};
        a3 = new StructureTerm(f3, h4);
        p1 = new Predicates.dollar_csMethod_3(s1, a3, engine.makeVariable(), cont);
        p2 = new Predicates.ListToObject_2(a1, a2, p1);
        p3 = new Predicates.GetAllFacts_1(a1, p2);
        return new Predicates.dollar_csMethod_3(s1, s2, engine.makeVariable(), p3);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "reset_all_agents";
    }
}
}

