/*
 * *** Please do not edit ! ***
 * @(#) ResolveAll_2.cs
 * @procedure resolve_all/2 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ResolveAll_2 : Predicate {
    static internal readonly Predicate ResolveAll_2_1 = new Predicates.ResolveAll_2_1();
    static internal readonly Predicate ResolveAll_2_2 = new Predicates.ResolveAll_2_2();
    static internal readonly Predicate ResolveAll_2_sub_1 = new Predicates.ResolveAll_2_sub_1();

    public Term arg1, arg2;

    public ResolveAll_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public ResolveAll_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(ResolveAll_2_1, ResolveAll_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "resolve_all(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class ResolveAll_2_sub_1 : ResolveAll_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(ResolveAll_2_2);
    }
}

sealed class ResolveAll_2_1 : ResolveAll_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("global_call", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("pred", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        Term[] h3 = {a3, engine.makeVariable()};
        a5 = new StructureTerm(f2, h3);
        Term[] h4 = {a5};
        a4 = new StructureTerm(f1, h4);
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        p1 = new Predicates.WaitFor_1(a7, cont);
        p2 = new Predicates.ResolveAllInList_4(a1, a2, a6, a7, p1);
        return new Predicates.Findall_3(a3, a4, a6, p2);
    }
}

sealed class ResolveAll_2_2 : ResolveAll_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.cont;
    }
}
}

