/*
 * *** Please do not edit ! ***
 * @(#) ResolveConflict_4.cs
 * @procedure resolve_conflict/4 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ResolveConflict_4 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("DCAServer.DCAServer");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("ResolveConflict", 3);

    public Term arg1, arg2, arg3, arg4;

    public ResolveConflict_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public ResolveConflict_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        a5 = engine.makeVariable();
        Term[] h3 = {a5, a2, a3};
        a6 = new StructureTerm(f2, h3);
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        p1 = new Predicates.RetractAllExceptOne_2(a1, a8, cont);
        p2 = new Predicates.IntTermToInt_2(a7, a8, p1);
        p3 = new Predicates.dollar_csMethod_3(s1, a6, a7, p2);
        return new Predicates.ListToObject_2(a1, a5, p3);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "resolve_conflict(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

