/*
 * *** Please do not edit ! ***
 * @(#) RetractAllExceptOne_2.cs
 * @procedure retract_all_except_one/2 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class RetractAllExceptOne_2 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public Term arg1, arg2;

    public RetractAllExceptOne_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public RetractAllExceptOne_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        return new Predicates.RetractAllExceptOne_3(a1, s1, a2, cont);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "retract_all_except_one(" + arg1 + ", " + arg2 + ")";
    }
}
}

