/*
 * *** Please do not edit ! ***
 * @(#) ThereAreSomeKeys_1.cs
 * @procedure there_are_some_keys/1 in dca2.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ThereAreSomeKeys_1 : Predicate, FcoPredicate {
    static internal readonly System.Type EntryCodeType = typeof( ThereAreSomeKeys_1 );
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate ThereAreSomeKeys_1_1 = new Predicates.ThereAreSomeKeys_1_1();
    static internal readonly Predicate ThereAreSomeKeys_1_2 = new Predicates.ThereAreSomeKeys_1_2();
    static internal readonly Predicate ThereAreSomeKeys_1_3 = new Predicates.ThereAreSomeKeys_1_3();
    static internal readonly Predicate ThereAreSomeKeys_1_lis = new Predicates.ThereAreSomeKeys_1_lis();
    static internal readonly Predicate ThereAreSomeKeys_1_var = new Predicates.ThereAreSomeKeys_1_var();

    public Term arg1;

    public ThereAreSomeKeys_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public ThereAreSomeKeys_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.SetEntryCode( EntryCodeType, this );
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   ThereAreSomeKeys_1_var,
                                   dollar_fail_0,
                                   ThereAreSomeKeys_1_1,
                                   dollar_fail_0,
                                   ThereAreSomeKeys_1_lis
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "there_are_some_keys(" + arg1 + ")";
    }
}

sealed class ThereAreSomeKeys_1_var : ThereAreSomeKeys_1 {
    static internal readonly Predicate ThereAreSomeKeys_1_var_1 = new Predicates.ThereAreSomeKeys_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(ThereAreSomeKeys_1_1, ThereAreSomeKeys_1_var_1);
    }
}

sealed class ThereAreSomeKeys_1_var_1 : ThereAreSomeKeys_1 {
    static internal readonly Predicate ThereAreSomeKeys_1_var_2 = new Predicates.ThereAreSomeKeys_1_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(ThereAreSomeKeys_1_2, ThereAreSomeKeys_1_var_2);
    }
}

sealed class ThereAreSomeKeys_1_var_2 : ThereAreSomeKeys_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(ThereAreSomeKeys_1_3);
    }
}

sealed class ThereAreSomeKeys_1_lis : ThereAreSomeKeys_1 {
    static internal readonly Predicate ThereAreSomeKeys_1_lis_1 = new Predicates.ThereAreSomeKeys_1_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(ThereAreSomeKeys_1_2, ThereAreSomeKeys_1_lis_1);
    }
}

sealed class ThereAreSomeKeys_1_lis_1 : ThereAreSomeKeys_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(ThereAreSomeKeys_1_3);
    }
}

sealed class ThereAreSomeKeys_1_1 : ThereAreSomeKeys_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_fail_0(cont);
    }
}

sealed class ThereAreSomeKeys_1_2 : ThereAreSomeKeys_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("key");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            if ( !s1.unify(((ListTerm)a1).car, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            if ( !a1.unify(new ListTerm(s1, engine.makeVariable()), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class ThereAreSomeKeys_1_3 : ThereAreSomeKeys_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("nonkey");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            if ( !s1.unify(((ListTerm)a1).car, engine.trail) )
                return engine.fail();
            a2 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(s1, a2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a2;
        engine.cont = cont;
        return engine.GetEntryCode( EntryCodeType ).call( engine );
    }
}
}

