/*
 * *** Please do not edit ! ***
 * @(#) DcaRetractOnServer_1.cs
 * @procedure dca_retract_on_server/1 in dca2.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates 
{

	using JJC.Psharp.Lang;
	using JJC.Psharp.Lang.Resource;
	using Predicates = JJC.Psharp.Predicates;
	using Resources = JJC.Psharp.Resources;

	public class IntTermToInt_2 : Predicate 
	{
		public Term arg1;
		public Term arg2;

		public IntTermToInt_2(Term a1, Term a2, Predicate cont) 
		{
			arg1 = a1; 
			arg2 = a2;
			this.cont = cont;
		}

		public IntTermToInt_2(){}
		public override void setArgument(Term[] args, Predicate cont) 
		{
			arg1 = args[0]; 
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) 
		{
			Term a1 = arg1.dereference( );
			Term a2 = arg2.dereference( );
			
			if( !a1.isCsObject( ) )
				return engine.fail( );

			CsObjectTerm cso = (CsObjectTerm)a1;
			int it = (int)( cso.Object( ) );
			if( !a2.unify( new IntegerTerm( it ), engine.trail ) )
				return engine.fail( );
			else
				return cont;
		}

		public override int arity() { return 2; }

		public override string ToString() 
		{
			return "int_term_to_int" + arg1 + ", " + arg2 + ")";
		}
	}
}