/*
 * *** Please do not edit ! ***
 * @(#) EchoInput_1.cs
 * @procedure echo_input/1 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class EchoInput_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate EchoInput_1_1 = new Predicates.EchoInput_1_1();
    static internal readonly Predicate EchoInput_1_2 = new Predicates.EchoInput_1_2();
    static internal readonly Predicate EchoInput_1_var = new Predicates.EchoInput_1_var();

    public Term arg1;

    public EchoInput_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public EchoInput_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   EchoInput_1_var,
                                   dollar_fail_0,
                                   EchoInput_1_1,
                                   dollar_fail_0,
                                   EchoInput_1_2
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "echo_input(" + arg1 + ")";
    }
}

sealed class EchoInput_1_var : EchoInput_1 {
    static internal readonly Predicate EchoInput_1_var_1 = new Predicates.EchoInput_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(EchoInput_1_1, EchoInput_1_var_1);
    }
}

sealed class EchoInput_1_var_1 : EchoInput_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(EchoInput_1_2);
    }
}

sealed class EchoInput_1_1 : EchoInput_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class EchoInput_1_2 : EchoInput_1 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.EchoInput_1(a3, cont);
        p2 = new Predicates.dollar_nl_0(p1);
        return new Predicates.Write_1(a2, p2);
    }
}
}

