/*
 * *** Please do not edit ! ***
 * @(#) IterateUpHierarchy_2.cs
 * @procedure iterate_up_hierarchy/2 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class IterateUpHierarchy_2 : Predicate {
    static internal readonly Predicate IterateUpHierarchy_2_1 = new Predicates.IterateUpHierarchy_2_1();
    static internal readonly Predicate IterateUpHierarchy_2_2 = new Predicates.IterateUpHierarchy_2_2();
    static internal readonly Predicate IterateUpHierarchy_2_sub_1 = new Predicates.IterateUpHierarchy_2_sub_1();

    public Term arg1, arg2;

    public IterateUpHierarchy_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public IterateUpHierarchy_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(IterateUpHierarchy_2_1, IterateUpHierarchy_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "iterate_up_hierarchy(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class IterateUpHierarchy_2_sub_1 : IterateUpHierarchy_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(IterateUpHierarchy_2_2);
    }
}

sealed class IterateUpHierarchy_2_1 : IterateUpHierarchy_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("derives", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("class", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h2 = {a5, a1};
        a4 = new StructureTerm(f1, h2);
        Term[] h4 = {a5};
        a6 = new StructureTerm(f3, h4);
        p1 = new Predicates.IterateUpHierarchy_2(a5, a2, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.NotReachedEnd_0(p2);
        p4 = new Predicates.Pulse_2(a2, a6, p3);
        p5 = new Predicates.dollar_call_1(a4, p4);
        return new Predicates.dollar_getLevel_1(a3, p5);
    }
}

sealed class IterateUpHierarchy_2_2 : IterateUpHierarchy_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.cont;
    }
}
}

