/*
 * *** Please do not edit ! ***
 * @(#) LoadNamespace_2.cs
 * @procedure load_namespace/2 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class LoadNamespace_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("_database");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("Loaded: ");

    public Term arg1, arg2;

    public LoadNamespace_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public LoadNamespace_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        p1 = new Predicates.Unlock_1(a2, cont);
        p2 = new Predicates.dollar_nl_0(p1);
        p3 = new Predicates.Write_1(a6, p2);
        p4 = new Predicates.Write_1(s2, p3);
        p5 = new Predicates.dollar_dummySearch__1_1(a6, p4);
        p6 = new Predicates.AtomChars_2(a6, a5, p5);
        p7 = new Predicates.Append_3(a3, a4, a5, p6);
        p8 = new Predicates.AtomChars_2(s1, a4, p7);
        p9 = new Predicates.AtomChars_2(a1, a3, p8);
        return new Predicates.Lock_1(a2, p9);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "load_namespace(" + arg1 + ", " + arg2 + ")";
    }
}
}

