/*
 * *** Please do not edit ! ***
 * @(#) OoSearchClassDefinesPrime_2.cs
 * @procedure oo_search_class_defines_prime/2 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearchClassDefinesPrime_2 : Predicate {
    static internal readonly Predicate OoSearchClassDefinesPrime_2_1 = new Predicates.OoSearchClassDefinesPrime_2_1();
    static internal readonly Predicate OoSearchClassDefinesPrime_2_2 = new Predicates.OoSearchClassDefinesPrime_2_2();
    static internal readonly Predicate OoSearchClassDefinesPrime_2_sub_1 = new Predicates.OoSearchClassDefinesPrime_2_sub_1();

    public Term arg1, arg2;

    public OoSearchClassDefinesPrime_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public OoSearchClassDefinesPrime_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(OoSearchClassDefinesPrime_2_1, OoSearchClassDefinesPrime_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "oo_search_class_defines_prime(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class OoSearchClassDefinesPrime_2_sub_1 : OoSearchClassDefinesPrime_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(OoSearchClassDefinesPrime_2_2);
    }
}

sealed class OoSearchClassDefinesPrime_2_1 : OoSearchClassDefinesPrime_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).car;
            if ( !s1.unify(((ListTerm)a2).cdr, engine.trail) )
                return engine.fail();
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a3, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_fail_0(cont);
        return new Predicates.ClassDefines_3(a1, a3, engine.makeVariable(), p1);
    }
}

sealed class OoSearchClassDefinesPrime_2_2 : OoSearchClassDefinesPrime_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.cont;
    }
}
}

