/*
 * *** Please do not edit ! ***
 * @(#) OoSearchClassDirectSubclasses_2.cs
 * @procedure oo_search_class_direct_subclasses/2 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearchClassDirectSubclasses_2 : Predicate {
    static internal readonly Predicate OoSearchClassDirectSubclasses_2_1 = new Predicates.OoSearchClassDirectSubclasses_2_1();
    static internal readonly Predicate OoSearchClassDirectSubclasses_2_2 = new Predicates.OoSearchClassDirectSubclasses_2_2();
    static internal readonly Predicate OoSearchClassDirectSubclasses_2_var = new Predicates.OoSearchClassDirectSubclasses_2_var();

    public Term arg1, arg2;

    public OoSearchClassDirectSubclasses_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public OoSearchClassDirectSubclasses_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   OoSearchClassDirectSubclasses_2_var,
                                   OoSearchClassDirectSubclasses_2_2,
                                   OoSearchClassDirectSubclasses_2_2,
                                   OoSearchClassDirectSubclasses_2_2,
                                   OoSearchClassDirectSubclasses_2_var
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "oo_search_class_direct_subclasses(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class OoSearchClassDirectSubclasses_2_var : OoSearchClassDirectSubclasses_2 {
    static internal readonly Predicate OoSearchClassDirectSubclasses_2_var_1 = new Predicates.OoSearchClassDirectSubclasses_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(OoSearchClassDirectSubclasses_2_1, OoSearchClassDirectSubclasses_2_var_1);
    }
}

sealed class OoSearchClassDirectSubclasses_2_var_1 : OoSearchClassDirectSubclasses_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(OoSearchClassDirectSubclasses_2_2);
    }
}

sealed class OoSearchClassDirectSubclasses_2_1 : OoSearchClassDirectSubclasses_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("class", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h3 = {a5};
        a6 = new StructureTerm(f2, h3);
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.ReachedEnd_0(p1);
        p3 = new Predicates.Pulse_2(a2, a6, p2);
        p4 = new Predicates.ClassSuperclass_2(a5, a3, p3);
        return new Predicates.dollar_getLevel_1(a4, p4);
    }
}

sealed class OoSearchClassDirectSubclasses_2_2 : OoSearchClassDirectSubclasses_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.cont;
    }
}
}

