/*
 * *** Please do not edit ! ***
 * @(#) OoSearchIterateClassesInner_6.cs
 * @procedure oo_search_iterate_classes_inner/6 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearchIterateClassesInner_6 : Predicate {
    static internal readonly Predicate OoSearchIterateClassesInner_6_1 = new Predicates.OoSearchIterateClassesInner_6_1();
    static internal readonly Predicate OoSearchIterateClassesInner_6_2 = new Predicates.OoSearchIterateClassesInner_6_2();
    static internal readonly Predicate OoSearchIterateClassesInner_6_sub_1 = new Predicates.OoSearchIterateClassesInner_6_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public OoSearchIterateClassesInner_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public OoSearchIterateClassesInner_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(OoSearchIterateClassesInner_6_1, OoSearchIterateClassesInner_6_sub_1);
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "oo_search_iterate_classes_inner(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class OoSearchIterateClassesInner_6_sub_1 : OoSearchIterateClassesInner_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(OoSearchIterateClassesInner_6_2);
    }
}

sealed class OoSearchIterateClassesInner_6_1 : OoSearchIterateClassesInner_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class OoSearchIterateClassesInner_6_2 : OoSearchIterateClassesInner_6 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a3.isList() ){
            a7 = ((ListTerm)a3).car;
            a8 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.OoSearchIterateClassesInner_6(a1, a2, a8, a4, a5, a6, cont);
        return new Predicates.OoSearch_6(a1, a7, a4, a2, a5, a6, p1);
    }
}
}

