/*
 * *** Please do not edit ! ***
 * @(#) OoSearchMethExactOrderedArgs_5.cs
 * @procedure oo_search_meth_exact_ordered_args/5 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearchMethExactOrderedArgs_5 : Predicate {
    static internal readonly Predicate OoSearchMethExactOrderedArgs_5_1 = new Predicates.OoSearchMethExactOrderedArgs_5_1();
    static internal readonly Predicate OoSearchMethExactOrderedArgs_5_2 = new Predicates.OoSearchMethExactOrderedArgs_5_2();
    static internal readonly Predicate OoSearchMethExactOrderedArgs_5_sub_1 = new Predicates.OoSearchMethExactOrderedArgs_5_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5;

    public OoSearchMethExactOrderedArgs_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public OoSearchMethExactOrderedArgs_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(OoSearchMethExactOrderedArgs_5_1, OoSearchMethExactOrderedArgs_5_sub_1);
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "oo_search_meth_exact_ordered_args(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class OoSearchMethExactOrderedArgs_5_sub_1 : OoSearchMethExactOrderedArgs_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(OoSearchMethExactOrderedArgs_5_2);
    }
}

sealed class OoSearchMethExactOrderedArgs_5_1 : OoSearchMethExactOrderedArgs_5 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a6, cont);
        p2 = new Predicates.ReachedEnd_0(p1);
        p3 = new Predicates.Pulse_2(a5, a7, p2);
        p4 = new Predicates.MethExactOrderedArgs_5(a1, a2, a3, a4, a7, p3);
        return new Predicates.dollar_getLevel_1(a6, p4);
    }
}

sealed class OoSearchMethExactOrderedArgs_5_2 : OoSearchMethExactOrderedArgs_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.cont;
    }
}
}

