/*
 * *** Please do not edit ! ***
 * @(#) OoSearchNamespacesInner_6.cs
 * @procedure oo_search_namespaces_inner/6 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearchNamespacesInner_6 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate OoSearchNamespacesInner_6_1 = new Predicates.OoSearchNamespacesInner_6_1();
    static internal readonly Predicate OoSearchNamespacesInner_6_2 = new Predicates.OoSearchNamespacesInner_6_2();
    static internal readonly Predicate OoSearchNamespacesInner_6_var = new Predicates.OoSearchNamespacesInner_6_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public OoSearchNamespacesInner_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public OoSearchNamespacesInner_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   OoSearchNamespacesInner_6_var,
                                   dollar_fail_0,
                                   OoSearchNamespacesInner_6_1,
                                   dollar_fail_0,
                                   OoSearchNamespacesInner_6_2
                                   );
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "oo_search_namespaces_inner(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class OoSearchNamespacesInner_6_var : OoSearchNamespacesInner_6 {
    static internal readonly Predicate OoSearchNamespacesInner_6_var_1 = new Predicates.OoSearchNamespacesInner_6_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(OoSearchNamespacesInner_6_1, OoSearchNamespacesInner_6_var_1);
    }
}

sealed class OoSearchNamespacesInner_6_var_1 : OoSearchNamespacesInner_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(OoSearchNamespacesInner_6_2);
    }
}

sealed class OoSearchNamespacesInner_6_1 : OoSearchNamespacesInner_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s2 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.Pulse_2(a6, s2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class OoSearchNamespacesInner_6_2 : OoSearchNamespacesInner_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("_database");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        p1 = new Predicates.dollar_dummySearch__5_6(a8, a2, a3, a4, a5, a6, cont);
        p2 = new Predicates.OoSearchIterateClasses_6(a7, a2, a3, a4, a5, a6, p1);
        p3 = new Predicates.dollar_loadAssembly_1(a12, p2);
        p4 = new Predicates.AtomChars_2(a12, a11, p3);
        p5 = new Predicates.Append_3(a9, a10, a11, p4);
        p6 = new Predicates.AtomChars_2(s1, a10, p5);
        p7 = new Predicates.AtomChars_2(a7, a9, p6);
        return new Predicates.dollar_dummySearch__4_0(p7);
    }
}
}

