/*
 * *** Please do not edit ! ***
 * @(#) OoSearchNamespacesLock_7.cs
 * @procedure oo_search_namespaces_lock/7 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearchNamespacesLock_7 : Predicate {

    public Term arg1, arg2, arg3, arg4, arg5, arg6, arg7;

    public OoSearchNamespacesLock_7(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Term a7, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        arg7 = a7; 
        this.cont = cont;
    }

    public OoSearchNamespacesLock_7(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        arg7 = args[6]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();
        a5 = arg5.dereference();
        a6 = arg6.dereference();
        a7 = arg7.dereference();

        p1 = new Predicates.Unlock_1(a7, cont);
        p2 = new Predicates.OoSearchNamespacesInner_6(a1, a2, a3, a4, a5, a6, p1);
        return new Predicates.Lock_1(a7, p2);
    }

    public override int arity() { return 7; }

    public override string ToString() {
        return "oo_search_namespaces_lock(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ", " + arg7 + ")";
    }
}
}

