/*
 * *** Please do not edit ! ***
 * @(#) PrimeNamespaces_2.cs
 * @procedure prime_namespaces/2 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class PrimeNamespaces_2 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate PrimeNamespaces_2_1 = new Predicates.PrimeNamespaces_2_1();
    static internal readonly Predicate PrimeNamespaces_2_2 = new Predicates.PrimeNamespaces_2_2();
    static internal readonly Predicate PrimeNamespaces_2_var = new Predicates.PrimeNamespaces_2_var();

    public Term arg1, arg2;

    public PrimeNamespaces_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public PrimeNamespaces_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   PrimeNamespaces_2_var,
                                   dollar_fail_0,
                                   PrimeNamespaces_2_1,
                                   dollar_fail_0,
                                   PrimeNamespaces_2_2
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "prime_namespaces(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class PrimeNamespaces_2_var : PrimeNamespaces_2 {
    static internal readonly Predicate PrimeNamespaces_2_var_1 = new Predicates.PrimeNamespaces_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(PrimeNamespaces_2_1, PrimeNamespaces_2_var_1);
    }
}

sealed class PrimeNamespaces_2_var_1 : PrimeNamespaces_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(PrimeNamespaces_2_2);
    }
}

sealed class PrimeNamespaces_2_1 : PrimeNamespaces_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class PrimeNamespaces_2_2 : PrimeNamespaces_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.PrimeNamespaces_2(a4, a2, cont);
        return new Predicates.dollar_dummySearch__2_2(a3, a2, p1);
    }
}
}

