using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using JJC.Psharp.Lang;
using JJC.Psharp.Predicates;
using System.Threading;
using System.Diagnostics;

namespace OO_Assistant {
	public class Form1 : System.Windows.Forms.Form {
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox comboBox2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textBox3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.RadioButton radioButton3;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.TextBox textBox4;
		private System.Windows.Forms.ComboBox comboBox3;

		private Term listOfNamespaces = null;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Panel panel3;
		private Term preload_lock = new VariableTerm( );

#if	JAVA
		public static string arg0 = null;
#endif

		public Form1() {
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
#if JAVA
			this.Text = "Object Oriented Assistant [Java]";
			this.label2.Text = "in package(s)";
			this.label7.Text = "Add package:";
#endif	
			textBox3.Enter += new System.EventHandler( this.EnterAction );
			this.Closed += new System.EventHandler( this.Close );
			button5.Enabled = false;
			statusBar1.Text = "Results so far: none";

			comboBox1.Sorted = true;

			string[] files = Directory.GetFiles( "." );
			Term list = SymbolTerm.makeSymbol( "[]", 0 );
			foreach( string file in files ) {
				if( file.EndsWith( "_database.dll" )
					&& !file.Equals( ".\\ClassHierarchy_database.dll" ) ) {
					string ns = file.Substring( 0, file.Length - 13 );
					ns = ns.Substring( 2 );
					list = new ListTerm( 
						SymbolTerm.makeSymbol( ns ),
						list );	
					comboBox3.Items.Add( ns );
				}
			}
			comboBox3.Sorted = true;

			listOfNamespaces = list;

			//ThreadStart ts = new ThreadStart( LoadAssemblies );
			//Thread t = new Thread( ts );
			//t.IsBackground = true;
			//t.Start( );
			
			sharp = new PrologInterface( 
				new PushbackReader( Console.In ), Console.Out, Console.Error, 
				true );
			sharp.addCallingAssembly( );
			Term loadThread = new VariableTerm( );
			sharp.setPredicate( new DoLoadAllNamespaces_3( listOfNamespaces, preload_lock, loadThread, new ReturnCs( sharp ) ) );
			sharp.call( );
			this.load_interface = (PrologInterface)( loadThread.toCsObject( ) );
		}

		public void LoadAssemblies( ) {
			PrologInterface sharp = new PrologInterface( 
				new PushbackReader( Console.In ), Console.Out, Console.Error, 
				true );
			sharp.addCallingAssembly( );
			sharp.setPredicate( new LoadNamespaces_2( listOfNamespaces, new VariableTerm( ), new ReturnCs( sharp ) ) );
			sharp.call( );
		}

		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.label1 = new System.Windows.Forms.Label();
			this.comboBox2 = new System.Windows.Forms.ComboBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.button3 = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.comboBox1 = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.label4 = new System.Windows.Forms.Label();
			this.textBox3 = new System.Windows.Forms.TextBox();
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.radioButton3 = new System.Windows.Forms.RadioButton();
			this.label6 = new System.Windows.Forms.Label();
			this.textBox4 = new System.Windows.Forms.TextBox();
			this.comboBox3 = new System.Windows.Forms.ComboBox();
			this.button5 = new System.Windows.Forms.Button();
			this.label7 = new System.Windows.Forms.Label();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.label5 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.panel1 = new System.Windows.Forms.Panel();
			this.panel2 = new System.Windows.Forms.Panel();
			this.panel3 = new System.Windows.Forms.Panel();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.groupBox1.SuspendLayout();
			this.panel1.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.SystemColors.Control;
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(16, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(32, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Find";
			this.label1.Click += new System.EventHandler(this.label1_Click);
			// 
			// comboBox2
			// 
			this.comboBox2.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.comboBox2.Items.AddRange(new object[] {
														   "Methods",
														   "Methods which take arguments (unordered subset)",
														   "Methods which take arguments (unordered)",
														   "Methods which take arguments (ordered)",
														   "Methods which return type",
														   "Fields",
														   "Fields of type",
														   "Classes",
														   "Classes which define member",
														   "Superclasses of",
														   "Direct subclasses of"});
			this.comboBox2.Location = new System.Drawing.Point(336, 32);
			this.comboBox2.MaxDropDownItems = 12;
			this.comboBox2.Name = "comboBox2";
			this.comboBox2.Size = new System.Drawing.Size(464, 21);
			this.comboBox2.TabIndex = 4;
			this.comboBox2.Text = "Methods";
			this.comboBox2.SelectedIndexChanged += new System.EventHandler(this.comboBox2_SelectedIndexChanged);
			// 
			// textBox1
			// 
			this.textBox1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.textBox1.Enabled = false;
			this.textBox1.Location = new System.Drawing.Point(16, 72);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(784, 20);
			this.textBox1.TabIndex = 5;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(256, 200);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(72, 24);
			this.button3.TabIndex = 10;
			this.button3.Text = "Search";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// label2
			// 
			this.label2.BackColor = System.Drawing.SystemColors.Control;
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(16, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(96, 23);
			this.label2.TabIndex = 9;
			this.label2.Text = "in namespace(s)";
			this.label2.Click += new System.EventHandler(this.label2_Click);
			// 
			// textBox2
			// 
			this.textBox2.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.textBox2.Location = new System.Drawing.Point(120, 16);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(328, 20);
			this.textBox2.TabIndex = 7;
			this.textBox2.Text = "";
			this.textBox2.TextChanged += new System.EventHandler(this.textBox2_TextChanged);
			// 
			// comboBox1
			// 
			this.comboBox1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.comboBox1.Location = new System.Drawing.Point(80, 240);
			this.comboBox1.MaxDropDownItems = 20;
			this.comboBox1.Name = "comboBox1";
			this.comboBox1.Size = new System.Drawing.Size(672, 21);
			this.comboBox1.TabIndex = 11;
			this.comboBox1.Text = "<Select the result whose documentation you wish to view>";
			// 
			// label3
			// 
			this.label3.BackColor = System.Drawing.SystemColors.Control;
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(16, 240);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(64, 23);
			this.label3.TabIndex = 12;
			this.label3.Text = "Results:";
			this.label3.Click += new System.EventHandler(this.label3_Click);
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button1.Location = new System.Drawing.Point(768, 240);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(32, 24);
			this.button1.TabIndex = 12;
			this.button1.Text = "Go";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(432, 200);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(80, 23);
			this.button2.TabIndex = 14;
			this.button2.Text = "Clear Results";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// label4
			// 
			this.label4.BackColor = System.Drawing.SystemColors.Control;
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(16, 200);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(80, 16);
			this.label4.TabIndex = 15;
			this.label4.Text = "with a limit of";
			// 
			// textBox3
			// 
			this.textBox3.Location = new System.Drawing.Point(104, 200);
			this.textBox3.MaxLength = 5;
			this.textBox3.Name = "textBox3";
			this.textBox3.Size = new System.Drawing.Size(64, 20);
			this.textBox3.TabIndex = 9;
			this.textBox3.Text = "50";
			// 
			// radioButton1
			// 
			this.radioButton1.BackColor = System.Drawing.SystemColors.Control;
			this.radioButton1.Location = new System.Drawing.Point(56, 32);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.Size = new System.Drawing.Size(56, 24);
			this.radioButton1.TabIndex = 1;
			this.radioButton1.Text = "static";
			this.radioButton1.CheckedChanged += new System.EventHandler(this.radioButton1_CheckedChanged);
			// 
			// radioButton2
			// 
			this.radioButton2.BackColor = System.Drawing.SystemColors.Control;
			this.radioButton2.Location = new System.Drawing.Point(112, 32);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.Size = new System.Drawing.Size(64, 24);
			this.radioButton2.TabIndex = 2;
			this.radioButton2.Text = "instance";
			this.radioButton2.CheckedChanged += new System.EventHandler(this.radioButton2_CheckedChanged);
			// 
			// radioButton3
			// 
			this.radioButton3.Checked = true;
			this.radioButton3.Location = new System.Drawing.Point(184, 32);
			this.radioButton3.Name = "radioButton3";
			this.radioButton3.Size = new System.Drawing.Size(144, 24);
			this.radioButton3.TabIndex = 3;
			this.radioButton3.TabStop = true;
			this.radioButton3.Text = "either static or instance";
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.Location = new System.Drawing.Point(16, 16);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(72, 16);
			this.label6.TabIndex = 21;
			this.label6.Text = "in class(es)";
			// 
			// textBox4
			// 
			this.textBox4.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.textBox4.Location = new System.Drawing.Point(88, 16);
			this.textBox4.Name = "textBox4";
			this.textBox4.Size = new System.Drawing.Size(248, 20);
			this.textBox4.TabIndex = 6;
			this.textBox4.Text = "";
			this.textBox4.TextChanged += new System.EventHandler(this.textBox4_TextChanged);
			// 
			// comboBox3
			// 
			this.comboBox3.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.comboBox3.Location = new System.Drawing.Point(176, 56);
			this.comboBox3.Name = "comboBox3";
			this.comboBox3.Size = new System.Drawing.Size(272, 21);
			this.comboBox3.TabIndex = 8;
			this.comboBox3.SelectedIndexChanged += new System.EventHandler(this.comboBox3_SelectedIndexChanged);
			// 
			// button5
			// 
			this.button5.Location = new System.Drawing.Point(344, 200);
			this.button5.Name = "button5";
			this.button5.TabIndex = 13;
			this.button5.Text = "Stop";
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(80, 56);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(96, 23);
			this.label7.TabIndex = 26;
			this.label7.Text = "Add namespace:";
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 264);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(816, 22);
			this.statusBar1.TabIndex = 27;
			this.statusBar1.Text = "statusBar1";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(176, 200);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(48, 23);
			this.label5.TabIndex = 28;
			this.label5.Text = "results.";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.textBox2,
																					this.label7,
																					this.comboBox3,
																					this.label2});
			this.groupBox1.Dock = System.Windows.Forms.DockStyle.Right;
			this.groupBox1.Location = new System.Drawing.Point(352, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(464, 96);
			this.groupBox1.TabIndex = 7;
			this.groupBox1.TabStop = false;
			this.groupBox1.Enter += new System.EventHandler(this.groupBox1_Enter);
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.panel2,
																				 this.splitter1,
																				 this.groupBox1});
			this.panel1.Location = new System.Drawing.Point(0, 96);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(816, 96);
			this.panel1.TabIndex = 29;
			// 
			// panel2
			// 
			this.panel2.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.panel3,
																				 this.label6,
																				 this.textBox4});
			this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(349, 96);
			this.panel2.TabIndex = 9;
			// 
			// panel3
			// 
			this.panel3.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.panel3.BackColor = System.Drawing.SystemColors.ControlText;
			this.panel3.Location = new System.Drawing.Point(348, 0);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(2, 96);
			this.panel3.TabIndex = 0;
			this.panel3.TabStop = true;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Right;
			this.splitter1.Location = new System.Drawing.Point(349, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(3, 96);
			this.splitter1.TabIndex = 8;
			this.splitter1.TabStop = false;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(816, 286);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.panel1,
																		  this.label5,
																		  this.statusBar1,
																		  this.button5,
																		  this.radioButton3,
																		  this.radioButton2,
																		  this.radioButton1,
																		  this.textBox3,
																		  this.label4,
																		  this.button2,
																		  this.button1,
																		  this.label3,
																		  this.comboBox1,
																		  this.button3,
																		  this.textBox1,
																		  this.comboBox2,
																		  this.label1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Object Oriented Assistant [C#]";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.groupBox1.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main( string[] args ) {
#if JAVA
			arg0 = args[ 0 ];
#endif
			Application.Run(new Form1());
		}

		private string TypeMunge( string sin ) {
#if JAVA
			return sin;
#else
			switch( sin ) {
				case "byte": return "System.Byte";
				case "char": return "System.Char";
				case "bool": return "System.Boolean";
				case "sbyte": return "System.Sbyte";
				case "short": return "System.Int16";
				case "ushort": return "System.Uint16";
				case "int": return "System.Int32";
				case "uint": return "System.Uint32";
				case "float": return "System.Single";
				case "double": return "System.Double";
				case "decimal": return "System.Decimal";
				case "long": return "System.Int64";
				case "ulong": return "System.Uint64";
				case "void": return "System.Void";
				case "object": return "System.Object";
				case "string": return "System.String";
				default: return sin;
			}
#endif
		}

		private PrologInterface sharp;
		private PrologInterface thread_interface;
		private Thread consumeThread;
		private PrologInterface load_interface;

		// search
		private void button3_Click(object sender, System.EventArgs e) {

			button3.Enabled = false; // disable search
			button2.Enabled = false; // disable clear
			button5.Enabled = true;  // enable stop

			// get maximum no. of solutions
			string maxSolns = textBox3.Text;
			int max = Int32.Parse( maxSolns );

			// get namespace list
			Term list = null;
			string namespaces = textBox2.Text.Trim( );
			string onlyOneNamespace = 
				( namespaces.IndexOf( ' ' ) == -1 ) ? namespaces : null;

			// get class list (if any)

			Term classlist = null;
			string classes = textBox4.Text.Trim( );

			string s = comboBox2.SelectedItem.ToString( );
			string s2 = null;
			switch( s ) {
				case "Methods":
				case "Methods which take arguments (unordered subset)": 
					s2 = "meth_args";
					break;
				case "Methods which take arguments (unordered)": 
					s2 = "meth_exact_args";
					break;
				case "Methods which take arguments (ordered)":
					s2 = "meth_exact_ordered_args";
					break;
				case "Methods which return type":
					s2 = "meth_return";
					break;
				case "Fields":
				case "Fields of type":
					s2 = "field_type";
					break;
				case "Classes":
				case "Classes which define member":
					s2 = "class_defines";
					break;
				case "Superclasses of":
					s2 = "class_superclass";
					namespaces = "ClassHierarchy";
					break;
				case "Direct subclasses of":					
					s2 = "class_direct_subclasses";
					namespaces = "ClassHierarchy";
					classes = "";
					break;
				case "All subclasses of":
					s2 = "class_all_subclasses";
					classes = "";
					break;
				default: 
					throw new Exception( );
			}
			SymbolTerm st = SymbolTerm.makeSymbol( s2 );
			SymbolTerm st2 = 
				textBox1.Enabled ? SymbolTerm.makeSymbol( textBox1.Text ) :
				SymbolTerm.makeSymbol( "" );

			// extract namespace list

			if( namespaces.Length == 0 ) {
				list = listOfNamespaces;
				Console.WriteLine( "using all!" );
			}
			else {
				list = SymbolTerm.makeSymbol( "[]", 0 );
				while( namespaces.Length > 0 ) {
					int pos = namespaces.IndexOf( ' ' );
					string next;
					if( pos == -1 ) {
						next = namespaces.Trim( );
						Console.WriteLine( "Next: " + next );
						namespaces = "";
					} else {
						next = namespaces.Substring( 0, pos ).Trim( );
						Console.WriteLine( "Next: " + next );
						namespaces = namespaces.Substring( pos + 1 ).Trim( );
					}
					list = new ListTerm ( SymbolTerm.makeSymbol( next ), list );
				}
			}
			
			// extract class list
			
			classlist = SymbolTerm.makeSymbol( "[]", 0 );
			while( classes.Length > 0 ) {
				int pos = classes.IndexOf( ' ' );
				string next;
				if( pos == -1 ) {
					next = classes.Trim( );
					if( onlyOneNamespace != null &&
						next.IndexOf( '.' ) == -1 )
						next = onlyOneNamespace + "." + next;
					classes = "";
				} else {
					next = classes.Substring( 0, pos ).Trim( );
					if( onlyOneNamespace != null &&
						next.IndexOf( '.' ) == -1 )
						next = onlyOneNamespace + "." + next;
					classes = classes.Substring( pos + 1 ).Trim( );
				}
				classlist = new ListTerm ( SymbolTerm.makeSymbol( next ), classlist );
			}


			// get argument list

			Term list2 = SymbolTerm.makeSymbol( "[]", 0 );
			string l = textBox1.Enabled ? textBox1.Text : "";
			while( l.Length > 0 ) {
				int pos = l.IndexOf( ' ' );
				if( pos == -1 ) {
					list2 = new ListTerm(
						SymbolTerm.makeSymbol( TypeMunge( l.Trim( ) ) ), list2 );
					l = "";
				} else {
					string next = l.Substring( 0, pos ).Trim( );
					list2 = new ListTerm( 
						SymbolTerm.makeSymbol( TypeMunge( next ) ), list2 );
					l = l.Substring( pos + 1 );
				}
			}

			// investigate static/instance/either

			string staticMode =
				radioButton1.Checked ? "static" :
				radioButton2.Checked ? "instance" :
				"either";

			Term staticModeTerm = SymbolTerm.makeSymbol( staticMode, 0 );
			
			// make a random VariableTerm (not used at present).

			Term vt = new VariableTerm( );
			Term thread = new VariableTerm( );
			
			// first make sure the queue is flushed
			// PrologInterface sharp2 = new PrologInterface( );
			// sharp2.setPredicate( new ZapQueue_1( getConcurrent( ), new ReturnCs( sharp2 ) ) );
			// sharp2.call( );

			PrologInterface sharp = new PrologInterface( 
				new PushbackReader( Console.In ), Console.Out, Console.Error, 
				true );
			sharp.addCallingAssembly( );
			sharp.setPredicate( new OoSearchNamespaces_9( list, st, classlist, staticModeTerm, list2, vt, new IntegerTerm( max ), preload_lock, thread, new ReturnCs( sharp ) ) );
			sharp.call( );
			
			this.thread_interface = (PrologInterface)( thread.toCsObject( ) );
			setConcurrent( (VariableTerm)vt );
			setMax( max );
			ThreadStart ts = new ThreadStart( ConsumeSolutions );
			consumeThread = new Thread( ts );
			consumeThread.IsBackground = true;
			consumeThread.Start( );
		}
	
		private VariableTerm concurrent = null;
		private VariableTerm getConcurrent( ) {
			lock( this )
				return concurrent;
		}

		private void setConcurrent( VariableTerm vt ) {
			lock( this )
				concurrent = vt;
		}

		private int max = 50;
		private int getMax( ) {
			lock( this )
				return max;
		}
		private void setMax( int maxin ) {
			lock( this )
				max = maxin;
		}

		private string GetDisplay( string sin ) {
			if( sin.StartsWith( "class_field" ) ) {
				int lbpos = sin.IndexOf( '(' );
				int cpos = sin.IndexOf( ',' );
				int rbpos = sin.LastIndexOf( ',' );
				string clazz = ( sin.Substring( lbpos + 1, cpos - lbpos - 1 ) );
				string fld = ( sin.Substring( cpos + 1, rbpos - cpos - 1 ) );
				bool isStatic = sin.Substring( rbpos + 1 ).StartsWith( "static" );
				return( ( isStatic ? "static field: " : "field: " )
					+ clazz + "." + fld );
			} else if( sin.StartsWith( "class_method" ) ) {
				int lastcomma = sin.LastIndexOf( "," );			
				int lbpos = sin.IndexOf( '(' );
				int cpos = sin.IndexOf( ',' );
				int rbpos = sin.IndexOf( ",[" );
				int lsq = sin.IndexOf( '[' );
				string clazz = ( sin.Substring( lbpos + 1, cpos - lbpos - 1 ) );
				string fld = ( sin.Substring( cpos + 1, rbpos - cpos - 1 ) );
				string args = sin.Substring( lsq + 1, lastcomma - lsq - 2 );
				int argslen = args.Length;
				bool isStatic = sin.Substring( lastcomma + 1 ).StartsWith( "static" );
				string args2 = "( " + args + " )";
				
				//string args = sin.Substring( lsq ).Replace( ")", "" ).Replace( '[', '(' ).Replace( ']', ')' );
				return( ( isStatic ? "static method: " : "method: " )
					+ clazz + "." + fld + args2 );
			} else if( sin.StartsWith( "class" ) ) { 
				int lbpos = sin.IndexOf( '(' );
				int rbpos = sin.IndexOf( ')' );
				string clazz = sin.Substring( lbpos + 1, rbpos - lbpos - 1 );
				return "class: " + clazz;
			}
			return "error";
		}

		private void ConsumeSolutions( ) {
			/************************************************************/
			/** DONT FORGET TO CALL THE UI THREAD PROPERLY EVENTUALLY ***/
			/************************************************************/
			VariableTerm c = getConcurrent( );
			int max = getMax( );
			int count = 0;
			statusBar1.Text = "Results so far: none";
			for( ; ; ) {
				//MessageBox.Show( "About to wait..." );
				Term c2 = (Term)( c.Receive( ).dereference( ) );
				if( c2.isStructure( ) ) {
					StructureTerm st = (StructureTerm)c2;
					//MessageBox.Show( "We got back a " + st );
					count++;
					statusBar1.Text = "Results so far: " + count;
					comboBox1.Items.Add( GetDisplay( st.ToString( ) ) );
					//if( count == max )
					//	break;
				} else {
					
					break;
				}
			}
			MessageBox.Show( "Finished generating solutions." );
			button3.Enabled = true;  // enable search
			button2.Enabled = true;  // enable clear
			button5.Enabled = false; // disable stop
		}

		private string Munge( string sin ) {
			// remove spaces and dots, convert all chars to lower case
			string sout = "";
			char[] ca = sin.ToLower( ).ToCharArray( );
			for( int i = 0; i < sin.Length; i++ ) {
				char ch = ca[ i ];
				if( ch != ' ' && ch != '.' )
					sout += ch.ToString( );
			}
			return sout;
		}
	
		// go!
		private void button1_Click(object sender, System.EventArgs e) {
			button1.Enabled = false;
			string url = null;
			string selection = null;

			if( comboBox1.SelectedItem == null ) {
				button1.Enabled = true;
				return;
			}
			else
				selection = comboBox1.SelectedItem.ToString( );
			//MessageBox.Show( selection );

#if JAVA
			if( selection.StartsWith( "method: " ) ) {
				// method: java.lang.Class.flibble( int,long,java.lang.String ) 
				// -> ...\java\lang\Class.html#flibble(int, long, java.lang.String).
				int lbpos = selection.IndexOf( '(' );
				int lastdotpos = selection.Substring( 0, lbpos ).LastIndexOf( '.' );
				int penultdotpos = selection.Substring( 0, lastdotpos - 1 ).LastIndexOf( '.' );
				string package = selection.Substring( 8, penultdotpos - 8 );
				string clazz = selection.Substring( penultdotpos + 1,
					lastdotpos - 1 - penultdotpos ).Replace( '$', '.' );
				string meth = selection.Substring( lastdotpos + 1 );
				string mungedMethod = meth.Replace( " ", "" ).Replace( ",", ", " );
				url = arg0 + "\\" + package.Replace( '.', '\\' ) +
					"\\" + clazz + ".html#" + mungedMethod + "";
			} else if( selection.StartsWith( "field: " ) ) {
				// field: java.lang.Class.flibble
				// -> ...\java\lang\Class.html#flibble
				int lastdotpos = selection.LastIndexOf( '.' );
				int penultdotpos = selection.Substring( 0, lastdotpos - 1 ).LastIndexOf( '.' );
				string package = selection.Substring( 7, penultdotpos - 7 );
				string clazz = selection.Substring( penultdotpos + 1,
					lastdotpos - 1 - penultdotpos ).Replace( '$', '.' );
				string fld = selection.Substring( lastdotpos + 1 );
				url = arg0 + "\\" + package.Replace( '.', '\\' ) +
					"\\" + clazz + ".html#" + fld + "";

			} else if( selection.StartsWith( "class: " ) ) {
				// class: java.lang.Class
				// -> ...\java\lang\Class.html
				int lastdotpos = selection.LastIndexOf( '.' );
				string package = selection.Substring( 7, lastdotpos - 7 );
				string clazz = selection.Substring( lastdotpos + 1 ).Replace( '$', '.' );
				url = arg0 + "\\" + package.Replace( '.', '\\' ) +
					"\\" + clazz + ".html";
				
			}

#else

			if( selection.StartsWith( "method: " )
				|| selection.StartsWith( "static method: " ) ) {
				int lbpos = selection.IndexOf( '(' );
				string str = selection.Substring( 0, lbpos );
				int lpos = str.IndexOf( ':' ) + 1;
				int mpos = str.LastIndexOf( '.' );
				string clazz = Munge( str.Substring( lpos + 1, mpos - lpos - 1 ) );
				string fld = Munge( str.Substring( mpos + 1 ) );
				if( fld.Equals( "constructor" ) )
					fld = "ctor";
				url = @"ms-help://MS.VSCC/MS.MSDNVS/cpref/html/frlrf" 
					+ clazz + "class" + fld + "topic.htm";
			} else if( selection.StartsWith( "field: " ) 
				|| selection.StartsWith( "static field: " ) ) {
				int lpos = selection.IndexOf( ':' ) + 1;
				int mpos = selection.LastIndexOf( '.' );
				string clazz = Munge( selection.Substring( lpos + 1, mpos - lpos - 1 ) );
				string fld = Munge( selection.Substring( mpos + 1 ) );
				url = @"ms-help://MS.VSCC/MS.MSDNVS/cpref/html/frlrf" 
					+ clazz + "class" + fld + "topic.htm";								
			} else if( selection.StartsWith( "class: " ) ) {
				int lpos = selection.IndexOf( ' ' );
				string clazz = Munge( selection.Substring( lpos + 1 ) );
				url = @"ms-help://MS.VSCC/MS.MSDNVS/cpref/html/frlrf" 
					+ clazz + "classtopic.htm";
			}

#endif

			Process p = new Process( );
			p.StartInfo.FileName = @"C:\Program Files\Internet Explorer\Iexplore.exe";
			p.StartInfo.Arguments = url;
			p.StartInfo.WindowStyle = ProcessWindowStyle.Maximized;
			p.Start( );
			button1.Enabled = true;
		}

		private void label2_Click(object sender, System.EventArgs e) {
		
		}

		private void label1_Click(object sender, System.EventArgs e) {
		
		}

		private void label3_Click(object sender, System.EventArgs e) {
		
		}

		// clear results
		private void button2_Click(object sender, System.EventArgs e) {
			statusBar1.Text = "Results so far: cleared";
			comboBox1.Text = "";
			comboBox1.Items.Clear( );
		}

		private void Form1_Load(object sender, System.EventArgs e) {
		}

		private void comboBox2_SelectedIndexChanged(object sender, System.EventArgs e) {
			// change the enabled states to match
			bool enable;
			string s = comboBox2.SelectedItem.ToString( );
			switch( s ) {
				case "Methods":
				case "Methods which take arguments (unordered subset)": 
				case "Methods which take arguments (unordered)": 
				case "Methods which take arguments (ordered)":
				case "Methods which return type":
				case "Fields":
				case "Fields of type":
				case "Classes":
				case "Classes which define member":
					enable = true;
					break;
				
				case "Superclasses of":
				case "Direct subclasses of":					
				case "All subclasses of":
					enable = false;
					break;
				default: 
					throw new Exception( );
			}
			label6.Enabled = label2.Enabled = label7.Enabled =
				textBox4.Enabled = textBox2.Enabled = comboBox3.Enabled = enable;

			switch( s ) {
				case "Methods":
				case "Methods which take arguments (unordered subset)": 
				case "Methods which take arguments (unordered)": 
				case "Methods which take arguments (ordered)":
				case "Methods which return type":
				case "Fields":
				case "Fields of type":
					enable = true;
					break;
				case "Classes":
				case "Classes which define member":
				case "Superclasses of":
				case "Direct subclasses of":					
				case "All subclasses of":
					enable = false;
					break;
				default: 
					throw new Exception( );
			}
		
			radioButton1.Enabled = radioButton2.Enabled = radioButton3.Enabled = enable;
		
			switch( s ) {
				case "Methods": 
				case "Fields":
				case "Classes":
					enable = false;
					break;
				default: 
					enable = true;
					break;
			}
		
			textBox1.Enabled = enable;
		}

		private void button4_Click(object sender, System.EventArgs e) {
		
		}

		private void comboBox3_SelectedIndexChanged(object sender, System.EventArgs e) {
			button4_Click_1( sender, e );
		}

		private void button4_Click_1(object sender, System.EventArgs e) {
			if( textBox2.Text.Equals( "" ) )
				textBox2.AppendText( comboBox3.Text );
			else
				textBox2.AppendText( " " + comboBox3.Text );
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e) {
		
		}

		private void EnterAction( object sender, System.EventArgs e ) {
			// button3_Click( sender, e );
		}

		private void textBox4_TextChanged(object sender, System.EventArgs e) {
		
		}

		private void textBox2_TextChanged(object sender, System.EventArgs e) {
		
		}

		private void radioButton1_CheckedChanged(object sender, System.EventArgs e) {
		
		}

		private void radioButton2_CheckedChanged(object sender, System.EventArgs e) {
		}

		public void Close( object sender, System.EventArgs e ) {
			if( load_interface != null ) {
				try { load_interface.stop( ); } catch { }
				load_interface = null;
			}
			button5_Click( null, null );

		}

		private void button5_Click(object sender, System.EventArgs e) {
			//PrologInterface sharp = new PrologInterface( );
			//sharp.setPredicate( new Unlock_1( preload_lock, new ReturnCs( sharp ) ) );
			//sharp.call( );

			if( thread_interface != null ) {
				//try { this.thread_interface.stop( ); } catch { }
				PrologInterface sharp2 = new PrologInterface(
					new PushbackReader( Console.In ), Console.Out, Console.Error, 
					true  );
				sharp2.setPredicate( new GlobalRetract_1( 
					SymbolTerm.makeSymbol( "keep_going" ), 
					new ZapQueue_1( getConcurrent( ), 
					new ReturnCs( sharp2 ) ) ) );
				sharp2.call( );
				getConcurrent( ).Send( new IntegerTerm( 0 ) );
			}
			//if( consumeThread != null )
			//	try { this.consumeThread.Abort( ); } catch { }
			thread_interface = null; // allow gc
			consumeThread = null; // allow gc

			button3.Enabled = true;  // enable search
			button2.Enabled = true;  // enable clear
			button5.Enabled = false; // disable stop

		}

		private void groupBox1_Enter(object sender, System.EventArgs e) {
		
		}
	}
}
