/*
 * *** Please do not edit ! ***
 * @(#) DesignPrime_3.cs
 * @procedure design_prime/3 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DesignPrime_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("node", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("pair", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("movetree");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("moveextent");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s6 = new IntegerTerm(0);

    public Term arg1, arg2, arg3;

    public DesignPrime_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public DesignPrime_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isStructure() ){
            if (f2 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a3.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a3.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isStructure() ){
            if (f1 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a6.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a6.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a8.isStructure() ){
            if (f2 != ((StructureTerm)a8).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a8).args;
            if ( !a4.unify(args[0],  engine.trail) )
                return engine.fail();
            a10 = args[1];
        } else if (a8.isVariable() ){
            a10 = engine.makeVariable();
            Term[] args = {a4, a10};
            if ( !a8.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.isList() ){
            a11 = ((ListTerm)a7).car;
            a12 = ((ListTerm)a7).cdr;
        } else if ( a7.isVariable() ){
            a11 = engine.makeVariable();
            a12 = engine.makeVariable();
            if ( !a7.unify(new ListTerm(a11, a12), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        a18 = engine.makeVariable();
        a21 = new ListTerm(a11, s5);
        a20 = new ListTerm(a4, a21);
        a19 = new ListTerm(a2, a20);
        p1 = new Predicates.RealInt_2(s6, a10, cont);
        p2 = new Predicates.dollar_call_1(a18, p1);
        p3 = new Predicates.eq_stop_stop_2(a18, a19, p2);
        p4 = new Predicates.Mergelist_2(a17, a12, p3);
        p5 = new Predicates.ListpairMap_4(s4, a15, a16, a17, p4);
        p6 = new Predicates.ListpairMap_4(s3, a14, a16, a9, p5);
        p7 = new Predicates.Fitlist_2(a15, a16, p6);
        p8 = new Predicates.ListpairUnzip_3(a13, a14, a15, p7);
        return new Predicates.MapDesignPrime_3(a2, a5, a13, p8);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "design_prime(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

