/*
 * *** Please do not edit ! ***
 * @(#) DoApp_4.cs
 * @procedure do_app/4 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DoApp_4 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate DoApp_4_1 = new Predicates.DoApp_4_1();
    static internal readonly Predicate DoApp_4_2 = new Predicates.DoApp_4_2();
    static internal readonly Predicate DoApp_4_var = new Predicates.DoApp_4_var();

    public Term arg1, arg2, arg3, arg4;

    public DoApp_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public DoApp_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   DoApp_4_var,
                                   dollar_fail_0,
                                   DoApp_4_1,
                                   dollar_fail_0,
                                   DoApp_4_2
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "do_app(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class DoApp_4_var : DoApp_4 {
    static internal readonly Predicate DoApp_4_var_1 = new Predicates.DoApp_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(DoApp_4_1, DoApp_4_var_1);
    }
}

sealed class DoApp_4_var_1 : DoApp_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(DoApp_4_2);
    }
}

sealed class DoApp_4_1 : DoApp_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class DoApp_4_2 : DoApp_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(10);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            a6 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.DoApp_4(a6, a2, a3, a4, cont);
        p2 = new Predicates.Drawline_4(a8, a3, a8, a4, p1);
        p3 = new Predicates.dollar_plus_3(a3, a9, a4, p2);
        p4 = new Predicates.dollar_unify_2(a9, s1, p3);
        p5 = new Predicates.RealSum_3(a2, a7, a8, p4);
        return new Predicates.Pickx_2(a5, a7, p5);
    }
}
}

