/*
 * *** Please do not edit ! ***
 * @(#) Eldestx_2.cs
 * @procedure eldestx/2 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Eldestx_2 : Predicate {

    public Term arg1, arg2;

    public Eldestx_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Eldestx_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, engine.makeVariable()), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.Pickx_2(a3, a2, cont);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "eldestx(" + arg1 + ", " + arg2 + ")";
    }
}
}

