/*
 * *** Please do not edit ! ***
 * @(#) Extentf_2.cs
 * @procedure extentf/2 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Extentf_2 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("extent", 3);
    static internal readonly IntegerTerm s2 = new IntegerTerm(20);

    public Term arg1, arg2;

    public Extentf_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Extentf_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
            a4 = args[1];
            if ( !s2.unify(args[2],  engine.trail) )
                return engine.fail();
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4, s2};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.RealNeg_2(a4, a3, cont);
        return new Predicates.GetHalfWidth_2(a1, a4, p1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "extentf(" + arg1 + ", " + arg2 + ")";
    }
}
}

