/*
 * *** Please do not edit ! ***
 * @(#) GenerateFromRoot_3.cs
 * @procedure generate_from_root/3 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GenerateFromRoot_3 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public Term arg1, arg2, arg3;

    public GenerateFromRoot_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public GenerateFromRoot_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        return new Predicates.GenerateFromRoot_4(a1, a2, a3, s1, cont);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "generate_from_root(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

