/*
 * *** Please do not edit ! ***
 * @(#) GenerateTree_4.cs
 * @procedure generate_tree/4 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GenerateTree_4 : Predicate {
    static internal readonly Predicate GenerateTree_4_1 = new Predicates.GenerateTree_4_1();
    static internal readonly Predicate GenerateTree_4_2 = new Predicates.GenerateTree_4_2();
    static internal readonly Predicate GenerateTree_4_sub_1 = new Predicates.GenerateTree_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public GenerateTree_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public GenerateTree_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(GenerateTree_4_1, GenerateTree_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "generate_tree(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class GenerateTree_4_sub_1 : GenerateTree_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(GenerateTree_4_2);
    }
}

sealed class GenerateTree_4_1 : GenerateTree_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("keep_going");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("ClassHierarchy_database");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("form1", 1);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("lock");
    static internal readonly IntegerTerm s6 = new IntegerTerm(10);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        Term[] h4 = {a2};
        a5 = new StructureTerm(f3, h4);
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.Unlock_1(s5, cont);
        p2 = new Predicates.DrawTree_2(a1, a9, p1);
        p3 = new Predicates.dollar_unify_2(a9, a6, p2);
        p4 = new Predicates.GenerateFromRoot_3(a1, a8, a7, p3);
        p5 = new Predicates.GlobalCall_1(s1, p4);
        p6 = new Predicates.dollar_dummyMltoprolog__2_3(a3, a6, a8, p5);
        p7 = new Predicates.GetRoot_5(a1, s6, engine.makeVariable(), a6, a7, p6);
        p8 = new Predicates.Lock_1(s5, p7);
        p9 = new Predicates.Assert_1(a5, p8);
        p10 = new Predicates.dollar_loadAssembly_1(s2, p9);
        return new Predicates.GlobalAssert_1(s1, p10);
    }
}

sealed class GenerateTree_4_2 : GenerateTree_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("lock");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        p1 = new Predicates.dollar_abort_0(cont);
        p2 = new Predicates.Unlock_1(s1, p1);
        return new Predicates.dollar_dummyMltoprolog__3_0(p2);
    }
}
}

