/*
 * *** Please do not edit ! ***
 * @(#) GetDropAbove_1.cs
 * @procedure get_drop_above/1 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GetDropAbove_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("get_drop_above");

    public Term arg1;

    public GetDropAbove_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public GetDropAbove_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        Predicate p1;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_csMethod_3(a2, s1, a1, cont);
        return new Predicates.Form1_1(a2, p1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "get_drop_above(" + arg1 + ")";
    }
}
}

