/*
 * *** Please do not edit ! ***
 * @(#) GetRootInner_6.cs
 * @procedure get_root_inner/6 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GetRootInner_6 : Predicate {
    static internal readonly Predicate GetRootInner_6_1 = new Predicates.GetRootInner_6_1();
    static internal readonly Predicate GetRootInner_6_2 = new Predicates.GetRootInner_6_2();
    static internal readonly Predicate GetRootInner_6_3 = new Predicates.GetRootInner_6_3();
    static internal readonly Predicate GetRootInner_6_4 = new Predicates.GetRootInner_6_4();
    static internal readonly Predicate GetRootInner_6_sub_1 = new Predicates.GetRootInner_6_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public GetRootInner_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public GetRootInner_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(GetRootInner_6_1, GetRootInner_6_sub_1);
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "get_root_inner(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class GetRootInner_6_sub_1 : GetRootInner_6 {
    static internal readonly Predicate GetRootInner_6_sub_2 = new Predicates.GetRootInner_6_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(GetRootInner_6_2, GetRootInner_6_sub_2);
    }
}

sealed class GetRootInner_6_sub_2 : GetRootInner_6 {
    static internal readonly Predicate GetRootInner_6_sub_3 = new Predicates.GetRootInner_6_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(GetRootInner_6_3, GetRootInner_6_sub_3);
    }
}

sealed class GetRootInner_6_sub_3 : GetRootInner_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(GetRootInner_6_4);
    }
}

sealed class GetRootInner_6_1 : GetRootInner_6 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !a1.unify(a3, engine.trail) ) return engine.fail();
        if ( !a2.unify(a4, engine.trail) ) return engine.fail();
        if ( !a5.unify(a6, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class GetRootInner_6_2 : GetRootInner_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("keep_going");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("derives", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("node", 2);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        a7 = engine.makeVariable();
        a9 = engine.makeVariable();
        Term[] h3 = {a9, a1};
        a8 = new StructureTerm(f2, h3);
        a10 = engine.makeVariable();
        a12 = new ListTerm(a6, s6);
        Term[] h7 = {a9, a12};
        a11 = new StructureTerm(f5, h7);
        p1 = new Predicates.GetRootInner_6(a9, a2, a3, a10, a5, a11, cont);
        p2 = new Predicates.dollar_plus_3(a4, s4, a10, p1);
        p3 = new Predicates.dollar_cut_1(a7, p2);
        p4 = new Predicates.dollar_call_1(a8, p3);
        p5 = new Predicates.GlobalCall_1(s1, p4);
        return new Predicates.dollar_getLevel_1(a7, p5);
    }
}

sealed class GetRootInner_6_3 : GetRootInner_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("lock");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        p1 = new Predicates.dollar_abort_0(cont);
        p2 = new Predicates.Unlock_1(s1, p1);
        return new Predicates.dollar_dummyMltoprolog__0_0(p2);
    }
}

sealed class GetRootInner_6_4 : GetRootInner_6 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !a1.unify(a3, engine.trail) ) return engine.fail();
        if ( !a5.unify(a6, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}
}

