/*
 * *** Please do not edit ! ***
 * @(#) ListpairUnzip_3.cs
 * @procedure listpair_unzip/3 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ListpairUnzip_3 : Predicate, FcoPredicate {
    static internal readonly System.Type EntryCodeType = typeof( ListpairUnzip_3 );
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate ListpairUnzip_3_1 = new Predicates.ListpairUnzip_3_1();
    static internal readonly Predicate ListpairUnzip_3_2 = new Predicates.ListpairUnzip_3_2();
    static internal readonly Predicate ListpairUnzip_3_var = new Predicates.ListpairUnzip_3_var();

    public Term arg1, arg2, arg3;

    public ListpairUnzip_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public ListpairUnzip_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.SetEntryCode( EntryCodeType, this );
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   ListpairUnzip_3_var,
                                   dollar_fail_0,
                                   ListpairUnzip_3_1,
                                   dollar_fail_0,
                                   ListpairUnzip_3_2
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "listpair_unzip(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class ListpairUnzip_3_var : ListpairUnzip_3 {
    static internal readonly Predicate ListpairUnzip_3_var_1 = new Predicates.ListpairUnzip_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(ListpairUnzip_3_1, ListpairUnzip_3_var_1);
    }
}

sealed class ListpairUnzip_3_var_1 : ListpairUnzip_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(ListpairUnzip_3_2);
    }
}

sealed class ListpairUnzip_3_1 : ListpairUnzip_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class ListpairUnzip_3_2 : ListpairUnzip_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("pair", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a4.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            if ( !a6.unify(((ListTerm)a2).car, engine.trail) )
                return engine.fail();
            a8 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a8 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a6, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            if ( !a7.unify(((ListTerm)a3).car, engine.trail) )
                return engine.fail();
            a9 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a9 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a7, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a5;
        engine.aregs[2] = a8;
        engine.aregs[3] = a9;
        engine.cont = cont;
        return engine.GetEntryCode( EntryCodeType ).call( engine );
    }
}
}

