/*
 * *** Please do not edit ! ***
 * @(#) LoadAndPrimeThread_1.cs
 * @procedure load_and_prime_thread/1 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class LoadAndPrimeThread_1 : Predicate {
    static internal readonly Predicate LoadAndPrimeThread_1_1 = new Predicates.LoadAndPrimeThread_1_1();
    static internal readonly Predicate LoadAndPrimeThread_1_2 = new Predicates.LoadAndPrimeThread_1_2();
    static internal readonly Predicate LoadAndPrimeThread_1_sub_1 = new Predicates.LoadAndPrimeThread_1_sub_1();

    public Term arg1;

    public LoadAndPrimeThread_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public LoadAndPrimeThread_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(LoadAndPrimeThread_1_1, LoadAndPrimeThread_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "load_and_prime_thread(" + arg1 + ")";
    }
}

sealed class LoadAndPrimeThread_1_sub_1 : LoadAndPrimeThread_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(LoadAndPrimeThread_1_2);
    }
}

sealed class LoadAndPrimeThread_1_1 : LoadAndPrimeThread_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("ClassHierarchy_database");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("lock");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("derives", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        Term[] h4 = {engine.makeVariable(), engine.makeVariable()};
        a2 = new StructureTerm(f3, h4);
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.Lock_1(s2, p1);
        p3 = new Predicates.Unlock_1(s2, p2);
        p4 = new Predicates.dollar_call_1(a2, p3);
        p5 = new Predicates.Lock_1(s2, p4);
        return new Predicates.dollar_loadAssembly_1(s1, p5);
    }
}

sealed class LoadAndPrimeThread_1_2 : LoadAndPrimeThread_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("lock");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        return new Predicates.Unlock_1(s1, cont);
    }
}
}

