/*
 * *** Please do not edit ! ***
 * @(#) Pickx_2.cs
 * @procedure pickx/2 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Pickx_2 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("node", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("pair", 2);

    public Term arg1, arg2;

    public Pickx_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Pickx_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3, engine.makeVariable()};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isStructure() ){
            if (f2 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a4 = args[1];
        } else if (a3.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {engine.makeVariable(), a4};
            if ( !a3.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !a4.unify(a2, engine.trail) ) return engine.fail();
        return cont;
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "pickx(" + arg1 + ", " + arg2 + ")";
    }
}
}

