/*
 * *** Please do not edit ! ***
 * @(#) Youngestx_2.cs
 * @procedure youngestx/2 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Youngestx_2 : Predicate {

    public Term arg1, arg2;

    public Youngestx_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Youngestx_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a4 = engine.makeVariable();
        a3 = new ListTerm(a4, engine.makeVariable());
        p1 = new Predicates.Pickx_2(a4, a2, cont);
        return new Predicates.Reverse_2(a1, a3, p1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "youngestx(" + arg1 + ", " + arg2 + ")";
    }
}
}

