using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using JJC.Psharp.Lang;
using JJC.Psharp.Predicates;

namespace View_Hierarchy {

	public class Form1 : System.Windows.Forms.Form {
		private System.ComponentModel.Container components = null;
		
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private DrawPanel drawPanel = new DrawPanel( );

		private VariableTerm lockTerm = new VariableTerm( );

		private ArrayList lines = new ArrayList( );
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.StatusBar statusBar1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.MenuItem menuItem3;
		private ArrayList labels = new ArrayList( );

		public double get_half_width( string s ) {
			Font f = new Font( FontFamily.GenericMonospace, 8 );
			double width = ( f.Size  ) * s.Length + 10;
			return width / 2;
		}

		public void end_invokes( ) {
		}

		public void draw_line( int a, int b, int c, int d ) {
			lines.Add( new LineSeg( a, b + 10, c, d + 10 ) );
		}

		public double[] draw_label( string s, double x, int y ) {
			labels.Add( new TLabel( s, (int)x, y + 10 ) );
			return new double[] { -20, 20, 10 };
		}

		public double real_sum( double x, double y ) { return x + y; }	
		public double real_diff( double x, double y ) { return x - y; }
		public double real_neg( double x ) { return -x;	}
		public double real_int( int x ) { return (double)x;	}
		public double real_div( double x, double y ) { return x/y; }
		public double real_max( double x, double y ) { return x > y ? x : y; }
		public double real_min( double x, double y ) { return x > y ? y : x; }
		public int real_floor( double x ) {	return (int)Math.Floor( x ); }
		public int real_ceil( double x ) { return (int)Math.Ceiling( x ); }
		public int get_drop_above( ) { return 10; }
		public int get_drop_below( ) { return 10; }

		private PrologInterface primeThread = null;

		public Form1() {
			InitializeComponent();
		
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] 
				{ this.drawPanel });
			this.drawPanel.Dock = System.Windows.Forms.DockStyle.Fill;
			drawPanel.AutoScroll = true;
			drawPanel.SetForm1( this );

			this.statusBar1.Text = "";

			VariableTerm v = new VariableTerm( );	
			PrologInterface sharp = new PrologInterface( true );
			sharp.addCallingAssembly( );
			sharp.setPredicate( new LoadAndPrime_1( 
				this.lockTerm, new ReturnCs( sharp ) ) );
			sharp.call( );
			// primeThread = (PrologInterface)( v.toCsObject( ) );
		}

		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.panel1 = new System.Windows.Forms.Panel();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem4});
			this.menuItem1.Text = "Menu";
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "Centre on class";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "Exit";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// statusBar1
			// 
			this.statusBar1.Location = new System.Drawing.Point(0, 320);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Size = new System.Drawing.Size(584, 22);
			this.statusBar1.TabIndex = 0;
			this.statusBar1.Text = "statusBar1";
			// 
			// panel1
			// 
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(584, 320);
			this.panel1.TabIndex = 1;
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "Stop design";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click_1);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.ControlDark;
			this.ClientSize = new System.Drawing.Size(584, 342);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.panel1,
																		  this.statusBar1});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Class Hierarchy Viewer";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() {
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e) {
		}

		private int currentDepth = 2;
		private PrologInterface currentDraw = null;

		private string centreClass = null;
		private int depth = 0;
		
		private System.Threading.Thread currentDesignDrawThread = null;
		private bool stopped = false;

		public void DrawTree( string centreClass, int depth ) {
			this.centreClass = centreClass;
			this.depth = depth;
			System.Threading.Thread t = 
				new System.Threading.Thread( 
				new System.Threading.ThreadStart( DoDrawTree ) );
			t.IsBackground = true;
			this.currentDesignDrawThread = t;
			t.Start( );

		}

		public void DoDrawTree( ) {
			int depthToUse;
			if( depth == -1 )
				depthToUse = currentDepth;
			else {
				depthToUse = depth;
				currentDepth = depth;
			}
			PrologInterface sharp = new PrologInterface( true );
			sharp.setPredicate( new GenerateTree_4(
				SymbolTerm.makeSymbol( centreClass ), 
				new CsObjectTerm( this ), 
				new IntegerTerm( depth ),
				this.lockTerm,
				new ReturnCs( sharp ) ) );
			sharp.addCallingAssembly( );
			drawPanel.SetCentre( centreClass );
			lines.Clear( );
			labels.Clear( );
			this.currentDraw = sharp;
			stopped = false;
			this.statusBar1.Text = "Designing tree...";
			sharp.call( );
			if( stopped ) {
				stopped = false;
				this.statusBar1.Text = "Stopped.";
			}
			else {
				this.statusBar1.Text = "Drawing tree...";
				this.currentDraw = null;
				// now draw it all.
				System.IAsyncResult iar = drawPanel.BeginInvoke( new
					System.Threading.ThreadStart( DoActualDraw ) );
				drawPanel.EndInvoke( iar );
				this.statusBar1.Text = "";
			}
		}

		public void DoActualDraw( ) {
			drawPanel.Controls.Clear( );
			foreach( TLabel label in labels ) 
				drawPanel.draw_label( label.s, label.x, label.y );
			foreach( LineSeg line in lines ) 
				drawPanel.draw_line( line.x1, line.y1, line.x2, line.y2 );
			drawPanel.Centre( );
		}

		private void menuItem2_Click(object sender, System.EventArgs e) {
			Form2 form2 = new Form2( );
			form2.SetForm1( this );
			form2.Show( );
		}

		/*
		private void menuItem3_Click(object sender, System.EventArgs e) {
			//stopped = true;
			//this.statusBar1.Text = "Stopped";
			
			//if( currentDesignDrawThread != null ) {
				if( currentDraw != null )
					this.currentDraw.stop( );
			//	this.currentDesignDrawThread.Abort( );
				// currentDraw.stop( );
				this.statusBar1.Text = "Stopped";
				currentDraw = null;
			//}
			

		}
		*/

		private void menuItem4_Click(object sender, System.EventArgs e) {
			Application.Exit( );
		}

		private void menuItem3_Click_1(object sender, System.EventArgs e) {
			stopped = true;
			PrologInterface sharp = new PrologInterface( true );
			sharp.setPredicate( new GlobalRetract_1( 
				SymbolTerm.makeSymbol( "keep_going" ), new ReturnCs( sharp ) ) );
			sharp.call( );
			this.statusBar1.Text = "Stopping...";
		}
	}

	struct LineSeg {
		public int x1, y1, x2, y2;

		public LineSeg( int x1, int y1, int x2, int y2 ) {
			this.x1 = x1;
			this.y1 = y1;
			this.x2 = x2;
			this.y2 = y2;
		}
	}

	struct TLabel {
		public int x, y;
		public string s;

		public TLabel( string s, int x, int y ) {
			this.s = s;
			this.x = x;
			this.y = y;
		}
	}

	class DrawPanel : System.Windows.Forms.Panel {
		ArrayList lines = new ArrayList( );
		ArrayList labels = new ArrayList( );
		string centre = null;
		Button centreButton = null;
		Form1 form1 = null;

		public void SetForm1( Form1 f ) {
			this.form1 = f;
		}

		public void SetCentre( string s ) {
			this.centre = s;
		}

		public void Centre( ) {
			if( centreButton != null )
				this.AutoScrollPosition = new System.Drawing.Point(
					( centreButton.Left + centreButton.Right ) / 2 -
					( this.Right - this.Left ) / 2, 0 );
		}

		public void clear_all( ) {
			lines = new ArrayList( );
			labels = new ArrayList( );
		}

		public void draw_line( int x1, int y1, int x2, int y2 ) {
			// only draws horizontal and vertical lines.
			Panel p = null;
			if( x1 == x2 ) {
				p = new Panel( );
				p.Location = new Point( x1, y1 );
				p.Size = new Size( 1, y2 - y1 );
			} else if ( y1 == y2 ) {
				p = new Panel( );
				p.Location = new Point( x1, y1 );
				p.Size = new Size( x2 - x1, 1 );
			} else
				throw new Exception( "Can only draw horizontal and vertical lines" );
			p.BackColor = Color.Black;
			this.Controls.Add( p );
		}

		public void draw_label( string s, int x, int y ) {
			Font f = new Font( FontFamily.GenericMonospace, 8 );
			int width = (int)( f.Size ) * s.Length;
			Button button = new Button( );
			button.Width = width;
			button.Location = new System.Drawing.Point( x - width / 2, y );
			button.Text = s;
			button.Font = f;
			button.BackColor = System.Drawing.Color.Wheat;
			this.Controls.Add( button );
			button.Click += new EventHandler( this.Jump );
			if( s.Equals( centre ) ) {
				this.centreButton = button;
			}
		}

		public void Jump( object sender, System.EventArgs e ) {
			if( !( sender is Button ) )
				return;
			Button b = (Button)sender;
			form1.DrawTree( b.Text, -1 );
		}

		/*
			protected override void OnPaint( PaintEventArgs e ) {
				Graphics g = e.Graphics;
				System.Drawing.Pen p = new System.Drawing.Pen(
					System.Drawing.Color.DarkBlue ); 
				p.Width = 1;
				foreach( LineSeg l in lines ) {
					g.DrawLine( p, l.x1, l.y1, l.x2, l.y2 );
				}
			
				Font f = new Font( FontFamily.GenericSerif, 10 );
				Brush b = Brushes.Black;
			
				foreach( TLabel tl in labels ) {
					//g.DrawString( tl.s, f, b, tl.x, tl.y );
					Button button = new Button( );
					button.Location = new System.Drawing.Point( tl.x, tl.y );
					button.Text = tl.s;
					button.Font = f;
				}
			
			}	
			*/		
	}

}
