using System;
using System.Reflection;
using System.IO;

namespace Generate_Namespace_Database {
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class GenDb {
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args) {
			foreach( string s in args ) {
				Console.WriteLine( s );
				Assembly a = Assembly.LoadWithPartialName( s );
				if( a == null )
					a = Assembly.Load( s );
				if( a == null )
					Console.Out.WriteLine( s + " does not seem to exist as an Assembly." );
				else {
					//Console.WriteLine( a );
					Type[] ts = a.GetExportedTypes( );
					foreach( Type t in ts ) {
						string clause = null;
						string filename = null;
						string ns = t.Namespace;						

						Type baseType = t.BaseType;
						if( baseType != null ) {
							// filename = ns.Replace( '.', '-' ) + ".pl";
							filename = ns + "_database.pl";
							StreamWriter sw = File.AppendText( @".\" + filename );
							sw.WriteLine( "derives( '" + 
								baseType.ToString( ) + 
								"', '" + t.ToString( ) + "' )." );
							sw.Close( );

							filename = "ClassHierarchy_database.pl";
							StreamWriter sw2 = File.AppendText( @".\" + filename );
							sw2.WriteLine( "derives( '" + 
								baseType.ToString( ) + 
								"', '" + t.ToString( ) + "' )." );
							sw2.Close( );
						}

						MemberInfo[] mi = t.GetMembers( );
						ParameterInfo[] pi = null;
						string sig = null;
						foreach( MemberInfo m in mi ) {
							//filename = ns.Replace( '.', '-' ) + ".pl";
							filename = ns + "_database.pl";
							// now attempt to open the relevant file to append to it...
							StreamWriter fs = File.AppendText( @".\" + filename );
							//BufferedStream bs = new BufferedStream( fs );
							if( t.IsClass ) 
								clause = "classmember( ";
							else if( t.IsInterface )
								clause = "interfacemember( ";
							else
								clause = "structmember( ";
							
							clause += "'" + ns + "', '" + t.ToString( ) + "', ";							

							bool shouldAdd = false;
							switch( m.MemberType ) {
								case MemberTypes.Constructor:
									clause += "constructor, method, ";
									ConstructorInfo ci = (ConstructorInfo)m;
									pi = ci.GetParameters( );
									sig = "constructor( void";
									if( pi.Length == 0 )
										sig += " )";
									else {
										sig += ", ";
										for( int i = 0; i < pi.Length; i++ ) {
											sig += "'" + pi[ i ].ParameterType.ToString( ) + "'"; 
											if( i == pi.Length - 1 )
												sig += " )";
											else
												sig += ", ";
										}
									}
									//Console.Out.WriteLine( sig );
									shouldAdd = true;
									break;
								case MemberTypes.Custom:
									break;
								case MemberTypes.Event:
									clause += "instance, event, ";
									EventInfo eventi = (EventInfo)m;
									sig = m.Name;
									break;
								case MemberTypes.Field:
									FieldInfo fieldi = (FieldInfo)m;
									if( fieldi.DeclaringType.IsEnum ) {
										if( fieldi.IsStatic ) 
											clause += "static, enum, ";
										else
											clause += "instance, enum, ";
									} else {
										if( fieldi.IsStatic ) 
											clause += "static, field, ";
										else
											clause += "instance, field, ";
									}
									sig = "'" + m.Name + "'( '" + fieldi.FieldType.ToString( ) + "' )";
									shouldAdd = true;
									break;
								case MemberTypes.Method:
									MethodInfo methi = (MethodInfo)m;
									if( methi.IsStatic )
										clause += "static, method, ";
									else
										clause += "instance, method, ";
									pi = methi.GetParameters( );
									sig = "'" + methi.Name + "'( ";
									sig += "'" + methi.ReturnType + "'";
									if( pi.Length == 0 )
										sig += " )";
									else {
										sig += ", ";
										for( int i = 0; i < pi.Length; i++ ) {
											sig += "'" + pi[ i ].ParameterType.ToString( ) + "'"; 
											if( i == pi.Length - 1 )
												sig += " )";
											else
												sig += ", ";
										}
									}
									//Console.Out.WriteLine( sig );
									shouldAdd = ( methi.DeclaringType.Equals( t ) );
									break;
								case MemberTypes.NestedType:

									break;
								case MemberTypes.Property:
									PropertyInfo propi = (PropertyInfo)m;
									//if( propi.IsStatic ) 
									//	clause += "static, field, ";
									//else
									clause += "property, field, ";
									sig = "'" + m.Name + "'( '" + propi.PropertyType.ToString( ) + "' )";
									shouldAdd = true;
									break;
								default: break;


							}
							clause += sig + " ).";
							if( shouldAdd )
								fs.WriteLine( clause );

							/*
							char[] ca = clause.ToCharArray( );
							byte[] ba = new Byte[ ca.Length ];
							for( int j = 0; j < ba.Length; j++ )
								ba[ j ] = (byte)ca[ j ];

							bs.Write( ba, 0, ba.Length ); 
							bs.WriteByte( 13 );
							bs.WriteByte( 10 );							
							bs.Close( );
							*/
							
							fs.Close( );
						}
					}
				}
			}
		}
	}
}