using System;
using System.IO;
using System.Collections;

namespace SplitIntoPredicates {
	/// <summary>
	/// This application is a preprocessor for Treeify,
	/// which puts the clauses for different predicates
	/// into different files, as Treeify only handles
	/// databases with single predicates.
	/// </summary>
	class Class1 {

        private Hashtable files = new Hashtable( );
		private ArrayList array = new ArrayList( );

		private void Process( string filename ) {
			// readin filename line by line,
			// sending to different files depending on functor.
			// filename.pl -> filename~pred.pl
			FileInfo f = new FileInfo( filename );
			int dotPos = f.Name.LastIndexOf( '.' );
			string nameLessExt = null;
			if( dotPos == -1 )
				nameLessExt = f.Name;
			else
				nameLessExt = f.Name.Substring( 0, dotPos );
			StreamReader sr = f.OpenText( );
			string next;
			while( ( next = sr.ReadLine( ) ) != null ) {
				string trim = next.TrimStart( );
				string pred = null;
				int loc = 0;
				if( ( loc = trim.IndexOf( '(' ) ) != -1 )
					pred = trim.Substring( 0, loc ).Trim( );
				else
					pred = trim.Substring( 0, trim.IndexOf( '.' ) ).Trim( );

				// HOLE: what if pred contains chars which cannot appear in a filename?

				string name = nameLessExt + "~" + pred + f.Extension;
				if( files[ name ] == null ) {
					FileInfo towriteto = new FileInfo( nameLessExt + "~" + pred + f.Extension );
					StreamWriter write = new StreamWriter( towriteto.OpenWrite( ) );
					files[ name ] = write;
					array.Add( write );
				}
				( (StreamWriter)files[ name ] ).WriteLine( next );		
		
				//StreamWriter write = towriteto.AppendText( );
				//write.WriteLine( next );
				//write.Close( );
			}
			foreach( StreamWriter sw in array )
				sw.Close( );

			sr.Close( );
		}


		[STAThread]
		static void Main(string[] args) {
			Class1 class1 = new Class1( );
			if( args.Length == 0 ) {
				Console.WriteLine( "SplitIntoPredicates <filename>" );
			} else {
				foreach( string filename in args ) {
					Console.WriteLine( "Now splitting: " + filename );
					class1.Process( filename );
				}
			}

		}
	}
}
