/*
 * *** Please do not edit ! ***
 * @(#) BundleUp_5.cs
 * @procedure bundle_up/5 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class BundleUp_5 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate BundleUp_5_1 = new Predicates.BundleUp_5_1();
    static internal readonly Predicate BundleUp_5_2 = new Predicates.BundleUp_5_2();
    static internal readonly Predicate BundleUp_5_3 = new Predicates.BundleUp_5_3();
    static internal readonly Predicate BundleUp_5_lis = new Predicates.BundleUp_5_lis();
    static internal readonly Predicate BundleUp_5_var = new Predicates.BundleUp_5_var();

    public Term arg1, arg2, arg3, arg4, arg5;

    public BundleUp_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public BundleUp_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   BundleUp_5_var,
                                   dollar_fail_0,
                                   BundleUp_5_1,
                                   dollar_fail_0,
                                   BundleUp_5_lis
                                   );
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "bundle_up(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class BundleUp_5_var : BundleUp_5 {
    static internal readonly Predicate BundleUp_5_var_1 = new Predicates.BundleUp_5_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(BundleUp_5_1, BundleUp_5_var_1);
    }
}

sealed class BundleUp_5_var_1 : BundleUp_5 {
    static internal readonly Predicate BundleUp_5_var_2 = new Predicates.BundleUp_5_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(BundleUp_5_2, BundleUp_5_var_2);
    }
}

sealed class BundleUp_5_var_2 : BundleUp_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(BundleUp_5_3);
    }
}

sealed class BundleUp_5_lis : BundleUp_5 {
    static internal readonly Predicate BundleUp_5_lis_1 = new Predicates.BundleUp_5_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(BundleUp_5_2, BundleUp_5_lis_1);
    }
}

sealed class BundleUp_5_lis_1 : BundleUp_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(BundleUp_5_3);
    }
}

sealed class BundleUp_5_1 : BundleUp_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !a3.unify(a4, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class BundleUp_5_2 : BundleUp_5 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a6 = ((ListTerm)a1).car;
            a7 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !a2.unify(a5, engine.trail) ) return engine.fail();
        a9 = new ListTerm(a6, s2);
        a8 = new ListTerm(a9, a3);
        p1 = new Predicates.BundleUp_5(a7, s1, a8, a4, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class BundleUp_5_3 : BundleUp_5 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a6 = ((ListTerm)a1).car;
            a7 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            a8 = ((ListTerm)a3).car;
            a9 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a10 = engine.makeVariable();
        a12 = new ListTerm(a6, a8);
        a11 = new ListTerm(a12, a9);
        p1 = new Predicates.BundleUp_5(a7, a10, a11, a4, a5, cont);
        return new Predicates.dollar_plus_3(a2, s1, a10, p1);
    }
}
}

