/*
 * *** Please do not edit ! ***
 * @(#) GenVars_4.cs
 * @procedure gen_vars/4 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GenVars_4 : Predicate {
    static internal readonly Predicate GenVars_4_1 = new Predicates.GenVars_4_1();
    static internal readonly Predicate GenVars_4_2 = new Predicates.GenVars_4_2();
    static internal readonly Predicate GenVars_4_sub_1 = new Predicates.GenVars_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public GenVars_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public GenVars_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(GenVars_4_1, GenVars_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "gen_vars(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class GenVars_4_sub_1 : GenVars_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(GenVars_4_2);
    }
}

sealed class GenVars_4_1 : GenVars_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("X");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(" )");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.Append_3(a9, a7, a4, cont);
        p2 = new Predicates.Append_3(a8, a6, a9, p1);
        p3 = new Predicates.Append_3(a1, a5, a8, p2);
        p4 = new Predicates.AtomChars_2(s2, a7, p3);
        p5 = new Predicates.NumberChars_2(a2, a6, p4);
        p6 = new Predicates.AtomChars_2(s1, a5, p5);
        return new Predicates.dollar_neckCut_0(p6);
    }
}

sealed class GenVars_4_2 : GenVars_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("X");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(", ");
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        p1 = new Predicates.GenVars_4(a10, a11, a3, a4, cont);
        p2 = new Predicates.dollar_plus_3(a2, s3, a11, p1);
        p3 = new Predicates.Append_3(a9, a7, a10, p2);
        p4 = new Predicates.Append_3(a8, a6, a9, p3);
        p5 = new Predicates.Append_3(a1, a5, a8, p4);
        p6 = new Predicates.AtomChars_2(s2, a7, p5);
        p7 = new Predicates.NumberChars_2(a2, a6, p6);
        return new Predicates.AtomChars_2(s1, a5, p7);
    }
}
}

