/*
 * *** Please do not edit ! ***
 * @(#) GeneraliseMyVarsNoNumber_2.cs
 * @procedure generalise_my_vars_no_number/2 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GeneraliseMyVarsNoNumber_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("( ");
    static internal readonly IntegerTerm s2 = new IntegerTerm(1);

    public Term arg1, arg2;

    public GeneraliseMyVarsNoNumber_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public GeneraliseMyVarsNoNumber_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a4 = new ListTerm(a5, a6);
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        p1 = new Predicates.AtomChars_2(a2, a11, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.GenVars_4(a9, s2, a10, a11, p2);
        p4 = new Predicates.Length_2(a6, a10, p3);
        p5 = new Predicates.Append_3(a7, a8, a9, p4);
        p6 = new Predicates.AtomChars_2(s1, a8, p5);
        p7 = new Predicates.AtomChars_2(a5, a7, p6);
        p8 = new Predicates.eq_stop_stop_2(a1, a4, p7);
        return new Predicates.dollar_getLevel_1(a3, p8);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "generalise_my_vars_no_number(" + arg1 + ", " + arg2 + ")";
    }
}
}

