/*
 * *** Please do not edit ! ***
 * @(#) GeneraliseMyVars_3.cs
 * @procedure generalise_my_vars/3 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GeneraliseMyVars_3 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(95);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);
    static internal readonly ListTerm s4 = new ListTerm(s1, s3);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("( ");
    static internal readonly IntegerTerm s6 = new IntegerTerm(1);

    public Term arg1, arg2, arg3;

    public GeneraliseMyVars_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public GeneraliseMyVars_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        a4 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a5 = new ListTerm(a6, a7);
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        p1 = new Predicates.AtomChars_2(a3, a15, cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.GenVars_4(a13, s6, a14, a15, p2);
        p4 = new Predicates.Length_2(a7, a14, p3);
        p5 = new Predicates.Append_3(a11, a12, a13, p4);
        p6 = new Predicates.AtomChars_2(s5, a12, p5);
        p7 = new Predicates.Append_3(a10, a9, a11, p6);
        p8 = new Predicates.Append_3(a8, s4, a10, p7);
        p9 = new Predicates.NumberChars_2(a2, a9, p8);
        p10 = new Predicates.AtomChars_2(a6, a8, p9);
        p11 = new Predicates.eq_stop_stop_2(a1, a5, p10);
        return new Predicates.dollar_getLevel_1(a4, p11);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "generalise_my_vars(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

