/*
 * *** Please do not edit ! ***
 * @(#) GetClauses_1.cs
 * @procedure get_clauses/1 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GetClauses_1 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("inputclause", 1);

    public Term arg1;

    public GetClauses_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public GetClauses_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        Term[] h2 = {a2};
        a3 = new StructureTerm(f1, h2);
        return new Predicates.Findall_3(a2, a3, a1, cont);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "get_clauses(" + arg1 + ")";
    }
}
}

