/*
 * *** Please do not edit ! ***
 * @(#) GetDbtree_2.cs
 * @procedure get_dbtree/2 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GetDbtree_2 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("dbtree", 3);
    static internal readonly IntegerTerm s2 = new IntegerTerm(100);
    static internal readonly IntegerTerm s3 = new IntegerTerm(98);
    static internal readonly IntegerTerm s4 = new IntegerTerm(116);
    static internal readonly IntegerTerm s5 = new IntegerTerm(114);
    static internal readonly IntegerTerm s6 = new IntegerTerm(101);
    static internal readonly IntegerTerm s7 = new IntegerTerm(95);
    static internal readonly SymbolTerm s8 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s9 = new ListTerm(s7, s8);
    static internal readonly ListTerm s10 = new ListTerm(s6, s9);
    static internal readonly ListTerm s11 = new ListTerm(s6, s10);
    static internal readonly ListTerm s12 = new ListTerm(s5, s11);
    static internal readonly ListTerm s13 = new ListTerm(s4, s12);
    static internal readonly ListTerm s14 = new ListTerm(s3, s13);
    static internal readonly ListTerm s15 = new ListTerm(s2, s14);

    public Term arg1, arg2;

    public GetDbtree_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public GetDbtree_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
            a5 = args[2];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a3, a4, a5};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        p1 = new Predicates.Name_2(a2, a13, cont);
        p2 = new Predicates.Append_3(a11, a12, a13, p1);
        p3 = new Predicates.AtomChars_2(a5, a12, p2);
        p4 = new Predicates.Append_3(a10, s9, a11, p3);
        p5 = new Predicates.Append_3(a8, a9, a10, p4);
        p6 = new Predicates.NumberChars_2(a4, a9, p5);
        p7 = new Predicates.Append_3(a7, s9, a8, p6);
        p8 = new Predicates.Append_3(s15, a6, a7, p7);
        return new Predicates.NumberChars_2(a3, a6, p8);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "get_dbtree(" + arg1 + ", " + arg2 + ")";
    }
}
}

