/*
 * *** Please do not edit ! ***
 * @(#) GetOutputFilename_3.cs
 * @procedure get_output_filename/3 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GetOutputFilename_3 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(126);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);
    static internal readonly ListTerm s4 = new ListTerm(s1, s3);
    static internal readonly IntegerTerm s5 = new IntegerTerm(46);
    static internal readonly IntegerTerm s6 = new IntegerTerm(112);
    static internal readonly IntegerTerm s7 = new IntegerTerm(108);
    static internal readonly ListTerm s8 = new ListTerm(s7, s2);
    static internal readonly ListTerm s9 = new ListTerm(s6, s8);
    static internal readonly ListTerm s10 = new ListTerm(s5, s9);

    public Term arg1, arg2, arg3;

    public GetOutputFilename_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public GetOutputFilename_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4, p5;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        p1 = new Predicates.AtomChars_2(a3, a8, cont);
        p2 = new Predicates.Append_3(a7, s10, a8, p1);
        p3 = new Predicates.Append_3(a5, a6, a7, p2);
        p4 = new Predicates.NumberChars_2(a2, a6, p3);
        p5 = new Predicates.Append_3(a4, s4, a5, p4);
        return new Predicates.AtomChars_2(a1, a4, p5);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "get_output_filename(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

