/*
 * *** Please do not edit ! ***
 * @(#) IterateThroughBundledList_6.cs
 * @procedure iterate_through_bundled_list/6 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class IterateThroughBundledList_6 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate IterateThroughBundledList_6_1 = new Predicates.IterateThroughBundledList_6_1();
    static internal readonly Predicate IterateThroughBundledList_6_2 = new Predicates.IterateThroughBundledList_6_2();
    static internal readonly Predicate IterateThroughBundledList_6_var = new Predicates.IterateThroughBundledList_6_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public IterateThroughBundledList_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public IterateThroughBundledList_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   IterateThroughBundledList_6_var,
                                   dollar_fail_0,
                                   IterateThroughBundledList_6_1,
                                   dollar_fail_0,
                                   IterateThroughBundledList_6_2
                                   );
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "iterate_through_bundled_list(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class IterateThroughBundledList_6_var : IterateThroughBundledList_6 {
    static internal readonly Predicate IterateThroughBundledList_6_var_1 = new Predicates.IterateThroughBundledList_6_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(IterateThroughBundledList_6_1, IterateThroughBundledList_6_var_1);
    }
}

sealed class IterateThroughBundledList_6_var_1 : IterateThroughBundledList_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(IterateThroughBundledList_6_2);
    }
}

sealed class IterateThroughBundledList_6_1 : IterateThroughBundledList_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !a4.unify(a5, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class IterateThroughBundledList_6_2 : IterateThroughBundledList_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("dbtree", 3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a11 = engine.makeVariable();
        Term[] h2 = {engine.makeVariable(), a11, engine.makeVariable()};
        a10 = new StructureTerm(f1, h2);
        a9 = new ListTerm(a10, engine.makeVariable());
        a12 = engine.makeVariable();
        Term[] h3 = {a2, a11, a3};
        a13 = new StructureTerm(f1, h3);
        a14 = engine.makeVariable();
        a15 = new ListTerm(a12, a4);
        p1 = new Predicates.IterateThroughBundledList_6(a8, a2, a3, a14, a5, a6, cont);
        p2 = new Predicates.dollar_unify_2(a14, a15, p1);
        p3 = new Predicates.PairUp_3(a12, a7, a6, p2);
        p4 = new Predicates.dollar_unify_2(a12, a13, p3);
        return new Predicates.dollar_unify_2(a7, a9, p4);
    }
}
}

