/*
 * *** Please do not edit ! ***
 * @(#) OutputChunk_3.cs
 * @procedure output_chunk/3 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OutputChunk_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("base", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("subpred", 1);
    static internal readonly IntegerTerm s5 = new IntegerTerm(1);

    public Term arg1, arg2, arg3;

    public OutputChunk_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public OutputChunk_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h2 = {engine.makeVariable()};
        a6 = new StructureTerm(f1, h2);
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        Term[] h4 = {a7};
        a9 = new StructureTerm(f3, h4);
        a10 = new ListTerm(a4, a5);
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        Term[] h6 = {a12};
        a13 = new StructureTerm(f1, h6);
        a14 = engine.makeVariable();
        p1 = new Predicates.Iterate_4(a14, s5, a7, a2, cont);
        p2 = new Predicates.Findall_3(a12, a13, a14, p1);
        p3 = new Predicates.BaseStep_5(a11, s5, a7, a2, a8, p2);
        p4 = new Predicates.dollar_reverse_2(a10, a11, p3);
        p5 = new Predicates.Pred_1(engine.makeVariable(), p4);
        p6 = new Predicates.Assertz_1(a9, p5);
        p7 = new Predicates.GeneraliseMyVarsFunctor_3(a4, a3, a8, p6);
        p8 = new Predicates.GeneraliseMyVars_3(a4, a3, a7, p7);
        return new Predicates.Retractall_1(a6, p8);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "output_chunk(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

