/*
 * *** Please do not edit ! ***
 * @(#) ReadAndConvertAll_3.cs
 * @procedure read_and_convert_all/3 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ReadAndConvertAll_3 : Predicate {
    static internal readonly Predicate ReadAndConvertAll_3_1 = new Predicates.ReadAndConvertAll_3_1();
    static internal readonly Predicate ReadAndConvertAll_3_2 = new Predicates.ReadAndConvertAll_3_2();
    static internal readonly Predicate ReadAndConvertAll_3_sub_1 = new Predicates.ReadAndConvertAll_3_sub_1();

    public Term arg1, arg2, arg3;

    public ReadAndConvertAll_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public ReadAndConvertAll_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(ReadAndConvertAll_3_1, ReadAndConvertAll_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "read_and_convert_all(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class ReadAndConvertAll_3_sub_1 : ReadAndConvertAll_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(ReadAndConvertAll_3_2);
    }
}

sealed class ReadAndConvertAll_3_1 : ReadAndConvertAll_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("inputclause", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("pred", 1);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("output filename: ");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("write");
    static internal readonly IntegerTerm s8 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a5 = engine.makeVariable();
        Term[] h2 = {a5};
        a4 = new StructureTerm(f1, h2);
        a6 = engine.makeVariable();
        Term[] h4 = {engine.makeVariable()};
        a7 = new StructureTerm(f3, h4);
        Term[] h5 = {a6};
        a8 = new StructureTerm(f3, h5);
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        p1 = new Predicates.ReadAndConvertAll_3(a1, a2, a12, cont);
        p2 = new Predicates.dollar_plus_3(a3, s8, a12, p1);
        p3 = new Predicates.dollar_close_1(a10, p2);
        p4 = new Predicates.OutputChunk_3(a11, a10, a3, p3);
        p5 = new Predicates.GetClauses_1(a11, p4);
        p6 = new Predicates.Open_3(a9, s7, a10, p5);
        p7 = new Predicates.dollar_nl_0(p6);
        p8 = new Predicates.Write_1(a9, p7);
        p9 = new Predicates.Write_1(s6, p8);
        p10 = new Predicates.GetOutputFilename_3(a2, a3, a9, p9);
        p11 = new Predicates.Assert_1(a8, p10);
        p12 = new Predicates.Retractall_1(a7, p11);
        p13 = new Predicates.GeneraliseMyVarsNoNumber_2(a5, a6, p12);
        p14 = new Predicates.Once_1(a4, p13);
        return new Predicates.ReadInChunkOfClauses_1(a1, p14);
    }
}

sealed class ReadAndConvertAll_3_2 : ReadAndConvertAll_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("write");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("subpred", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        Term[] h4 = {a6};
        a7 = new StructureTerm(f3, h4);
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_close_1(a5, cont);
        p2 = new Predicates.GenMasterClauses_3(a5, a9, a8, p1);
        p3 = new Predicates.Pred_1(a9, p2);
        p4 = new Predicates.Findall_3(a6, a7, a8, p3);
        p5 = new Predicates.Open_3(a4, s2, a5, p4);
        p6 = new Predicates.GetOutputFilename_3(a2, s1, a4, p5);
        return new Predicates.dollar_dummyTreeify__0_1(a3, p6);
    }
}
}

