/*
 * *** Please do not edit ! ***
 * @(#) ReadInChunkOfClauses_1.cs
 * @procedure read_in_chunk_of_clauses/1 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ReadInChunkOfClauses_1 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("inputclause", 1);
    static internal readonly IntegerTerm s3 = new IntegerTerm(0);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("not_reached_end");

    public Term arg1;

    public ReadInChunkOfClauses_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public ReadInChunkOfClauses_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = arg1.dereference();

        Term[] h2 = {engine.makeVariable()};
        a2 = new StructureTerm(f1, h2);
        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a3, s4, cont);
        p2 = new Predicates.ReadInChunkOfClauses_3(a1, s3, a3, p1);
        return new Predicates.Retractall_1(a2, p2);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "read_in_chunk_of_clauses(" + arg1 + ")";
    }
}
}

