/*
 * *** Please do not edit ! ***
 * @(#) ReadInChunkOfClauses_3.cs
 * @procedure read_in_chunk_of_clauses/3 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ReadInChunkOfClauses_3 : Predicate {
    static internal readonly Predicate ReadInChunkOfClauses_3_1 = new Predicates.ReadInChunkOfClauses_3_1();
    static internal readonly Predicate ReadInChunkOfClauses_3_2 = new Predicates.ReadInChunkOfClauses_3_2();
    static internal readonly Predicate ReadInChunkOfClauses_3_3 = new Predicates.ReadInChunkOfClauses_3_3();
    static internal readonly Predicate ReadInChunkOfClauses_3_4 = new Predicates.ReadInChunkOfClauses_3_4();
    static internal readonly Predicate ReadInChunkOfClauses_3_sub_1 = new Predicates.ReadInChunkOfClauses_3_sub_1();

    public Term arg1, arg2, arg3;

    public ReadInChunkOfClauses_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public ReadInChunkOfClauses_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(ReadInChunkOfClauses_3_1, ReadInChunkOfClauses_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "read_in_chunk_of_clauses(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class ReadInChunkOfClauses_3_sub_1 : ReadInChunkOfClauses_3 {
    static internal readonly Predicate ReadInChunkOfClauses_3_sub_2 = new Predicates.ReadInChunkOfClauses_3_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(ReadInChunkOfClauses_3_2, ReadInChunkOfClauses_3_sub_2);
    }
}

sealed class ReadInChunkOfClauses_3_sub_2 : ReadInChunkOfClauses_3 {
    static internal readonly Predicate ReadInChunkOfClauses_3_sub_3 = new Predicates.ReadInChunkOfClauses_3_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(ReadInChunkOfClauses_3_3, ReadInChunkOfClauses_3_sub_3);
    }
}

sealed class ReadInChunkOfClauses_3_sub_3 : ReadInChunkOfClauses_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(ReadInChunkOfClauses_3_4);
    }
}

sealed class ReadInChunkOfClauses_3_1 : ReadInChunkOfClauses_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(500);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("not_reached_end");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( !s2.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class ReadInChunkOfClauses_3_2 : ReadInChunkOfClauses_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("inputclause", 1);
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        Term[] h2 = {a4};
        a5 = new StructureTerm(f1, h2);
        a6 = engine.makeVariable();
        p1 = new Predicates.ReadInChunkOfClauses_3(a1, a6, a3, cont);
        p2 = new Predicates.dollar_plus_3(a2, s3, a6, p1);
        p3 = new Predicates.Assertz_1(a5, p2);
        p4 = new Predicates.dollar_dummyTreeify__1_1(a4, p3);
        return new Predicates.Read_2(a1, a4, p4);
    }
}

sealed class ReadInChunkOfClauses_3_3 : ReadInChunkOfClauses_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("not_reached_end");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( !s2.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class ReadInChunkOfClauses_3_4 : ReadInChunkOfClauses_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("reached_end");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        return cont;
    }
}
}

