/*
 * *** Please do not edit ! ***
 * @(#) WriteDbtree_2.cs
 * @procedure write_dbtree/2 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class WriteDbtree_2 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("dbtree", 3);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("dbtree_");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("_");

    public Term arg1, arg2;

    public WriteDbtree_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public WriteDbtree_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4, p5;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
            a4 = args[1];
            a5 = args[2];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a3, a4, a5};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.Write_2(a1, a5, cont);
        p2 = new Predicates.Write_2(a1, s3, p1);
        p3 = new Predicates.Write_2(a1, a4, p2);
        p4 = new Predicates.Write_2(a1, s3, p3);
        p5 = new Predicates.Write_2(a1, a3, p4);
        return new Predicates.Write_2(a1, s2, p5);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "write_dbtree(" + arg1 + ", " + arg2 + ")";
    }
}
}

