/*
 * *** Please do not edit ! ***
 * @(#) WriteSpecial_2.cs
 * @procedure write_special/2 in treeify.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class WriteSpecial_2 : Predicate {
    static internal readonly Predicate WriteSpecial_2_1 = new Predicates.WriteSpecial_2_1();
    static internal readonly Predicate WriteSpecial_2_2 = new Predicates.WriteSpecial_2_2();
    static internal readonly Predicate WriteSpecial_2_3 = new Predicates.WriteSpecial_2_3();
    static internal readonly Predicate WriteSpecial_2_sub_1 = new Predicates.WriteSpecial_2_sub_1();

    public Term arg1, arg2;

    public WriteSpecial_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public WriteSpecial_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(WriteSpecial_2_1, WriteSpecial_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "write_special(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class WriteSpecial_2_sub_1 : WriteSpecial_2 {
    static internal readonly Predicate WriteSpecial_2_sub_2 = new Predicates.WriteSpecial_2_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(WriteSpecial_2_2, WriteSpecial_2_sub_2);
    }
}

sealed class WriteSpecial_2_sub_2 : WriteSpecial_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(WriteSpecial_2_3);
    }
}

sealed class WriteSpecial_2_1 : WriteSpecial_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("'");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.Write_2(a1, s1, cont);
        p2 = new Predicates.Write_2(a1, a2, p1);
        p3 = new Predicates.Write_2(a1, s1, p2);
        p4 = new Predicates.dollar_cut_1(a3, p3);
        p5 = new Predicates.dollar_atom_1(a2, p4);
        return new Predicates.dollar_getLevel_1(a3, p5);
    }
}

sealed class WriteSpecial_2_2 : WriteSpecial_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("'");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("'( ");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(" )");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a4 = new ListTerm(a5, a6);
        p1 = new Predicates.Write_2(a1, s3, cont);
        p2 = new Predicates.WriteSpecialArgs_2(a1, a6, p1);
        p3 = new Predicates.Write_2(a1, s2, p2);
        p4 = new Predicates.Write_2(a1, a5, p3);
        p5 = new Predicates.Write_2(a1, s1, p4);
        p6 = new Predicates.eq_stop_stop_2(a2, a4, p5);
        p7 = new Predicates.dollar_cut_1(a3, p6);
        p8 = new Predicates.Compound_1(a2, p7);
        return new Predicates.dollar_getLevel_1(a3, p8);
    }
}

sealed class WriteSpecial_2_3 : WriteSpecial_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        return new Predicates.Write_2(a1, a2, cont);
    }
}
}

