/*
 * *** Please do not edit ! ***
 * @(#) ClassDefines_3.cs
 * @procedure class_defines/3 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ClassDefines_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("class", 1);

    public Term arg1, arg2, arg3;

    public ClassDefines_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public ClassDefines_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        if ( a3.isStructure() ){
            if (f1 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a4 = args[0];
        } else if (a3.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a3.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a5 = engine.makeVariable();
        a6 = new ListTerm(a2, engine.makeVariable());
        p1 = new Predicates.eq_stop_stop_2(a5, a6, cont);
        return new Predicates.Members_5(a1, a4, engine.makeVariable(), engine.makeVariable(), a5, p1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "class_defines(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

