/*
 * *** Please do not edit ! ***
 * @(#) IncCount_0.cs
 * @procedure inc_count/0 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class IncCount_0 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("limit_count", 1);
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("Limit count is : ");

    public IncCount_0(Predicate cont) {
        this.cont = cont;
    }

    public IncCount_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4, p5, p6;

        a2 = engine.makeVariable();
        Term[] h2 = {a2};
        a1 = new StructureTerm(f1, h2);
        a3 = engine.makeVariable();
        Term[] h4 = {a2};
        a4 = new StructureTerm(f1, h4);
        Term[] h5 = {a3};
        a5 = new StructureTerm(f1, h5);
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(a3, p1);
        p3 = new Predicates.Write_1(s6, p2);
        p4 = new Predicates.GlobalAssert_1(a5, p3);
        p5 = new Predicates.GlobalRetract_1(a4, p4);
        p6 = new Predicates.dollar_plus_3(a2, s3, a3, p5);
        return new Predicates.GlobalCall_1(a1, p6);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "inc_count";
    }
}
}

