/*
 * *** Please do not edit ! ***
 * @(#) OoSearchClassDefines_4.cs
 * @procedure oo_search_class_defines/4 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearchClassDefines_4 : Predicate {
    static internal readonly Predicate OoSearchClassDefines_4_1 = new Predicates.OoSearchClassDefines_4_1();
    static internal readonly Predicate OoSearchClassDefines_4_2 = new Predicates.OoSearchClassDefines_4_2();
    static internal readonly Predicate OoSearchClassDefines_4_3 = new Predicates.OoSearchClassDefines_4_3();
    static internal readonly Predicate OoSearchClassDefines_4_4 = new Predicates.OoSearchClassDefines_4_4();
    static internal readonly Predicate OoSearchClassDefines_4_5 = new Predicates.OoSearchClassDefines_4_5();
    static internal readonly Predicate OoSearchClassDefines_4_sub_1 = new Predicates.OoSearchClassDefines_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public OoSearchClassDefines_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public OoSearchClassDefines_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(OoSearchClassDefines_4_1, OoSearchClassDefines_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "oo_search_class_defines(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class OoSearchClassDefines_4_sub_1 : OoSearchClassDefines_4 {
    static internal readonly Predicate OoSearchClassDefines_4_sub_2 = new Predicates.OoSearchClassDefines_4_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearchClassDefines_4_2, OoSearchClassDefines_4_sub_2);
    }
}

sealed class OoSearchClassDefines_4_sub_2 : OoSearchClassDefines_4 {
    static internal readonly Predicate OoSearchClassDefines_4_sub_3 = new Predicates.OoSearchClassDefines_4_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearchClassDefines_4_3, OoSearchClassDefines_4_sub_3);
    }
}

sealed class OoSearchClassDefines_4_sub_3 : OoSearchClassDefines_4 {
    static internal readonly Predicate OoSearchClassDefines_4_sub_4 = new Predicates.OoSearchClassDefines_4_sub_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearchClassDefines_4_4, OoSearchClassDefines_4_sub_4);
    }
}

sealed class OoSearchClassDefines_4_sub_4 : OoSearchClassDefines_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(OoSearchClassDefines_4_5);
    }
}

sealed class OoSearchClassDefines_4_1 : OoSearchClassDefines_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("members", 5);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("class", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        Term[] h3 = {a1, a2, engine.makeVariable(), engine.makeVariable(), engine.makeVariable()};
        a5 = new StructureTerm(f2, h3);
        Term[] h5 = {a2};
        a6 = new StructureTerm(f4, h5);
        p1 = new Predicates.Pulse_2(a4, a6, cont);
        p2 = new Predicates.Once_1(a5, p1);
        p3 = new Predicates.NotReachedEnd_0(p2);
        return new Predicates.dollar_dummySearch__6_1(a2, p3);
    }
}

sealed class OoSearchClassDefines_4_2 : OoSearchClassDefines_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(",", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("members", 5);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("=..", 2);
    static internal readonly SymbolTerm f8 = SymbolTerm.makeSymbol("class", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a3.isList() ){
            a5 = ((ListTerm)a3).car;
            if ( !s1.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a5, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        Term[] h4 = {a1, a2, engine.makeVariable(), engine.makeVariable(), a8};
        a7 = new StructureTerm(f3, h4);
        a10 = new ListTerm(a5, engine.makeVariable());
        Term[] h6 = {a8, a10};
        a9 = new StructureTerm(f5, h6);
        Term[] h7 = {a7, a9};
        a6 = new StructureTerm(f2, h7);
        Term[] h9 = {a2};
        a11 = new StructureTerm(f8, h9);
        p1 = new Predicates.Pulse_2(a4, a11, cont);
        p2 = new Predicates.Once_1(a6, p1);
        p3 = new Predicates.NotReachedEnd_0(p2);
        return new Predicates.dollar_dummySearch__7_1(a2, p3);
    }
}

sealed class OoSearchClassDefines_4_3 : OoSearchClassDefines_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("call", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("members", 5);
    static internal readonly SymbolTerm f6 = SymbolTerm.makeSymbol("limit", 1);
    static internal readonly SymbolTerm f8 = SymbolTerm.makeSymbol("limit_count", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        a5 = engine.makeVariable();
        Term[] h4 = {a1, a5, engine.makeVariable(), engine.makeVariable(), engine.makeVariable()};
        a7 = new StructureTerm(f3, h4);
        Term[] h5 = {a7};
        a6 = new StructureTerm(f2, h5);
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a11 = engine.makeVariable();
        Term[] h7 = {a11};
        a10 = new StructureTerm(f6, h7);
        a13 = engine.makeVariable();
        Term[] h9 = {a13};
        a12 = new StructureTerm(f8, h9);
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        p1 = new Predicates.PulseList_2(a4, a15, cont);
        p2 = new Predicates.Truncate_3(a9, a14, a15, p1);
        p3 = new Predicates.dollar_minus_3(a11, a13, a14, p2);
        p4 = new Predicates.dollar_lessThan_2(a13, a11, p3);
        p5 = new Predicates.GlobalCall_1(a12, p4);
        p6 = new Predicates.GlobalCall_1(a10, p5);
        p7 = new Predicates.Sort_2(a8, a9, p6);
        p8 = new Predicates.Findall_3(a5, a6, a8, p7);
        return new Predicates.dollar_var_1(a2, p8);
    }
}

sealed class OoSearchClassDefines_4_4 : OoSearchClassDefines_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a3.isList() ){
            a5 = ((ListTerm)a3).car;
            if ( !s1.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a5, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a6, cont);
        p2 = new Predicates.ReachedEnd_0(p1);
        p3 = new Predicates.Pulse_2(a4, a7, p2);
        p4 = new Predicates.ClassDefines_3(a1, a5, a7, p3);
        p5 = new Predicates.dollar_var_1(a2, p4);
        return new Predicates.dollar_getLevel_1(a6, p5);
    }
}

sealed class OoSearchClassDefines_4_5 : OoSearchClassDefines_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.cont;
    }
}
}

