/*
 * *** Please do not edit ! ***
 * @(#) OoSearchClassSuperclass_2.cs
 * @procedure oo_search_class_superclass/2 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearchClassSuperclass_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("call", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol(";", 2);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("derives", 2);
    static internal readonly SymbolTerm f9 = SymbolTerm.makeSymbol("class", 1);

    public Term arg1, arg2;

    public OoSearchClassSuperclass_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public OoSearchClassSuperclass_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h5 = {a3, engine.makeVariable()};
        a6 = new StructureTerm(f4, h5);
        Term[] h6 = {engine.makeVariable(), a3};
        a7 = new StructureTerm(f4, h6);
        Term[] h7 = {a6, a7};
        a5 = new StructureTerm(f3, h7);
        Term[] h8 = {a5};
        a4 = new StructureTerm(f2, h8);
        Term[] h10 = {a3};
        a8 = new StructureTerm(f9, h10);
        p1 = new Predicates.IterateUpHierarchy_2(a3, a2, cont);
        p2 = new Predicates.Pulse_2(a2, a8, p1);
        return new Predicates.Once_1(a4, p2);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "oo_search_class_superclass(" + arg1 + ", " + arg2 + ")";
    }
}
}

