/*
 * *** Please do not edit ! ***
 * @(#) OoSearchIterateClasses_6.cs
 * @procedure oo_search_iterate_classes/6 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearchIterateClasses_6 : Predicate {
    static internal readonly Predicate OoSearchIterateClasses_6_1 = new Predicates.OoSearchIterateClasses_6_1();
    static internal readonly Predicate OoSearchIterateClasses_6_2 = new Predicates.OoSearchIterateClasses_6_2();
    static internal readonly Predicate OoSearchIterateClasses_6_3 = new Predicates.OoSearchIterateClasses_6_3();
    static internal readonly Predicate OoSearchIterateClasses_6_4 = new Predicates.OoSearchIterateClasses_6_4();
    static internal readonly Predicate OoSearchIterateClasses_6_sub_1 = new Predicates.OoSearchIterateClasses_6_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public OoSearchIterateClasses_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public OoSearchIterateClasses_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(OoSearchIterateClasses_6_1, OoSearchIterateClasses_6_sub_1);
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "oo_search_iterate_classes(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class OoSearchIterateClasses_6_sub_1 : OoSearchIterateClasses_6 {
    static internal readonly Predicate OoSearchIterateClasses_6_sub_2 = new Predicates.OoSearchIterateClasses_6_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearchIterateClasses_6_2, OoSearchIterateClasses_6_sub_2);
    }
}

sealed class OoSearchIterateClasses_6_sub_2 : OoSearchIterateClasses_6 {
    static internal readonly Predicate OoSearchIterateClasses_6_sub_3 = new Predicates.OoSearchIterateClasses_6_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearchIterateClasses_6_3, OoSearchIterateClasses_6_sub_3);
    }
}

sealed class OoSearchIterateClasses_6_sub_3 : OoSearchIterateClasses_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(OoSearchIterateClasses_6_4);
    }
}

sealed class OoSearchIterateClasses_6_1 : OoSearchIterateClasses_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("either");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("oo_search", 6);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        if ( !s2.unify(a4, engine.trail) ) return engine.fail();
        Term[] h4 = {a1, engine.makeVariable(), engine.makeVariable(), a2, a5, a6};
        a7 = new StructureTerm(f3, h4);
        p1 = new Predicates.Once_1(a7, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class OoSearchIterateClasses_6_2 : OoSearchIterateClasses_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("oo_search", 6);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        Term[] h3 = {a1, engine.makeVariable(), a4, a2, a5, a6};
        a7 = new StructureTerm(f2, h3);
        p1 = new Predicates.Once_1(a7, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class OoSearchIterateClasses_6_3 : OoSearchIterateClasses_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("either");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("oo_search_iterate_classes_inner", 6);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        Term[] h3 = {a1, a2, a3, engine.makeVariable(), a5, a6};
        a7 = new StructureTerm(f2, h3);
        p1 = new Predicates.Once_1(a7, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class OoSearchIterateClasses_6_4 : OoSearchIterateClasses_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("oo_search_iterate_classes_inner", 6);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {a1, a2, a3, a4, a5, a6};
        a7 = new StructureTerm(f1, h2);
        return new Predicates.Once_1(a7, cont);
    }
}
}

