/*
 * *** Please do not edit ! ***
 * @(#) OoSearch_6.cs
 * @procedure oo_search/6 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class OoSearch_6 : Predicate {
    static internal readonly Predicate OoSearch_6_1 = new Predicates.OoSearch_6_1();
    static internal readonly Predicate OoSearch_6_2 = new Predicates.OoSearch_6_2();
    static internal readonly Predicate OoSearch_6_3 = new Predicates.OoSearch_6_3();
    static internal readonly Predicate OoSearch_6_4 = new Predicates.OoSearch_6_4();
    static internal readonly Predicate OoSearch_6_5 = new Predicates.OoSearch_6_5();
    static internal readonly Predicate OoSearch_6_6 = new Predicates.OoSearch_6_6();
    static internal readonly Predicate OoSearch_6_7 = new Predicates.OoSearch_6_7();
    static internal readonly Predicate OoSearch_6_8 = new Predicates.OoSearch_6_8();
    static internal readonly Predicate OoSearch_6_sub_1 = new Predicates.OoSearch_6_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public OoSearch_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public OoSearch_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(OoSearch_6_1, OoSearch_6_sub_1);
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "oo_search(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class OoSearch_6_sub_1 : OoSearch_6 {
    static internal readonly Predicate OoSearch_6_sub_2 = new Predicates.OoSearch_6_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearch_6_2, OoSearch_6_sub_2);
    }
}

sealed class OoSearch_6_sub_2 : OoSearch_6 {
    static internal readonly Predicate OoSearch_6_sub_3 = new Predicates.OoSearch_6_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearch_6_3, OoSearch_6_sub_3);
    }
}

sealed class OoSearch_6_sub_3 : OoSearch_6 {
    static internal readonly Predicate OoSearch_6_sub_4 = new Predicates.OoSearch_6_sub_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearch_6_4, OoSearch_6_sub_4);
    }
}

sealed class OoSearch_6_sub_4 : OoSearch_6 {
    static internal readonly Predicate OoSearch_6_sub_5 = new Predicates.OoSearch_6_sub_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearch_6_5, OoSearch_6_sub_5);
    }
}

sealed class OoSearch_6_sub_5 : OoSearch_6 {
    static internal readonly Predicate OoSearch_6_sub_6 = new Predicates.OoSearch_6_sub_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearch_6_6, OoSearch_6_sub_6);
    }
}

sealed class OoSearch_6_sub_6 : OoSearch_6 {
    static internal readonly Predicate OoSearch_6_sub_7 = new Predicates.OoSearch_6_sub_7();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(OoSearch_6_7, OoSearch_6_sub_7);
    }
}

sealed class OoSearch_6_sub_7 : OoSearch_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(OoSearch_6_8);
    }
}

sealed class OoSearch_6_1 : OoSearch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("meth_args");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.OoSearchMethArgs_5(a1, a2, a3, a5, a6, cont);
    }
}

sealed class OoSearch_6_2 : OoSearch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("meth_exact_args");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.OoSearchMethExactArgs_5(a1, a2, a3, a5, a6, cont);
    }
}

sealed class OoSearch_6_3 : OoSearch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("meth_exact_ordered_args");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.OoSearchMethExactOrderedArgs_5(a1, a2, a3, a5, a6, cont);
    }
}

sealed class OoSearch_6_4 : OoSearch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("meth_return");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.OoSearchMethReturn_5(a1, a2, a3, a5, a6, cont);
    }
}

sealed class OoSearch_6_5 : OoSearch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("field_type");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.OoSearchFieldType_5(a1, a2, a3, a5, a6, cont);
    }
}

sealed class OoSearch_6_6 : OoSearch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("class_defines");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.OoSearchClassDefines_4(a1, a2, a5, a6, cont);
    }
}

sealed class OoSearch_6_7 : OoSearch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("class_superclass");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.OoSearchClassSuperclass_2(a5, a6, cont);
    }
}

sealed class OoSearch_6_8 : OoSearch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("class_direct_subclasses");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.OoSearchClassDirectSubclasses_2(a5, a6, cont);
    }
}
}

