/*
 * *** Please do not edit ! ***
 * @(#) ReachedEnd_0.cs
 * @procedure reached_end/0 in search.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ReachedEnd_0 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("limit", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("limit_count", 1);

    public ReachedEnd_0(Predicate cont) {
        this.cont = cont;
    }

    public ReachedEnd_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2;

        a2 = engine.makeVariable();
        Term[] h2 = {a2};
        a1 = new StructureTerm(f1, h2);
        a4 = engine.makeVariable();
        Term[] h4 = {a4};
        a3 = new StructureTerm(f3, h4);
        p1 = new Predicates.dollar_equalityOfTerm_2(a4, a2, cont);
        p2 = new Predicates.GlobalCall_1(a3, p1);
        return new Predicates.GlobalCall_1(a1, p2);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "reached_end";
    }
}
}

