/*
 * *** Please do not edit ! ***
 * @(#) DrawLabel_4.cs
 * @procedure draw_label/4 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DrawLabel_4 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("extent", 3);
    static internal readonly IntegerTerm s2 = new IntegerTerm(5);
    static internal readonly IntegerTerm s3 = new IntegerTerm(-20);
    static internal readonly IntegerTerm s4 = new IntegerTerm(20);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("draw_label", 3);

    public Term arg1, arg2, arg3, arg4;

    public DrawLabel_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public DrawLabel_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a5 = args[0];
            a6 = args[1];
            if ( !s2.unify(args[2],  engine.trail) )
                return engine.fail();
        } else if (a4.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6, s2};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        Term[] h6 = {a1, a2, a3};
        a8 = new StructureTerm(f5, h6);
        p1 = new Predicates.dollar_csMethod_3(a7, a8, engine.makeVariable(), cont);
        p2 = new Predicates.Form1_1(a7, p1);
        p3 = new Predicates.RealInt_2(s4, a6, p2);
        return new Predicates.RealInt_2(s3, a5, p3);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "draw_label(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

