/*
 * *** Please do not edit ! ***
 * @(#) DrawTree_2.cs
 * @procedure draw_tree/2 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class DrawTree_2 : Predicate {
    static internal readonly Predicate DrawTree_2_1 = new Predicates.DrawTree_2_1();
    static internal readonly Predicate DrawTree_2_2 = new Predicates.DrawTree_2_2();
    static internal readonly Predicate DrawTree_2_sub_1 = new Predicates.DrawTree_2_sub_1();

    public Term arg1, arg2;

    public DrawTree_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public DrawTree_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(DrawTree_2_1, DrawTree_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "draw_tree(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class DrawTree_2_sub_1 : DrawTree_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(DrawTree_2_2);
    }
}

sealed class DrawTree_2_1 : DrawTree_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("keep_going");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("extentf");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("pair", 2);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("extent", 3);
    static internal readonly IntegerTerm s7 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        Term[] h4 = {a5, a6};
        a4 = new StructureTerm(f3, h4);
        a8 = engine.makeVariable();
        Term[] h6 = {a8, engine.makeVariable(), engine.makeVariable()};
        a7 = new StructureTerm(f5, h6);
        a9 = engine.makeVariable();
        p1 = new Predicates.EndInvokes_0(cont);
        p2 = new Predicates.Draw2_5(a9, s7, a6, a5, engine.makeVariable(), p1);
        p3 = new Predicates.GlobalCall_1(s1, p2);
        p4 = new Predicates.RealNeg_2(a8, a9, p3);
        p5 = new Predicates.dollar_cut_1(a3, p4);
        p6 = new Predicates.CollapseExtent_2(a6, a7, p5);
        p7 = new Predicates.Design_3(a2, s2, a4, p6);
        p8 = new Predicates.GlobalCall_1(s1, p7);
        return new Predicates.dollar_getLevel_1(a3, p8);
    }
}

sealed class DrawTree_2_2 : DrawTree_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("lock");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        p1 = new Predicates.dollar_abort_0(cont);
        p2 = new Predicates.Unlock_1(s1, p1);
        return new Predicates.dollar_dummyMltoprolog__4_0(p2);
    }
}
}

