/*
 * *** Please do not edit ! ***
 * @(#) FitlistrPrime_3.cs
 * @procedure fitlistr_prime/3 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class FitlistrPrime_3 : Predicate {
    static internal readonly Predicate FitlistrPrime_3_1 = new Predicates.FitlistrPrime_3_1();
    static internal readonly Predicate FitlistrPrime_3_2 = new Predicates.FitlistrPrime_3_2();
    static internal readonly Predicate FitlistrPrime_3_sub_1 = new Predicates.FitlistrPrime_3_sub_1();

    public Term arg1, arg2, arg3;

    public FitlistrPrime_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public FitlistrPrime_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(FitlistrPrime_3_1, FitlistrPrime_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "fitlistr_prime(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class FitlistrPrime_3_sub_1 : FitlistrPrime_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(FitlistrPrime_3_2);
    }
}

sealed class FitlistrPrime_3_1 : FitlistrPrime_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class FitlistrPrime_3_2 : FitlistrPrime_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a4 = ((ListTerm)a2).car;
            a5 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            a6 = ((ListTerm)a3).car;
            a7 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        p1 = new Predicates.FitlistrPrime_3(a11, a5, a7, cont);
        p2 = new Predicates.Merge_3(a10, a1, a11, p1);
        p3 = new Predicates.Moveextent_3(a4, a6, a10, p2);
        p4 = new Predicates.RealDiff_3(a9, a8, a6, p3);
        p5 = new Predicates.RealInt_2(s1, a9, p4);
        return new Predicates.Fit_3(a4, a1, a8, p5);
    }
}
}

