/*
 * *** Please do not edit ! ***
 * @(#) ListpairMap_4.cs
 * @procedure listpair_map/4 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ListpairMap_4 : Predicate {
    static internal readonly Predicate ListpairMap_4_1 = new Predicates.ListpairMap_4_1();
    static internal readonly Predicate ListpairMap_4_2 = new Predicates.ListpairMap_4_2();
    static internal readonly Predicate ListpairMap_4_sub_1 = new Predicates.ListpairMap_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public ListpairMap_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public ListpairMap_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(ListpairMap_4_1, ListpairMap_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "listpair_map(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class ListpairMap_4_sub_1 : ListpairMap_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(ListpairMap_4_2);
    }
}

sealed class ListpairMap_4_1 : ListpairMap_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class ListpairMap_4_2 : ListpairMap_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a5 = ((ListTerm)a2).car;
            a6 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            a7 = ((ListTerm)a3).car;
            a8 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isList() ){
            a9 = ((ListTerm)a4).car;
            a10 = ((ListTerm)a4).cdr;
        } else if ( a4.isVariable() ){
            a9 = engine.makeVariable();
            a10 = engine.makeVariable();
            if ( !a4.unify(new ListTerm(a9, a10), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a11 = engine.makeVariable();
        a15 = new ListTerm(a9, s1);
        a14 = new ListTerm(a7, a15);
        a13 = new ListTerm(a5, a14);
        a12 = new ListTerm(a1, a13);
        p1 = new Predicates.ListpairMap_4(a1, a6, a8, a10, cont);
        p2 = new Predicates.dollar_call_1(a11, p1);
        return new Predicates.eq_stop_stop_2(a11, a12, p2);
    }
}
}

