/*
 * *** Please do not edit ! ***
 * @(#) LoadAndPrime_1.cs
 * @procedure load_and_prime/1 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class LoadAndPrime_1 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("load_and_prime_thread", 1);

    public Term arg1;

    public LoadAndPrime_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public LoadAndPrime_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        a1 = arg1.dereference();

        Term[] h2 = {a1};
        a2 = new StructureTerm(f1, h2);
        return new Predicates.Fork_1(a2, cont);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "load_and_prime(" + arg1 + ")";
    }
}
}

