/*
 * *** Please do not edit ! ***
 * @(#) Mergelist_2.cs
 * @procedure mergelist/2 in mltoprolog.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Mergelist_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("merge");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public Term arg1, arg2;

    public Mergelist_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Mergelist_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        return new Predicates.Foldr_4(s1, s2, a1, a2, cont);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "mergelist(" + arg1 + ", " + arg2 + ")";
    }
}
}

