/*
 * *** Please do not edit ! ***
 * @(#) dollar_callSpin_2.cs
 * @procedure $call_spin/2 in built.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_callSpin_2 : Predicate {
    static internal readonly Predicate dollar_callSpin_2_1 = new Predicates.dollar_callSpin_2_1();
    static internal readonly Predicate dollar_callSpin_2_2 = new Predicates.dollar_callSpin_2_2();
    static internal readonly Predicate dollar_callSpin_2_sub_1 = new Predicates.dollar_callSpin_2_sub_1();

    public Term arg1, arg2;

    public dollar_callSpin_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_callSpin_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_callSpin_2_1, dollar_callSpin_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$call_spin(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_callSpin_2_sub_1 : dollar_callSpin_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_callSpin_2_2);
    }
}

sealed class dollar_callSpin_2_1 : dollar_callSpin_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$msg", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        Term[] h2 = {a2, a4};
        a3 = new StructureTerm(f1, h2);
        Term[] h3 = {a2, a4};
        a5 = new StructureTerm(f1, h3);
        p1 = new Predicates.dollar_protectedUnify_2(a1, a4, cont);
        p2 = new Predicates.GlobalRetract_1(a5, p1);
        return new Predicates.GlobalCall_1(a3, p2);
    }
}

sealed class dollar_callSpin_2_2 : dollar_callSpin_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        p1 = new Predicates.dollar_callSpin_2(a1, a2, cont);
        return new Predicates.dollar_waitOn_1(a2, p1);
    }
}
}

