/*
 * *** Please do not edit ! ***
 * @(#) dollar_findall_4.cs
 * @procedure $findall/4 in built.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_findall_4 : Predicate {
    static internal readonly Predicate dollar_findall_4_1 = new Predicates.dollar_findall_4_1();
    static internal readonly Predicate dollar_findall_4_2 = new Predicates.dollar_findall_4_2();
    static internal readonly Predicate dollar_findall_4_sub_1 = new Predicates.dollar_findall_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public dollar_findall_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_findall_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_findall_4_1, dollar_findall_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$findall(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_findall_4_sub_1 : dollar_findall_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_findall_4_2);
    }
}

sealed class dollar_findall_4_1 : dollar_findall_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("all");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        a5 = engine.makeVariable();
        a6 = new ListTerm(a2, a5);
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_putTerm_3(a1, s1, a7, p1);
        p3 = new Predicates.dollar_copyTerm_2(a6, a7, p2);
        p4 = new Predicates.dollar_getTerm_3(a1, s1, a5, p3);
        return new Predicates.dollar_call_1(a3, p4);
    }
}

sealed class dollar_findall_4_2 : dollar_findall_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("all");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a5, cont);
        p2 = new Predicates.dollar_reverse_2(a7, a4, p1);
        p3 = new Predicates.dollar_copyTerm_2(a6, a7, p2);
        p4 = new Predicates.dollar_getTerm_3(a1, s1, a6, p3);
        return new Predicates.dollar_getLevel_1(a5, p4);
    }
}
}

