/*
 * *** Please do not edit ! ***
 * @(#) dollar_memberInReverse_2.cs
 * @procedure $member_in_reverse/2 in built.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_memberInReverse_2 : Predicate, FcoPredicate {
    static internal readonly System.Type EntryCodeType = typeof( dollar_memberInReverse_2 );
    static internal readonly Predicate dollar_memberInReverse_2_1 = new Predicates.dollar_memberInReverse_2_1();
    static internal readonly Predicate dollar_memberInReverse_2_2 = new Predicates.dollar_memberInReverse_2_2();
    static internal readonly Predicate dollar_memberInReverse_2_sub_1 = new Predicates.dollar_memberInReverse_2_sub_1();

    public Term arg1, arg2;

    public dollar_memberInReverse_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_memberInReverse_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.SetEntryCode( EntryCodeType, this );
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_memberInReverse_2_1, dollar_memberInReverse_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$member_in_reverse(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_memberInReverse_2_sub_1 : dollar_memberInReverse_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_memberInReverse_2_2);
    }
}

sealed class dollar_memberInReverse_2_1 : dollar_memberInReverse_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(engine.makeVariable(), a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a1;
        engine.aregs[2] = a3;
        engine.cont = cont;
        return engine.GetEntryCode( EntryCodeType ).call( engine );
    }
}

sealed class dollar_memberInReverse_2_2 : dollar_memberInReverse_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            if ( !a1.unify(((ListTerm)a2).car, engine.trail) )
                return engine.fail();
        } else if ( a2.isVariable() ){
            if ( !a2.unify(new ListTerm(a1, engine.makeVariable()), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return cont;
    }
}
}

