/*
 * *** Please do not edit ! ***
 * @(#) Findall_3.cs
 * @procedure findall/3 in built.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Findall_3 : Predicate {

    public Term arg1, arg2, arg3;

    public Findall_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public Findall_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_closeTable_1(a4, cont);
        p2 = new Predicates.dollar_findall_4(a4, a1, a2, a3, p1);
        return new Predicates.dollar_openTable_1(a4, p2);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "findall(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

