/*
 * *** Please do not edit ! ***
 * @(#) GlobalCall_1.cs
 * @procedure global_call/1 in built.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GlobalCall_1 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("clause", 3);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("$soln", 1);

    public Term arg1;

    public GlobalCall_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public GlobalCall_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        a4 = engine.makeVariable();
        Term[] h2 = {a2, a1, a4};
        a3 = new StructureTerm(f1, h2);
        Term[] h4 = {engine.makeVariable(), a1, a4};
        a6 = new StructureTerm(f1, h4);
        Term[] h5 = {a6};
        a5 = new StructureTerm(f3, h5);
        p1 = new Predicates.dollar_call_1(a4, cont);
        p2 = new Predicates.dollar_call_1(a5, p1);
        p3 = new Predicates.dollar_runOnGlobalEngine_1(a3, p2);
        return new Predicates.GlobalTable_1(a2, p3);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "global_call(" + arg1 + ")";
    }
}
}

