/*
 * *** Please do not edit ! ***
 * @(#) NumberChars_2.cs
 * @procedure number_chars/2 in built.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class NumberChars_2 : Predicate {
    static internal readonly Predicate NumberChars_2_1 = new Predicates.NumberChars_2_1();
    static internal readonly Predicate NumberChars_2_2 = new Predicates.NumberChars_2_2();
    static internal readonly Predicate NumberChars_2_3 = new Predicates.NumberChars_2_3();
    static internal readonly Predicate NumberChars_2_4 = new Predicates.NumberChars_2_4();
    static internal readonly Predicate NumberChars_2_5 = new Predicates.NumberChars_2_5();
    static internal readonly Predicate NumberChars_2_sub_1 = new Predicates.NumberChars_2_sub_1();

    public Term arg1, arg2;

    public NumberChars_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public NumberChars_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(NumberChars_2_1, NumberChars_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "number_chars(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class NumberChars_2_sub_1 : NumberChars_2 {
    static internal readonly Predicate NumberChars_2_sub_2 = new Predicates.NumberChars_2_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(NumberChars_2_2, NumberChars_2_sub_2);
    }
}

sealed class NumberChars_2_sub_2 : NumberChars_2 {
    static internal readonly Predicate NumberChars_2_sub_3 = new Predicates.NumberChars_2_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(NumberChars_2_3, NumberChars_2_sub_3);
    }
}

sealed class NumberChars_2_sub_3 : NumberChars_2 {
    static internal readonly Predicate NumberChars_2_sub_4 = new Predicates.NumberChars_2_sub_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(NumberChars_2_4, NumberChars_2_sub_4);
    }
}

sealed class NumberChars_2_sub_4 : NumberChars_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(NumberChars_2_5);
    }
}

sealed class NumberChars_2_1 : NumberChars_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_numberChars_2(a1, a2, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.Number_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class NumberChars_2_2 : NumberChars_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("type", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("number");
    static internal readonly Term[] h7 = {s2};
    static internal readonly StructureTerm s3 = new StructureTerm(f1, h7);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("number_chars", 2);
    static internal readonly IntegerTerm s6 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        Term[] h5 = {a1, a2};
        a4 = new StructureTerm(f4, h5);
        p1 = new Predicates.dollar_illarg_3(s3, a4, s6, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_nonvar_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class NumberChars_2_3 : NumberChars_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a1, a4, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_numberChars_2(a4, a2, p2);
        p4 = new Predicates.dollar_var_1(a1, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class NumberChars_2_4 : NumberChars_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_atomChars_2(engine.makeVariable(), a2, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class NumberChars_2_5 : NumberChars_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("type", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("list", 1);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("char");
    static internal readonly Term[] h9 = {s3};
    static internal readonly StructureTerm s4 = new StructureTerm(f2, h9);
    static internal readonly Term[] h10 = {s4};
    static internal readonly StructureTerm s5 = new StructureTerm(f1, h10);
    static internal readonly SymbolTerm f6 = SymbolTerm.makeSymbol("number_chars", 2);
    static internal readonly IntegerTerm s8 = new IntegerTerm(2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        Term[] h7 = {a1, a2};
        a3 = new StructureTerm(f6, h7);
        return new Predicates.dollar_illarg_3(s5, a3, s8, cont);
    }
}
}

