/*
 * *** Please do not edit ! ***
 * @(#) Retract_2.cs
 * @procedure retract/2 in built.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Retract_2 : Predicate {

    public Term arg1, arg2;

    public Retract_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Retract_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4, p5;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_putTerm_3(a1, a3, a8, cont);
        p2 = new Predicates.dollar_unify_2(a7, a4, p1);
        p3 = new Predicates.dollar_selectInReverse_3(a7, a6, a8, p2);
        p4 = new Predicates.dollar_copyTerm_2(a5, a6, p3);
        p5 = new Predicates.dollar_getTerm_3(a1, a3, a5, p4);
        return new Predicates.dollar_canonicalClause_3(a2, a3, a4, p5);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "retract(" + arg1 + ", " + arg2 + ")";
    }
}
}

