/*
 * *** Please do not edit ! ***
 * @(#) Retractall_2.cs
 * @procedure retractall/2 in built.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Retractall_2 : Predicate {
    static internal readonly Predicate Retractall_2_1 = new Predicates.Retractall_2_1();
    static internal readonly Predicate Retractall_2_2 = new Predicates.Retractall_2_2();
    static internal readonly Predicate Retractall_2_sub_1 = new Predicates.Retractall_2_sub_1();

    public Term arg1, arg2;

    public Retractall_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Retractall_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(Retractall_2_1, Retractall_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "retractall(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class Retractall_2_sub_1 : Retractall_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(Retractall_2_2);
    }
}

sealed class Retractall_2_1 : Retractall_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h2 = {a4, a5};
        a6 = new StructureTerm(f1, h2);
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        Term[] h3 = {a4, a5};
        a10 = new StructureTerm(f1, h3);
        p1 = new Predicates.dollar_putTerm_3(a1, a10, a9, cont);
        p2 = new Predicates.dollar_retractall_3(a2, a8, a9, p1);
        p3 = new Predicates.dollar_copyTerm_2(a7, a8, p2);
        p4 = new Predicates.dollar_getTerm_3(a1, a6, a7, p3);
        p5 = new Predicates.dollar_functor_3(a2, a4, a5, p4);
        p6 = new Predicates.dollar_cut_1(a3, p5);
        p7 = new Predicates.dollar_nonvar_1(a2, p6);
        return new Predicates.dollar_getLevel_1(a3, p7);
    }
}

sealed class Retractall_2_2 : Retractall_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("var");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("retractall", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        Term[] h3 = {a1, a2};
        a3 = new StructureTerm(f2, h3);
        return new Predicates.dollar_illarg_3(s1, a3, s4, cont);
    }
}
}

