/*
 * *** Please do not edit ! ***
 * @(#) dollar_parseTokensError1_2.cs
 * @procedure $parse_tokens_error1/2 in inout.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_parseTokensError1_2 : Predicate {
    static internal readonly Predicate dollar_parseTokensError1_2_1 = new Predicates.dollar_parseTokensError1_2_1();
    static internal readonly Predicate dollar_parseTokensError1_2_2 = new Predicates.dollar_parseTokensError1_2_2();
    static internal readonly Predicate dollar_parseTokensError1_2_3 = new Predicates.dollar_parseTokensError1_2_3();
    static internal readonly Predicate dollar_parseTokensError1_2_con = new Predicates.dollar_parseTokensError1_2_con();
    static internal readonly Predicate dollar_parseTokensError1_2_lis = new Predicates.dollar_parseTokensError1_2_lis();
    static internal readonly Predicate dollar_parseTokensError1_2_var = new Predicates.dollar_parseTokensError1_2_var();

    public Term arg1, arg2;

    public dollar_parseTokensError1_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_parseTokensError1_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_parseTokensError1_2_var,
                                   dollar_parseTokensError1_2_2,
                                   dollar_parseTokensError1_2_con,
                                   dollar_parseTokensError1_2_2,
                                   dollar_parseTokensError1_2_lis
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$parse_tokens_error1(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_parseTokensError1_2_var : dollar_parseTokensError1_2 {
    static internal readonly Predicate dollar_parseTokensError1_2_var_1 = new Predicates.dollar_parseTokensError1_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_parseTokensError1_2_1, dollar_parseTokensError1_2_var_1);
    }
}

sealed class dollar_parseTokensError1_2_var_1 : dollar_parseTokensError1_2 {
    static internal readonly Predicate dollar_parseTokensError1_2_var_2 = new Predicates.dollar_parseTokensError1_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_parseTokensError1_2_2, dollar_parseTokensError1_2_var_2);
    }
}

sealed class dollar_parseTokensError1_2_var_2 : dollar_parseTokensError1_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_parseTokensError1_2_3);
    }
}

sealed class dollar_parseTokensError1_2_con : dollar_parseTokensError1_2 {
    static internal readonly Predicate dollar_parseTokensError1_2_con_1 = new Predicates.dollar_parseTokensError1_2_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_parseTokensError1_2_1, dollar_parseTokensError1_2_con_1);
    }
}

sealed class dollar_parseTokensError1_2_con_1 : dollar_parseTokensError1_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_parseTokensError1_2_2);
    }
}

sealed class dollar_parseTokensError1_2_lis : dollar_parseTokensError1_2 {
    static internal readonly Predicate dollar_parseTokensError1_2_lis_1 = new Predicates.dollar_parseTokensError1_2_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_parseTokensError1_2_2, dollar_parseTokensError1_2_lis_1);
    }
}

sealed class dollar_parseTokensError1_2_lis_1 : dollar_parseTokensError1_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_parseTokensError1_2_3);
    }
}

sealed class dollar_parseTokensError1_2_1 : dollar_parseTokensError1_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_parseTokensError1_2_2 : dollar_parseTokensError1_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("** here **");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.dollar_parseTokensError1_2(a1, s2, p1);
        p3 = new Predicates.dollar_nl_0(p2);
        p4 = new Predicates.Write_1(s1, p3);
        p5 = new Predicates.dollar_nl_0(p4);
        p6 = new Predicates.dollar_cut_1(a3, p5);
        p7 = new Predicates.dollar_equalityOfTerm_2(a1, a2, p6);
        return new Predicates.dollar_getLevel_1(a3, p7);
    }
}

sealed class dollar_parseTokensError1_2_3 : dollar_parseTokensError1_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_parseTokensError1_2(a4, a2, cont);
        return new Predicates.dollar_parseTokensError2_1(a3, p1);
    }
}
}

