/*
 * *** Please do not edit ! ***
 * @(#) dollar_parseTokensError_3.cs
 * @procedure $parse_tokens_error/3 in inout.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_parseTokensError_3 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("SYNTAX ERROR");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("** ");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(" **");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");

    public Term arg1, arg2, arg3;

    public dollar_parseTokensError_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_parseTokensError_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_parseTokensError1_2(a4, a2, p1);
        p3 = new Predicates.dollar_tokens_1(a4, p2);
        p4 = new Predicates.dollar_parseTokensError1_2(s4, a2, p3);
        p5 = new Predicates.dollar_nl_0(p4);
        p6 = new Predicates.Write_1(s3, p5);
        p7 = new Predicates.dollar_parseTokensWriteMessage_1(a1, p6);
        p8 = new Predicates.Write_1(s2, p7);
        p9 = new Predicates.dollar_nl_0(p8);
        return new Predicates.Write_1(s1, p9);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$parse_tokens_error(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

