/*
 * *** Please do not edit ! ***
 * @(#) dollar_parseTokens1_5.cs
 * @procedure $parse_tokens1/5 in inout.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_parseTokens1_5 : Predicate {
    static internal readonly Predicate dollar_parseTokens1_5_1 = new Predicates.dollar_parseTokens1_5_1();
    static internal readonly Predicate dollar_parseTokens1_5_2 = new Predicates.dollar_parseTokens1_5_2();
    static internal readonly Predicate dollar_parseTokens1_5_sub_1 = new Predicates.dollar_parseTokens1_5_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_parseTokens1_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_parseTokens1_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_parseTokens1_5_1, dollar_parseTokens1_5_sub_1);
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$parse_tokens1(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_parseTokens1_5_sub_1 : dollar_parseTokens1_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_parseTokens1_5_2);
    }
}

sealed class dollar_parseTokens1_5_1 : dollar_parseTokens1_5 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_parseTokensBeforeOp_5(a1, a2, a3, a8, a5, cont);
        p2 = new Predicates.dollar_cut_1(a6, p1);
        p3 = new Predicates.dollar_parseTokensIsStarter_1(a7, p2);
        p4 = new Predicates.dollar_parseTokensPeepNext_3(a7, a4, a8, p3);
        return new Predicates.dollar_getLevel_1(a6, p4);
    }
}

sealed class dollar_parseTokens1_5_2 : dollar_parseTokens1_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("cannot");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("start");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("an");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("expression");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);
    static internal readonly ListTerm s7 = new ListTerm(s3, s6);
    static internal readonly ListTerm s8 = new ListTerm(s2, s7);
    static internal readonly ListTerm s9 = new ListTerm(s1, s8);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = new ListTerm(a6, s9);
        p1 = new Predicates.dollar_parseTokensError_3(a8, a7, a5, cont);
        return new Predicates.dollar_parseTokensPeepNext_3(a6, a4, a7, p1);
    }
}
}

