/*
 * *** Please do not edit ! ***
 * @(#) dollar_readint1_3.cs
 * @procedure $readint1/3 in inout.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_readint1_3 : Predicate {
    static internal readonly Predicate dollar_readint1_3_1 = new Predicates.dollar_readint1_3_1();
    static internal readonly Predicate dollar_readint1_3_2 = new Predicates.dollar_readint1_3_2();
    static internal readonly Predicate dollar_readint1_3_3 = new Predicates.dollar_readint1_3_3();
    static internal readonly Predicate dollar_readint1_3_con = new Predicates.dollar_readint1_3_con();
    static internal readonly Predicate dollar_readint1_3_lis = new Predicates.dollar_readint1_3_lis();
    static internal readonly Predicate dollar_readint1_3_str = new Predicates.dollar_readint1_3_str();
    static internal readonly Predicate dollar_readint1_3_var = new Predicates.dollar_readint1_3_var();

    public Term arg1, arg2, arg3;

    public dollar_readint1_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_readint1_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_readint1_3_var,
                                   dollar_readint1_3_var,
                                   dollar_readint1_3_con,
                                   dollar_readint1_3_str,
                                   dollar_readint1_3_lis
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$readint1(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_readint1_3_var : dollar_readint1_3 {
    static internal readonly Predicate dollar_readint1_3_var_1 = new Predicates.dollar_readint1_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_readint1_3_1, dollar_readint1_3_var_1);
    }
}

sealed class dollar_readint1_3_var_1 : dollar_readint1_3 {
    static internal readonly Predicate dollar_readint1_3_var_2 = new Predicates.dollar_readint1_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readint1_3_2, dollar_readint1_3_var_2);
    }
}

sealed class dollar_readint1_3_var_2 : dollar_readint1_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_readint1_3_3);
    }
}

sealed class dollar_readint1_3_con : dollar_readint1_3 {
    static internal readonly Predicate dollar_readint1_3_con_1 = new Predicates.dollar_readint1_3_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_readint1_3_1, dollar_readint1_3_con_1);
    }
}

sealed class dollar_readint1_3_con_1 : dollar_readint1_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_readint1_3_3);
    }
}

sealed class dollar_readint1_3_str : dollar_readint1_3 {
    static internal readonly Predicate dollar_readint1_3_str_1 = new Predicates.dollar_readint1_3_str_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_readint1_3_1, dollar_readint1_3_str_1);
    }
}

sealed class dollar_readint1_3_str_1 : dollar_readint1_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_readint1_3_3);
    }
}

sealed class dollar_readint1_3_lis : dollar_readint1_3 {
    static internal readonly Predicate dollar_readint1_3_lis_1 = new Predicates.dollar_readint1_3_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_readint1_3_1, dollar_readint1_3_lis_1);
    }
}

sealed class dollar_readint1_3_lis_1 : dollar_readint1_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_readint1_3_3);
    }
}

sealed class dollar_readint1_3_1 : dollar_readint1_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(48);
    static internal readonly IntegerTerm s2 = new IntegerTerm(57);
    static internal readonly IntegerTerm s3 = new IntegerTerm(10);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_readint1_3(a8, a7, a3, cont);
        p2 = new Predicates.dollar_get0_1(a8, p1);
        p3 = new Predicates.dollar_minus_3(a6, s1, a7, p2);
        p4 = new Predicates.dollar_plus_3(a5, a1, a6, p3);
        p5 = new Predicates.dollar_multi_3(s3, a2, a5, p4);
        p6 = new Predicates.dollar_cut_1(a4, p5);
        p7 = new Predicates.dollar_lessOrEqual_2(a1, s2, p6);
        p8 = new Predicates.dollar_greaterOrEqual_2(a1, s1, p7);
        return new Predicates.dollar_getLevel_1(a4, p8);
    }
}

sealed class dollar_readint1_3_2 : dollar_readint1_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(10);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_readint1_3_3 : dollar_readint1_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(10);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        p1 = new Predicates.Skip_1(s1, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}
}

