/*
 * *** Please do not edit ! ***
 * @(#) Display_1.cs
 * @procedure display/1 in inout.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Display_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("user");

    public Term arg1;

    public Display_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Display_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_setOutput_1(a2, cont);
        p2 = new Predicates.dollar_display_1(a1, p1);
        p3 = new Predicates.dollar_setOutput_1(s1, p2);
        return new Predicates.dollar_currentOutput_1(a2, p3);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "display(" + arg1 + ")";
    }
}
}

