/*
 * *** Please do not edit ! ***
 * @(#) PeekChar_2.cs
 * @procedure peek_char/2 in inout.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class PeekChar_2 : Predicate {
    static internal readonly Predicate PeekChar_2_1 = new Predicates.PeekChar_2_1();
    static internal readonly Predicate PeekChar_2_2 = new Predicates.PeekChar_2_2();
    static internal readonly Predicate PeekChar_2_sub_1 = new Predicates.PeekChar_2_sub_1();

    public Term arg1, arg2;

    public PeekChar_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public PeekChar_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(PeekChar_2_1, PeekChar_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "peek_char(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class PeekChar_2_sub_1 : PeekChar_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(PeekChar_2_2);
    }
}

sealed class PeekChar_2_1 : PeekChar_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a2, a4, cont);
        p2 = new Predicates.dollar_unget_2(a1, a4, p1);
        p3 = new Predicates.dollar_cut_1(a3, p2);
        p4 = new Predicates.dollar_get0_2(a1, a4, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class PeekChar_2_2 : PeekChar_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("type", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("stream");
    static internal readonly Term[] h7 = {s2};
    static internal readonly StructureTerm s3 = new StructureTerm(f1, h7);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("peek_char", 2);
    static internal readonly IntegerTerm s6 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        Term[] h5 = {a1, a2};
        a3 = new StructureTerm(f4, h5);
        return new Predicates.dollar_illarg_3(s3, a3, s6, cont);
    }
}
}

