/*
 * *** Please do not edit ! ***
 * @(#) ReadWithVariables_2.cs
 * @procedure read_with_variables/2 in inout.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ReadWithVariables_2 : Predicate {

    public Term arg1, arg2;

    public ReadWithVariables_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public ReadWithVariables_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a3, cont);
        p2 = new Predicates.ParseTokens_2(a1, a4, p1);
        p3 = new Predicates.ReadTokens_2(a4, a2, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "read_with_variables(" + arg1 + ", " + arg2 + ")";
    }
}
}

