/*
 * *** Please do not edit ! ***
 * @(#) dollar_cafeExec_2.cs
 * @procedure $cafe_exec/2 in interpreter.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_cafeExec_2 : Predicate {
    static internal readonly Predicate dollar_cafeExec_2_1 = new Predicates.dollar_cafeExec_2_1();
    static internal readonly Predicate dollar_cafeExec_2_2 = new Predicates.dollar_cafeExec_2_2();
    static internal readonly Predicate dollar_cafeExec_2_sub_1 = new Predicates.dollar_cafeExec_2_sub_1();

    public Term arg1, arg2;

    public dollar_cafeExec_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_cafeExec_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_cafeExec_2_1, dollar_cafeExec_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$cafe_exec(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_cafeExec_2_sub_1 : dollar_cafeExec_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_cafeExec_2_2);
    }
}

sealed class dollar_cafeExec_2_1 : dollar_cafeExec_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.dollar_dummyInterpreter__1_1(a1, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_cafeExec_2_2 : dollar_cafeExec_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol(" ? ");
    static internal readonly IntegerTerm s2 = new IntegerTerm(59);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s4 = new ListTerm(s2, s3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.dollar_inequalityOfTerm_2(a3, s4, p1);
        p3 = new Predicates.Readline_1(a3, p2);
        p4 = new Predicates.dollar_flushOutput_0(p3);
        p5 = new Predicates.Write_1(s1, p4);
        p6 = new Predicates.dollar_cafeWriteResult_1(a2, p5);
        p7 = new Predicates.dollar_nl_0(p6);
        return new Predicates.dollar_dummyInterpreter__2_1(a1, p7);
    }
}
}

