/*
 * *** Please do not edit ! ***
 * @(#) dollar_cafeExecute_2.cs
 * @procedure $cafe_execute/2 in interpreter.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_cafeExecute_2 : Predicate {
    static internal readonly Predicate dollar_cafeExecute_2_1 = new Predicates.dollar_cafeExecute_2_1();
    static internal readonly Predicate dollar_cafeExecute_2_2 = new Predicates.dollar_cafeExecute_2_2();
    static internal readonly Predicate dollar_cafeExecute_2_3 = new Predicates.dollar_cafeExecute_2_3();
    static internal readonly Predicate dollar_cafeExecute_2_4 = new Predicates.dollar_cafeExecute_2_4();
    static internal readonly Predicate dollar_cafeExecute_2_5 = new Predicates.dollar_cafeExecute_2_5();
    static internal readonly Predicate dollar_cafeExecute_2_6 = new Predicates.dollar_cafeExecute_2_6();
    static internal readonly Predicate dollar_cafeExecute_2_con = new Predicates.dollar_cafeExecute_2_con();
    static internal readonly Predicate dollar_cafeExecute_2_int = new Predicates.dollar_cafeExecute_2_int();
    static internal readonly Predicate dollar_cafeExecute_2_lis = new Predicates.dollar_cafeExecute_2_lis();
    static internal readonly Predicate dollar_cafeExecute_2_str = new Predicates.dollar_cafeExecute_2_str();
    static internal readonly Predicate dollar_cafeExecute_2_var = new Predicates.dollar_cafeExecute_2_var();

    public Term arg1, arg2;

    public dollar_cafeExecute_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_cafeExecute_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_cafeExecute_2_var,
                                   dollar_cafeExecute_2_int,
                                   dollar_cafeExecute_2_con,
                                   dollar_cafeExecute_2_str,
                                   dollar_cafeExecute_2_lis
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$cafe_execute(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_cafeExecute_2_var : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_var_1 = new Predicates.dollar_cafeExecute_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_cafeExecute_2_1, dollar_cafeExecute_2_var_1);
    }
}

sealed class dollar_cafeExecute_2_var_1 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_var_2 = new Predicates.dollar_cafeExecute_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_2, dollar_cafeExecute_2_var_2);
    }
}

sealed class dollar_cafeExecute_2_var_2 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_var_3 = new Predicates.dollar_cafeExecute_2_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_3, dollar_cafeExecute_2_var_3);
    }
}

sealed class dollar_cafeExecute_2_var_3 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_var_4 = new Predicates.dollar_cafeExecute_2_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_4, dollar_cafeExecute_2_var_4);
    }
}

sealed class dollar_cafeExecute_2_var_4 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_var_5 = new Predicates.dollar_cafeExecute_2_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_5, dollar_cafeExecute_2_var_5);
    }
}

sealed class dollar_cafeExecute_2_var_5 : dollar_cafeExecute_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_cafeExecute_2_6);
    }
}

sealed class dollar_cafeExecute_2_int : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_int_1 = new Predicates.dollar_cafeExecute_2_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_cafeExecute_2_1, dollar_cafeExecute_2_int_1);
    }
}

sealed class dollar_cafeExecute_2_int_1 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_int_2 = new Predicates.dollar_cafeExecute_2_int_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_5, dollar_cafeExecute_2_int_2);
    }
}

sealed class dollar_cafeExecute_2_int_2 : dollar_cafeExecute_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_cafeExecute_2_6);
    }
}

sealed class dollar_cafeExecute_2_con : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_con_1 = new Predicates.dollar_cafeExecute_2_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_cafeExecute_2_1, dollar_cafeExecute_2_con_1);
    }
}

sealed class dollar_cafeExecute_2_con_1 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_con_2 = new Predicates.dollar_cafeExecute_2_con_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_2, dollar_cafeExecute_2_con_2);
    }
}

sealed class dollar_cafeExecute_2_con_2 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_con_3 = new Predicates.dollar_cafeExecute_2_con_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_4, dollar_cafeExecute_2_con_3);
    }
}

sealed class dollar_cafeExecute_2_con_3 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_con_4 = new Predicates.dollar_cafeExecute_2_con_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_5, dollar_cafeExecute_2_con_4);
    }
}

sealed class dollar_cafeExecute_2_con_4 : dollar_cafeExecute_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_cafeExecute_2_6);
    }
}

sealed class dollar_cafeExecute_2_str : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_str_1 = new Predicates.dollar_cafeExecute_2_str_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_cafeExecute_2_1, dollar_cafeExecute_2_str_1);
    }
}

sealed class dollar_cafeExecute_2_str_1 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_str_2 = new Predicates.dollar_cafeExecute_2_str_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_5, dollar_cafeExecute_2_str_2);
    }
}

sealed class dollar_cafeExecute_2_str_2 : dollar_cafeExecute_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_cafeExecute_2_6);
    }
}

sealed class dollar_cafeExecute_2_lis : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_lis_1 = new Predicates.dollar_cafeExecute_2_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_cafeExecute_2_1, dollar_cafeExecute_2_lis_1);
    }
}

sealed class dollar_cafeExecute_2_lis_1 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_lis_2 = new Predicates.dollar_cafeExecute_2_lis_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_3, dollar_cafeExecute_2_lis_2);
    }
}

sealed class dollar_cafeExecute_2_lis_2 : dollar_cafeExecute_2 {
    static internal readonly Predicate dollar_cafeExecute_2_lis_3 = new Predicates.dollar_cafeExecute_2_lis_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_cafeExecute_2_5, dollar_cafeExecute_2_lis_3);
    }
}

sealed class dollar_cafeExecute_2_lis_3 : dollar_cafeExecute_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_cafeExecute_2_6);
    }
}

sealed class dollar_cafeExecute_2_1 : dollar_cafeExecute_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("Invalid goal");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s1, p1);
        p3 = new Predicates.dollar_cut_1(a3, p2);
        p4 = new Predicates.dollar_var_1(a1, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class dollar_cafeExecute_2_2 : dollar_cafeExecute_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("end_of_file");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_cafeExecute_2_3 : dollar_cafeExecute_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("consult", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = new ListTerm(a3, a4);
        Term[] h2 = {a6};
        a5 = new StructureTerm(f1, h2);
        p1 = new Predicates.dollar_cafeExecute_2(a5, engine.makeVariable(), cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_cafeExecute_2_4 : dollar_cafeExecute_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("help");
    static internal readonly IntegerTerm s2 = new IntegerTerm(8);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("compile(File).");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("consult(File).");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("listing.");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("trace.");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("notrace.");
    static internal readonly SymbolTerm s8 = SymbolTerm.makeSymbol("halt. or ^D");
    static internal readonly SymbolTerm s9 = SymbolTerm.makeSymbol("end_of_file.");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15, p16, p17, p18, p19, p20, p21;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s9, p1);
        p3 = new Predicates.dollar_tab_1(s2, p2);
        p4 = new Predicates.dollar_nl_0(p3);
        p5 = new Predicates.Write_1(s8, p4);
        p6 = new Predicates.dollar_tab_1(s2, p5);
        p7 = new Predicates.dollar_nl_0(p6);
        p8 = new Predicates.Write_1(s7, p7);
        p9 = new Predicates.dollar_tab_1(s2, p8);
        p10 = new Predicates.dollar_nl_0(p9);
        p11 = new Predicates.Write_1(s6, p10);
        p12 = new Predicates.dollar_tab_1(s2, p11);
        p13 = new Predicates.dollar_nl_0(p12);
        p14 = new Predicates.Write_1(s5, p13);
        p15 = new Predicates.dollar_tab_1(s2, p14);
        p16 = new Predicates.dollar_nl_0(p15);
        p17 = new Predicates.Write_1(s4, p16);
        p18 = new Predicates.dollar_tab_1(s2, p17);
        p19 = new Predicates.dollar_nl_0(p18);
        p20 = new Predicates.Write_1(s3, p19);
        p21 = new Predicates.dollar_tab_1(s2, p20);
        return new Predicates.dollar_neckCut_0(p21);
    }
}

sealed class dollar_cafeExecute_2_5 : dollar_cafeExecute_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yes");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s1, p1);
        p3 = new Predicates.dollar_cut_1(a3, p2);
        p4 = new Predicates.dollar_cafeExec_2(a1, a2, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class dollar_cafeExecute_2_6 : dollar_cafeExecute_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("no");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s1, p1);
        return new Predicates.dollar_nl_0(p2);
    }
}
}

