/*
 * *** Please do not edit ! ***
 * @(#) dollar_leashMode_1.cs
 * @procedure $leash_mode/1 in interpreter.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_leashMode_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_leashMode_1_1 = new Predicates.dollar_leashMode_1_1();
    static internal readonly Predicate dollar_leashMode_1_2 = new Predicates.dollar_leashMode_1_2();
    static internal readonly Predicate dollar_leashMode_1_3 = new Predicates.dollar_leashMode_1_3();
    static internal readonly Predicate dollar_leashMode_1_4 = new Predicates.dollar_leashMode_1_4();
    static internal readonly Predicate dollar_leashMode_1_5 = new Predicates.dollar_leashMode_1_5();
    static internal readonly Predicate dollar_leashMode_1_6 = new Predicates.dollar_leashMode_1_6();
    static internal readonly Predicate dollar_leashMode_1_var = new Predicates.dollar_leashMode_1_var();

    public Term arg1;

    public dollar_leashMode_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_leashMode_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_leashMode_1_var,
                                   dollar_fail_0,
                                   dollar_leashMode_1_var,
                                   dollar_fail_0,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$leash_mode(" + arg1 + ")";
    }
}

sealed class dollar_leashMode_1_var : dollar_leashMode_1 {
    static internal readonly Predicate dollar_leashMode_1_var_1 = new Predicates.dollar_leashMode_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_leashMode_1_1, dollar_leashMode_1_var_1);
    }
}

sealed class dollar_leashMode_1_var_1 : dollar_leashMode_1 {
    static internal readonly Predicate dollar_leashMode_1_var_2 = new Predicates.dollar_leashMode_1_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_leashMode_1_2, dollar_leashMode_1_var_2);
    }
}

sealed class dollar_leashMode_1_var_2 : dollar_leashMode_1 {
    static internal readonly Predicate dollar_leashMode_1_var_3 = new Predicates.dollar_leashMode_1_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_leashMode_1_3, dollar_leashMode_1_var_3);
    }
}

sealed class dollar_leashMode_1_var_3 : dollar_leashMode_1 {
    static internal readonly Predicate dollar_leashMode_1_var_4 = new Predicates.dollar_leashMode_1_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_leashMode_1_4, dollar_leashMode_1_var_4);
    }
}

sealed class dollar_leashMode_1_var_4 : dollar_leashMode_1 {
    static internal readonly Predicate dollar_leashMode_1_var_5 = new Predicates.dollar_leashMode_1_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_leashMode_1_5, dollar_leashMode_1_var_5);
    }
}

sealed class dollar_leashMode_1_var_5 : dollar_leashMode_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_leashMode_1_6);
    }
}

sealed class dollar_leashMode_1_1 : dollar_leashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("call");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_leashMode_1_2 : dollar_leashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("exit");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_leashMode_1_3 : dollar_leashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("redo");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_leashMode_1_4 : dollar_leashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("fail");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_leashMode_1_5 : dollar_leashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("full");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_leashMode_1_6 : dollar_leashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("none");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }
}
}

