/*
 * *** Please do not edit ! ***
 * @(#) dollar_removeRedundantVars_2.cs
 * @procedure $remove_redundant_vars/2 in interpreter.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_removeRedundantVars_2 : Predicate, FcoPredicate {
    static internal readonly System.Type EntryCodeType = typeof( dollar_removeRedundantVars_2 );
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_removeRedundantVars_2_1 = new Predicates.dollar_removeRedundantVars_2_1();
    static internal readonly Predicate dollar_removeRedundantVars_2_2 = new Predicates.dollar_removeRedundantVars_2_2();
    static internal readonly Predicate dollar_removeRedundantVars_2_3 = new Predicates.dollar_removeRedundantVars_2_3();
    static internal readonly Predicate dollar_removeRedundantVars_2_lis = new Predicates.dollar_removeRedundantVars_2_lis();
    static internal readonly Predicate dollar_removeRedundantVars_2_var = new Predicates.dollar_removeRedundantVars_2_var();

    public Term arg1, arg2;

    public dollar_removeRedundantVars_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_removeRedundantVars_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.SetEntryCode( EntryCodeType, this );
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_removeRedundantVars_2_var,
                                   dollar_fail_0,
                                   dollar_removeRedundantVars_2_1,
                                   dollar_fail_0,
                                   dollar_removeRedundantVars_2_lis
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$remove_redundant_vars(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_removeRedundantVars_2_var : dollar_removeRedundantVars_2 {
    static internal readonly Predicate dollar_removeRedundantVars_2_var_1 = new Predicates.dollar_removeRedundantVars_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_removeRedundantVars_2_1, dollar_removeRedundantVars_2_var_1);
    }
}

sealed class dollar_removeRedundantVars_2_var_1 : dollar_removeRedundantVars_2 {
    static internal readonly Predicate dollar_removeRedundantVars_2_var_2 = new Predicates.dollar_removeRedundantVars_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_removeRedundantVars_2_2, dollar_removeRedundantVars_2_var_2);
    }
}

sealed class dollar_removeRedundantVars_2_var_2 : dollar_removeRedundantVars_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_removeRedundantVars_2_3);
    }
}

sealed class dollar_removeRedundantVars_2_lis : dollar_removeRedundantVars_2 {
    static internal readonly Predicate dollar_removeRedundantVars_2_lis_1 = new Predicates.dollar_removeRedundantVars_2_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_removeRedundantVars_2_2, dollar_removeRedundantVars_2_lis_1);
    }
}

sealed class dollar_removeRedundantVars_2_lis_1 : dollar_removeRedundantVars_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_removeRedundantVars_2_3);
    }
}

sealed class dollar_removeRedundantVars_2_1 : dollar_removeRedundantVars_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_removeRedundantVars_2_2 : dollar_removeRedundantVars_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isStructure() ){
            if (f1 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a3.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a3.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_removeRedundantVars_2(a4, a2, cont);
        p2 = new Predicates.dollar_unify_2(a5, a6, p1);
        p3 = new Predicates.dollar_cut_1(a7, p2);
        p4 = new Predicates.dollar_var_1(a6, p3);
        return new Predicates.dollar_getLevel_1(a7, p4);
    }
}

sealed class dollar_removeRedundantVars_2_3 : dollar_removeRedundantVars_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            if ( !a3.unify(((ListTerm)a2).car, engine.trail) )
                return engine.fail();
            a5 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a3, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a4;
        engine.aregs[2] = a5;
        engine.cont = cont;
        return engine.GetEntryCode( EntryCodeType ).call( engine );
    }
}
}

