/*
 * *** Please do not edit ! ***
 * @(#) dollar_spy_1.cs
 * @procedure $spy/1 in interpreter.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_spy_1 : Predicate {
    static internal readonly Predicate dollar_spy_1_1 = new Predicates.dollar_spy_1_1();
    static internal readonly Predicate dollar_spy_1_2 = new Predicates.dollar_spy_1_2();
    static internal readonly Predicate dollar_spy_1_sub_1 = new Predicates.dollar_spy_1_sub_1();

    public Term arg1;

    public dollar_spy_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_spy_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_spy_1_1, dollar_spy_1_sub_1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$spy(" + arg1 + ")";
    }
}

sealed class dollar_spy_1_sub_1 : dollar_spy_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_spy_1_2);
    }
}

sealed class dollar_spy_1_1 : dollar_spy_1 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_dummyInterpreter__7_2(a1, engine.makeVariable(), cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_nonvar_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class dollar_spy_1_2 : dollar_spy_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("var");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("spy", 1);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        Term[] h3 = {a1};
        a2 = new StructureTerm(f2, h3);
        return new Predicates.dollar_illarg_3(s1, a2, s4, cont);
    }
}
}

