/*
 * *** Please do not edit ! ***
 * @(#) dollar_traceReduce_2.cs
 * @procedure $trace_reduce/2 in interpreter.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_traceReduce_2 : Predicate {
    static internal readonly Predicate dollar_ancestor_2_res1 = new Resources.resource_1_Interpreter_dollar_ancestor_2();
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$ancestor", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("$trace_reduce", 1);

    public Term arg1, arg2;

    public dollar_traceReduce_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_traceReduce_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        Term[] h4 = {a1};
        a8 = new StructureTerm(f3, h4);
        Term[] h5 = {a8, a3};
        a7 = new StructureTerm(f2, h5);
        Term[] h6 = {a3, a1};
        a9 = new ClosureTerm( dollar_ancestor_2_res1, h6);
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_endExpImp_2(a6, a10, cont);
        p2 = new Predicates.dollar_trace_2(a4, a5, p1);
        p3 = new Predicates.dollar_midExpImp_1(a10, p2);
        p4 = new Predicates.dollar_addExpRes_2(a7, a9, p3);
        p5 = new Predicates.dollar_beginImp_1(a6, p4);
        p6 = new Predicates.dollar_plus_3(a2, s1, a5, p5);
        p7 = new Predicates.Clause_2(a1, a4, p6);
        return new Predicates.dollar_getLevel_1(a3, p7);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$trace_reduce(" + arg1 + ", " + arg2 + ")";
    }
}
}

