/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeBody0_1.cs
 * @procedure $write_body0/1 in interpreter.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeBody0_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_writeBody0_1_1 = new Predicates.dollar_writeBody0_1_1();
    static internal readonly Predicate dollar_writeBody0_1_2 = new Predicates.dollar_writeBody0_1_2();
    static internal readonly Predicate dollar_writeBody0_1_3 = new Predicates.dollar_writeBody0_1_3();
    static internal readonly Predicate dollar_writeBody0_1_lis = new Predicates.dollar_writeBody0_1_lis();
    static internal readonly Predicate dollar_writeBody0_1_var = new Predicates.dollar_writeBody0_1_var();

    public Term arg1;

    public dollar_writeBody0_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_writeBody0_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_writeBody0_1_var,
                                   dollar_fail_0,
                                   dollar_writeBody0_1_1,
                                   dollar_fail_0,
                                   dollar_writeBody0_1_lis
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$write_body0(" + arg1 + ")";
    }
}

sealed class dollar_writeBody0_1_var : dollar_writeBody0_1 {
    static internal readonly Predicate dollar_writeBody0_1_var_1 = new Predicates.dollar_writeBody0_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_writeBody0_1_1, dollar_writeBody0_1_var_1);
    }
}

sealed class dollar_writeBody0_1_var_1 : dollar_writeBody0_1 {
    static internal readonly Predicate dollar_writeBody0_1_var_2 = new Predicates.dollar_writeBody0_1_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeBody0_1_2, dollar_writeBody0_1_var_2);
    }
}

sealed class dollar_writeBody0_1_var_2 : dollar_writeBody0_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_writeBody0_1_3);
    }
}

sealed class dollar_writeBody0_1_lis : dollar_writeBody0_1 {
    static internal readonly Predicate dollar_writeBody0_1_lis_1 = new Predicates.dollar_writeBody0_1_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_writeBody0_1_2, dollar_writeBody0_1_lis_1);
    }
}

sealed class dollar_writeBody0_1_lis_1 : dollar_writeBody0_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_writeBody0_1_3);
    }
}

sealed class dollar_writeBody0_1_1 : dollar_writeBody0_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_writeBody0_1_2 : dollar_writeBody0_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s2 = new IntegerTerm(8);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(".");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s3, p1);
        p3 = new Predicates.Writeq_1(a2, p2);
        p4 = new Predicates.dollar_tab_1(s2, p3);
        return new Predicates.dollar_neckCut_0(p4);
    }
}

sealed class dollar_writeBody0_1_3 : dollar_writeBody0_1 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(8);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(",");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_writeBody0_1(a3, cont);
        p2 = new Predicates.dollar_nl_0(p1);
        p3 = new Predicates.Write_1(s2, p2);
        p4 = new Predicates.Writeq_1(a2, p3);
        return new Predicates.dollar_tab_1(s1, p4);
    }
}
}

