/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeBody_1.cs
 * @procedure $write_body/1 in interpreter.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeBody_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public Term arg1;

    public dollar_writeBody_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_writeBody_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        Predicate p1;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_writeBody0_1(a2, cont);
        return new Predicates.dollar_listOfBody_3(a1, a2, s1, p1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$write_body(" + arg1 + ")";
    }
}
}

