/*
 * *** Please do not edit ! ***
 * @(#) Notrace_0.cs
 * @procedure notrace/0 in interpreter.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Notrace_0 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$trace_flag", 1);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("off");
    static internal readonly Term[] h6 = {s3};
    static internal readonly StructureTerm s4 = new StructureTerm(f1, h6);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("{Small debugger is switch off}");

    public Notrace_0(Predicate cont) {
        this.cont = cont;
    }

    public Notrace_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        Predicate p1, p2, p3, p4, p5;

        a1 = engine.makeVariable();
        Term[] h2 = {engine.makeVariable()};
        a2 = new StructureTerm(f1, h2);
        p1 = new Predicates.dollar_cut_1(a1, cont);
        p2 = new Predicates.dollar_nl_0(p1);
        p3 = new Predicates.Write_1(s5, p2);
        p4 = new Predicates.Assert_1(s4, p3);
        p5 = new Predicates.Retract_1(a2, p4);
        return new Predicates.dollar_getLevel_1(a1, p5);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "notrace";
    }
}
}

