/*
 * *** Please do not edit ! ***
 * @(#) dollar_assertClause_1.cs
 * @procedure $assert_clause/1 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_assertClause_1 : Predicate {
    static internal readonly Predicate dollar_assertClause_1_1 = new Predicates.dollar_assertClause_1_1();
    static internal readonly Predicate dollar_assertClause_1_2 = new Predicates.dollar_assertClause_1_2();
    static internal readonly Predicate dollar_assertClause_1_3 = new Predicates.dollar_assertClause_1_3();
    static internal readonly Predicate dollar_assertClause_1_4 = new Predicates.dollar_assertClause_1_4();
    static internal readonly Predicate dollar_assertClause_1_5 = new Predicates.dollar_assertClause_1_5();
    static internal readonly Predicate dollar_assertClause_1_6 = new Predicates.dollar_assertClause_1_6();
    static internal readonly Predicate dollar_assertClause_1_7 = new Predicates.dollar_assertClause_1_7();
    static internal readonly Predicate dollar_assertClause_1_8 = new Predicates.dollar_assertClause_1_8();
    static internal readonly Predicate dollar_assertClause_1_9 = new Predicates.dollar_assertClause_1_9();
    static internal readonly Predicate dollar_assertClause_1_10 = new Predicates.dollar_assertClause_1_10();
    static internal readonly Predicate dollar_assertClause_1_con = new Predicates.dollar_assertClause_1_con();
    static internal readonly Predicate dollar_assertClause_1_str = new Predicates.dollar_assertClause_1_str();
    static internal readonly Predicate dollar_assertClause_1_var = new Predicates.dollar_assertClause_1_var();

    public Term arg1;

    public dollar_assertClause_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_assertClause_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_assertClause_1_var,
                                   dollar_assertClause_1_10,
                                   dollar_assertClause_1_con,
                                   dollar_assertClause_1_str,
                                   dollar_assertClause_1_10
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$assert_clause(" + arg1 + ")";
    }
}

sealed class dollar_assertClause_1_var : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_var_1 = new Predicates.dollar_assertClause_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_assertClause_1_1, dollar_assertClause_1_var_1);
    }
}

sealed class dollar_assertClause_1_var_1 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_var_2 = new Predicates.dollar_assertClause_1_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_2, dollar_assertClause_1_var_2);
    }
}

sealed class dollar_assertClause_1_var_2 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_var_3 = new Predicates.dollar_assertClause_1_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_3, dollar_assertClause_1_var_3);
    }
}

sealed class dollar_assertClause_1_var_3 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_var_4 = new Predicates.dollar_assertClause_1_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_4, dollar_assertClause_1_var_4);
    }
}

sealed class dollar_assertClause_1_var_4 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_var_5 = new Predicates.dollar_assertClause_1_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_5, dollar_assertClause_1_var_5);
    }
}

sealed class dollar_assertClause_1_var_5 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_var_6 = new Predicates.dollar_assertClause_1_var_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_6, dollar_assertClause_1_var_6);
    }
}

sealed class dollar_assertClause_1_var_6 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_var_7 = new Predicates.dollar_assertClause_1_var_7();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_7, dollar_assertClause_1_var_7);
    }
}

sealed class dollar_assertClause_1_var_7 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_var_8 = new Predicates.dollar_assertClause_1_var_8();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_8, dollar_assertClause_1_var_8);
    }
}

sealed class dollar_assertClause_1_var_8 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_var_9 = new Predicates.dollar_assertClause_1_var_9();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_9, dollar_assertClause_1_var_9);
    }
}

sealed class dollar_assertClause_1_var_9 : dollar_assertClause_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assertClause_1_10);
    }
}

sealed class dollar_assertClause_1_con : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_con_1 = new Predicates.dollar_assertClause_1_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_assertClause_1_1, dollar_assertClause_1_con_1);
    }
}

sealed class dollar_assertClause_1_con_1 : dollar_assertClause_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assertClause_1_10);
    }
}

sealed class dollar_assertClause_1_str : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_str_1 = new Predicates.dollar_assertClause_1_str_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_assertClause_1_2, dollar_assertClause_1_str_1);
    }
}

sealed class dollar_assertClause_1_str_1 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_str_2 = new Predicates.dollar_assertClause_1_str_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_3, dollar_assertClause_1_str_2);
    }
}

sealed class dollar_assertClause_1_str_2 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_str_3 = new Predicates.dollar_assertClause_1_str_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_4, dollar_assertClause_1_str_3);
    }
}

sealed class dollar_assertClause_1_str_3 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_str_4 = new Predicates.dollar_assertClause_1_str_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_5, dollar_assertClause_1_str_4);
    }
}

sealed class dollar_assertClause_1_str_4 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_str_5 = new Predicates.dollar_assertClause_1_str_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_6, dollar_assertClause_1_str_5);
    }
}

sealed class dollar_assertClause_1_str_5 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_str_6 = new Predicates.dollar_assertClause_1_str_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_7, dollar_assertClause_1_str_6);
    }
}

sealed class dollar_assertClause_1_str_6 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_str_7 = new Predicates.dollar_assertClause_1_str_7();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_8, dollar_assertClause_1_str_7);
    }
}

sealed class dollar_assertClause_1_str_7 : dollar_assertClause_1 {
    static internal readonly Predicate dollar_assertClause_1_str_8 = new Predicates.dollar_assertClause_1_str_8();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertClause_1_9, dollar_assertClause_1_str_8);
    }
}

sealed class dollar_assertClause_1_str_8 : dollar_assertClause_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assertClause_1_10);
    }
}

sealed class dollar_assertClause_1_1 : dollar_assertClause_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("end_of_file");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_assertClause_1_2 : dollar_assertClause_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("resource", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_assertResourcePredicate_1(a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_assertClause_1_3 : dollar_assertClause_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("dynamic", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_assertDynamic_1(a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_assertClause_1_4 : dollar_assertClause_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("mode", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
        } else if (a2.isVariable() ){
            Term[] args = {engine.makeVariable()};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_assertClause_1_5 : dollar_assertClause_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("multifile", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
        } else if (a2.isVariable() ){
            Term[] args = {engine.makeVariable()};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_assertClause_1_6 : dollar_assertClause_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("public", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
        } else if (a2.isVariable() ){
            Term[] args = {engine.makeVariable()};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_assertClause_1_7 : dollar_assertClause_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("block", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
        } else if (a2.isVariable() ){
            Term[] args = {engine.makeVariable()};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_assertClause_1_8 : dollar_assertClause_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("meta_predicate", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
        } else if (a2.isVariable() ){
            Term[] args = {engine.makeVariable()};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_assertClause_1_9 : dollar_assertClause_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_call_1(a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_assertClause_1_10 : dollar_assertClause_1 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_assertCls_1(a2, cont);
        return new Predicates.dollar_preprocess_2(a1, a2, p1);
    }
}
}

