/*
 * *** Please do not edit ! ***
 * @(#) dollar_changeStartOfName_2.cs
 * @procedure $change_start_of_name/2 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_changeStartOfName_2 : Predicate {
    static internal readonly Predicate dollar_changeStartOfName_2_1 = new Predicates.dollar_changeStartOfName_2_1();
    static internal readonly Predicate dollar_changeStartOfName_2_2 = new Predicates.dollar_changeStartOfName_2_2();
    static internal readonly Predicate dollar_changeStartOfName_2_3 = new Predicates.dollar_changeStartOfName_2_3();
    static internal readonly Predicate dollar_changeStartOfName_2_4 = new Predicates.dollar_changeStartOfName_2_4();
    static internal readonly Predicate dollar_changeStartOfName_2_5 = new Predicates.dollar_changeStartOfName_2_5();
    static internal readonly Predicate dollar_changeStartOfName_2_sub_1 = new Predicates.dollar_changeStartOfName_2_sub_1();

    public Term arg1, arg2;

    public dollar_changeStartOfName_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_changeStartOfName_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_changeStartOfName_2_1, dollar_changeStartOfName_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$change_start_of_name(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_changeStartOfName_2_sub_1 : dollar_changeStartOfName_2 {
    static internal readonly Predicate dollar_changeStartOfName_2_sub_2 = new Predicates.dollar_changeStartOfName_2_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_changeStartOfName_2_2, dollar_changeStartOfName_2_sub_2);
    }
}

sealed class dollar_changeStartOfName_2_sub_2 : dollar_changeStartOfName_2 {
    static internal readonly Predicate dollar_changeStartOfName_2_sub_3 = new Predicates.dollar_changeStartOfName_2_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_changeStartOfName_2_3, dollar_changeStartOfName_2_sub_3);
    }
}

sealed class dollar_changeStartOfName_2_sub_3 : dollar_changeStartOfName_2 {
    static internal readonly Predicate dollar_changeStartOfName_2_sub_4 = new Predicates.dollar_changeStartOfName_2_sub_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_changeStartOfName_2_4, dollar_changeStartOfName_2_sub_4);
    }
}

sealed class dollar_changeStartOfName_2_sub_4 : dollar_changeStartOfName_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_changeStartOfName_2_5);
    }
}

sealed class dollar_changeStartOfName_2_1 : dollar_changeStartOfName_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).car;
            if ( !s1.unify(((ListTerm)a2).cdr, engine.trail) )
                return engine.fail();
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a3, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_toupper_2(a1, a3, cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.dollar_islower_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class dollar_changeStartOfName_2_2 : dollar_changeStartOfName_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(95);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);
    static internal readonly ListTerm s4 = new ListTerm(s1, s3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a2, s4, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_unify_2(a1, s1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class dollar_changeStartOfName_2_3 : dollar_changeStartOfName_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(95);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a5 = new ListTerm(a1, s2);
        a4 = new ListTerm(s1, a5);
        p1 = new Predicates.dollar_unify_2(a2, a4, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_isdigit_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class dollar_changeStartOfName_2_4 : dollar_changeStartOfName_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(95);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a5 = new ListTerm(a1, s2);
        a4 = new ListTerm(s1, a5);
        p1 = new Predicates.dollar_unify_2(a2, a4, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_isupper_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class dollar_changeStartOfName_2_5 : dollar_changeStartOfName_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a4 = new ListTerm(a1, s1);
        p1 = new Predicates.dollar_replacement_2(a3, a2, cont);
        return new Predicates.Name_2(a3, a4, p1);
    }
}
}

