/*
 * *** Please do not edit ! ***
 * @(#) dollar_compileClause_5.cs
 * @procedure $compile_clause/5 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compileClause_5 : Predicate {
    static internal readonly Predicate dollar_compileClause_5_1 = new Predicates.dollar_compileClause_5_1();
    static internal readonly Predicate dollar_compileClause_5_2 = new Predicates.dollar_compileClause_5_2();
    static internal readonly Predicate dollar_compileClause_5_3 = new Predicates.dollar_compileClause_5_3();
    static internal readonly Predicate dollar_compileClause_5_var = new Predicates.dollar_compileClause_5_var();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_compileClause_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_compileClause_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_compileClause_5_var,
                                   dollar_compileClause_5_3,
                                   dollar_compileClause_5_3,
                                   dollar_compileClause_5_var,
                                   dollar_compileClause_5_3
                                   );
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$compile_clause(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_compileClause_5_var : dollar_compileClause_5 {
    static internal readonly Predicate dollar_compileClause_5_var_1 = new Predicates.dollar_compileClause_5_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compileClause_5_1, dollar_compileClause_5_var_1);
    }
}

sealed class dollar_compileClause_5_var_1 : dollar_compileClause_5 {
    static internal readonly Predicate dollar_compileClause_5_var_2 = new Predicates.dollar_compileClause_5_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compileClause_5_2, dollar_compileClause_5_var_2);
    }
}

sealed class dollar_compileClause_5_var_2 : dollar_compileClause_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compileClause_5_3);
    }
}

sealed class dollar_compileClause_5_1 : dollar_compileClause_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("$CS", 1);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("cs_code", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            Term[] args = {engine.makeVariable(), a6};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !s2.unify(a2, engine.trail) ) return engine.fail();
        if ( !s2.unify(a3, engine.trail) ) return engine.fail();
        a7 = engine.makeVariable();
        a9 = engine.makeVariable();
        Term[] h4 = {a9};
        a8 = new StructureTerm(f3, h4);
        Term[] h6 = {a9};
        a10 = new StructureTerm(f5, h6);
        p1 = new Predicates._C_3(a4, a10, a5, cont);
        p2 = new Predicates.dollar_cut_1(a7, p1);
        p3 = new Predicates.dollar_unify_2(a6, a8, p2);
        p4 = new Predicates.dollar_nonvar_1(a6, p3);
        return new Predicates.dollar_getLevel_1(a7, p4);
    }
}

sealed class dollar_compileClause_5_2 : dollar_compileClause_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 2);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        Term[] h2 = {a6, a7};
        a9 = new StructureTerm(f1, h2);
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        Term[] h3 = {a11, a12};
        a10 = new StructureTerm(f1, h3);
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a8, cont);
        p2 = new Predicates.dollar_compileGround_4(a14, a3, a2, s4, p1);
        p3 = new Predicates.dollar_compileChunks_4(a13, a14, a4, a5, p2);
        p4 = new Predicates.dollar_precompile_3(a11, a12, a13, p3);
        p5 = new Predicates.dollar_transform_2(a9, a10, p4);
        return new Predicates.dollar_getLevel_1(a8, p5);
    }
}

sealed class dollar_compileClause_5_3 : dollar_compileClause_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("compilation");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("of");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("failed");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s5 = new ListTerm(s3, s4);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        a8 = new ListTerm(a1, s5);
        a7 = new ListTerm(s2, a8);
        a6 = new ListTerm(s1, a7);
        p1 = new Predicates.dollar_unify_2(a5, a4, cont);
        p2 = new Predicates.dollar_fail_0(p1);
        return new Predicates.dollar_message_1(a6, p2);
    }
}
}

