/*
 * *** Please do not edit ! ***
 * @(#) dollar_compileGround_4.cs
 * @procedure $compile_ground/4 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compileGround_4 : Predicate {
    static internal readonly Predicate dollar_compileGround_4_1 = new Predicates.dollar_compileGround_4_1();
    static internal readonly Predicate dollar_compileGround_4_2 = new Predicates.dollar_compileGround_4_2();
    static internal readonly Predicate dollar_compileGround_4_var = new Predicates.dollar_compileGround_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_compileGround_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_compileGround_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_compileGround_4_var,
                                   dollar_compileGround_4_2,
                                   dollar_compileGround_4_var,
                                   dollar_compileGround_4_2,
                                   dollar_compileGround_4_2
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$compile_ground(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_compileGround_4_var : dollar_compileGround_4 {
    static internal readonly Predicate dollar_compileGround_4_var_1 = new Predicates.dollar_compileGround_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compileGround_4_1, dollar_compileGround_4_var_1);
    }
}

sealed class dollar_compileGround_4_var_1 : dollar_compileGround_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compileGround_4_2);
    }
}

sealed class dollar_compileGround_4_1 : dollar_compileGround_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a4, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compileGround_4_2 : dollar_compileGround_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a5 = ((ListTerm)a2).car;
            a6 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isList() ){
            a7 = ((ListTerm)a6).car;
            a8 = ((ListTerm)a6).cdr;
        } else if ( a6.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a6.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a8.isList() ){
            a9 = ((ListTerm)a8).car;
            if ( !s1.unify(((ListTerm)a8).cdr, engine.trail) )
                return engine.fail();
        } else if ( a8.isVariable() ){
            a9 = engine.makeVariable();
            if ( !a8.unify(new ListTerm(a9, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a14 = engine.makeVariable();
        a13 = new ListTerm(a14, s1);
        a12 = new ListTerm(engine.makeVariable(), a13);
        a11 = new ListTerm(engine.makeVariable(), a12);
        a10 = new ListTerm(engine.makeVariable(), a11);
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a20 = new ListTerm(engine.makeVariable(), s1);
        a19 = new ListTerm(a9, a20);
        a18 = new ListTerm(a7, a19);
        a17 = new ListTerm(a5, a18);
        p1 = new Predicates.dollar_unify_2(a16, a17, cont);
        p2 = new Predicates.dollar_genStaticTerms_5(a15, a1, a16, a3, a4, p1);
        p3 = new Predicates.dollar_pickupGround_3(a14, a15, s1, p2);
        return new Predicates.dollar_unify_2(a1, a10, p3);
    }
}
}

