/*
 * *** Please do not edit ! ***
 * @(#) dollar_compilePredicate_4.cs
 * @procedure $compile_predicate/4 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compilePredicate_4 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("clause", 2);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("$internal_clause", 2);
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("[]");

    public Term arg1, arg2, arg3, arg4;

    public dollar_compilePredicate_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_compilePredicate_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2, p3, p4, p5;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a8 = engine.makeVariable();
        Term[] h2 = {a6, a8};
        a7 = new StructureTerm(f1, h2);
        Term[] h5 = {a6, a8};
        a10 = new StructureTerm(f4, h5);
        Term[] h6 = {a10, engine.makeVariable()};
        a9 = new StructureTerm(f3, h6);
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a5, cont);
        p2 = new Predicates.dollar_flattenCode_3(a12, a3, a4, p1);
        p3 = new Predicates.dollar_compilePred_5(a11, a1, a2, a12, s7, p2);
        p4 = new Predicates.Findall_3(a7, a9, a11, p3);
        p5 = new Predicates.dollar_functor_3(a6, a1, a2, p4);
        return new Predicates.dollar_getLevel_1(a5, p5);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$compile_predicate(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

