/*
 * *** Please do not edit ! ***
 * @(#) dollar_createRegArgs_2.cs
 * @procedure $create_reg_args/2 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_createRegArgs_2 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_createRegArgs_2_1 = new Predicates.dollar_createRegArgs_2_1();
    static internal readonly Predicate dollar_createRegArgs_2_2 = new Predicates.dollar_createRegArgs_2_2();
    static internal readonly Predicate dollar_createRegArgs_2_var = new Predicates.dollar_createRegArgs_2_var();

    public Term arg1, arg2;

    public dollar_createRegArgs_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_createRegArgs_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_createRegArgs_2_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_createRegArgs_2_var
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$create_reg_args(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_createRegArgs_2_var : dollar_createRegArgs_2 {
    static internal readonly Predicate dollar_createRegArgs_2_var_1 = new Predicates.dollar_createRegArgs_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_createRegArgs_2_1, dollar_createRegArgs_2_var_1);
    }
}

sealed class dollar_createRegArgs_2_var_1 : dollar_createRegArgs_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_createRegArgs_2_2);
    }
}

sealed class dollar_createRegArgs_2_1 : dollar_createRegArgs_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a4 = ((ListTerm)a2).car;
            if ( !s1.unify(((ListTerm)a2).cdr, engine.trail) )
                return engine.fail();
        } else if ( a2.isVariable() ){
            a4 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a4, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_createRegName_2(a3, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_createRegArgs_2_2 : dollar_createRegArgs_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol(", ");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a5 = ((ListTerm)a2).car;
            a6 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isList() ){
            if ( !s1.unify(((ListTerm)a6).car, engine.trail) )
                return engine.fail();
            a7 = ((ListTerm)a6).cdr;
        } else if ( a6.isVariable() ){
            a7 = engine.makeVariable();
            if ( !a6.unify(new ListTerm(s1, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_createRegArgs_2(a4, a7, cont);
        return new Predicates.dollar_createRegName_2(a3, a5, p1);
    }
}
}

