/*
 * *** Please do not edit ! ***
 * @(#) dollar_genUnify_6.cs
 * @procedure $gen_unify/6 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genUnify_6 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_genUnify_6_1 = new Predicates.dollar_genUnify_6_1();
    static internal readonly Predicate dollar_genUnify_6_2 = new Predicates.dollar_genUnify_6_2();
    static internal readonly Predicate dollar_genUnify_6_3 = new Predicates.dollar_genUnify_6_3();
    static internal readonly Predicate dollar_genUnify_6_4 = new Predicates.dollar_genUnify_6_4();
    static internal readonly Predicate dollar_genUnify_6_5 = new Predicates.dollar_genUnify_6_5();
    static internal readonly Predicate dollar_genUnify_6_6 = new Predicates.dollar_genUnify_6_6();
    static internal readonly Predicate dollar_genUnify_6_7 = new Predicates.dollar_genUnify_6_7();
    static internal readonly Predicate dollar_genUnify_6_8 = new Predicates.dollar_genUnify_6_8();
    static internal readonly Predicate dollar_genUnify_6_lis = new Predicates.dollar_genUnify_6_lis();
    static internal readonly Predicate dollar_genUnify_6_var = new Predicates.dollar_genUnify_6_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public dollar_genUnify_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public dollar_genUnify_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_genUnify_6_var,
                                   dollar_fail_0,
                                   dollar_genUnify_6_1,
                                   dollar_fail_0,
                                   dollar_genUnify_6_lis
                                   );
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "$gen_unify(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class dollar_genUnify_6_var : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_var_1 = new Predicates.dollar_genUnify_6_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genUnify_6_1, dollar_genUnify_6_var_1);
    }
}

sealed class dollar_genUnify_6_var_1 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_var_2 = new Predicates.dollar_genUnify_6_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_2, dollar_genUnify_6_var_2);
    }
}

sealed class dollar_genUnify_6_var_2 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_var_3 = new Predicates.dollar_genUnify_6_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_3, dollar_genUnify_6_var_3);
    }
}

sealed class dollar_genUnify_6_var_3 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_var_4 = new Predicates.dollar_genUnify_6_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_4, dollar_genUnify_6_var_4);
    }
}

sealed class dollar_genUnify_6_var_4 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_var_5 = new Predicates.dollar_genUnify_6_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_5, dollar_genUnify_6_var_5);
    }
}

sealed class dollar_genUnify_6_var_5 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_var_6 = new Predicates.dollar_genUnify_6_var_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_6, dollar_genUnify_6_var_6);
    }
}

sealed class dollar_genUnify_6_var_6 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_var_7 = new Predicates.dollar_genUnify_6_var_7();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_7, dollar_genUnify_6_var_7);
    }
}

sealed class dollar_genUnify_6_var_7 : dollar_genUnify_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genUnify_6_8);
    }
}

sealed class dollar_genUnify_6_lis : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_lis_1 = new Predicates.dollar_genUnify_6_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genUnify_6_2, dollar_genUnify_6_lis_1);
    }
}

sealed class dollar_genUnify_6_lis_1 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_lis_2 = new Predicates.dollar_genUnify_6_lis_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_3, dollar_genUnify_6_lis_2);
    }
}

sealed class dollar_genUnify_6_lis_2 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_lis_3 = new Predicates.dollar_genUnify_6_lis_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_4, dollar_genUnify_6_lis_3);
    }
}

sealed class dollar_genUnify_6_lis_3 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_lis_4 = new Predicates.dollar_genUnify_6_lis_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_5, dollar_genUnify_6_lis_4);
    }
}

sealed class dollar_genUnify_6_lis_4 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_lis_5 = new Predicates.dollar_genUnify_6_lis_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_6, dollar_genUnify_6_lis_5);
    }
}

sealed class dollar_genUnify_6_lis_5 : dollar_genUnify_6 {
    static internal readonly Predicate dollar_genUnify_6_lis_6 = new Predicates.dollar_genUnify_6_lis_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnify_6_7, dollar_genUnify_6_lis_6);
    }
}

sealed class dollar_genUnify_6_lis_6 : dollar_genUnify_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genUnify_6_8);
    }
}

sealed class dollar_genUnify_6_1 : dollar_genUnify_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( !a3.unify(a4, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_genUnify_6_2 : dollar_genUnify_6 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        p1 = new Predicates.dollar_genUnify_6(a8, a2, a12, a4, a13, a6, cont);
        p2 = new Predicates.dollar_genUnifyVar_4(a10, a11, a5, a13, p1);
        p3 = new Predicates.dollar_assignReg_5(a7, a10, a11, a3, a12, p2);
        p4 = new Predicates.dollar_cut_1(a9, p3);
        p5 = new Predicates.dollar_var_1(a7, p4);
        return new Predicates.dollar_getLevel_1(a9, p5);
    }
}

sealed class dollar_genUnify_6_3 : dollar_genUnify_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("floating");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("point");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("numbers");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("are");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("not");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("supported");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s8 = new ListTerm(s6, s7);
    static internal readonly ListTerm s9 = new ListTerm(s5, s8);
    static internal readonly ListTerm s10 = new ListTerm(s4, s9);
    static internal readonly ListTerm s11 = new ListTerm(s3, s10);
    static internal readonly ListTerm s12 = new ListTerm(s2, s11);
    static internal readonly ListTerm s13 = new ListTerm(s1, s12);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, engine.makeVariable()), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        p2 = new Predicates.dollar_fail_0(p1);
        p3 = new Predicates.dollar_message_1(s13, p2);
        p4 = new Predicates.dollar_cut_1(a8, p3);
        p5 = new Predicates.Float_1(a7, p4);
        return new Predicates.dollar_getLevel_1(a8, p5);
    }
}

sealed class dollar_genUnify_6_4 : dollar_genUnify_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yes");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("unify_int", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        Term[] h3 = {a10};
        a13 = new StructureTerm(f2, h3);
        a14 = engine.makeVariable();
        p1 = new Predicates.dollar_genUnify_6(a8, a2, a12, a4, a14, a6, cont);
        p2 = new Predicates._C_3(a5, a13, a14, p1);
        p3 = new Predicates.dollar_unify_2(a11, s1, p2);
        p4 = new Predicates.dollar_assignReg_5(a7, a10, a11, a3, a12, p3);
        p5 = new Predicates.dollar_cut_1(a9, p4);
        p6 = new Predicates.dollar_integer_1(a7, p5);
        return new Predicates.dollar_getLevel_1(a9, p6);
    }
}

sealed class dollar_genUnify_6_5 : dollar_genUnify_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yes");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("unify_con", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        Term[] h3 = {a10};
        a13 = new StructureTerm(f2, h3);
        a14 = engine.makeVariable();
        p1 = new Predicates.dollar_genUnify_6(a8, a2, a12, a4, a14, a6, cont);
        p2 = new Predicates._C_3(a5, a13, a14, p1);
        p3 = new Predicates.dollar_unify_2(a11, s1, p2);
        p4 = new Predicates.dollar_assignReg_5(a7, a10, a11, a3, a12, p3);
        p5 = new Predicates.dollar_cut_1(a9, p4);
        p6 = new Predicates.dollar_atom_1(a7, p5);
        return new Predicates.dollar_getLevel_1(a9, p6);
    }
}

sealed class dollar_genUnify_6_6 : dollar_genUnify_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("yes");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("unify_ground", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a10 = new ListTerm(a11, a12);
        a14 = new ListTerm(a12, s1);
        a13 = new ListTerm(a11, a14);
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        a18 = engine.makeVariable();
        a19 = engine.makeVariable();
        Term[] h4 = {a17};
        a20 = new StructureTerm(f3, h4);
        a21 = engine.makeVariable();
        p1 = new Predicates.dollar_genUnify_6(a8, a2, a19, a4, a21, a6, cont);
        p2 = new Predicates._C_3(a16, a20, a21, p1);
        p3 = new Predicates.dollar_unify_2(a18, s2, p2);
        p4 = new Predicates.dollar_assignReg_5(a7, a17, a18, a15, a19, p3);
        p5 = new Predicates.dollar_genPutArgs_6(a13, engine.makeVariable(), a3, a15, a5, a16, p4);
        p6 = new Predicates.dollar_cut_1(a9, p5);
        p7 = new Predicates.dollar_unify_2(a7, a10, p6);
        p8 = new Predicates.Ground_1(a7, p7);
        return new Predicates.dollar_getLevel_1(a9, p8);
    }
}

sealed class dollar_genUnify_6_7 : dollar_genUnify_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$f_n", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("yes");
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("unify_ground", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a10 = new ListTerm(a11, a12);
        a13 = engine.makeVariable();
        Term[] h2 = {a11, a13};
        a14 = new StructureTerm(f1, h2);
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        a18 = engine.makeVariable();
        a19 = engine.makeVariable();
        a20 = engine.makeVariable();
        Term[] h5 = {a18};
        a21 = new StructureTerm(f4, h5);
        a22 = engine.makeVariable();
        p1 = new Predicates.dollar_genUnify_6(a8, a2, a20, a4, a22, a6, cont);
        p2 = new Predicates._C_3(a17, a21, a22, p1);
        p3 = new Predicates.dollar_unify_2(a19, s3, p2);
        p4 = new Predicates.dollar_assignReg_5(a7, a18, a19, a16, a20, p3);
        p5 = new Predicates.dollar_genPutArgs_6(a12, engine.makeVariable(), a15, a16, a5, a17, p4);
        p6 = new Predicates.dollar_assignFunctor_4(a14, engine.makeVariable(), a3, a15, p5);
        p7 = new Predicates.dollar_cut_1(a9, p6);
        p8 = new Predicates.dollar_functor_3(a7, engine.makeVariable(), a13, p7);
        p9 = new Predicates.eq_stop_stop_2(a7, a10, p8);
        p10 = new Predicates.Ground_1(a7, p9);
        return new Predicates.dollar_getLevel_1(a9, p10);
    }
}

sealed class dollar_genUnify_6_8 : dollar_genUnify_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a9 = ((ListTerm)a2).car;
            a10 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a9 = engine.makeVariable();
            a10 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a9, a10), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.isStructure() ){
            if (f1 != ((StructureTerm)a9).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a9).args;
            a11 = args[0];
            if ( !a7.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a9.isVariable() ){
            a11 = engine.makeVariable();
            Term[] args = {a11, a7};
            if ( !a9.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        p1 = new Predicates.dollar_genUnify_6(a8, a10, a13, a4, a14, a6, cont);
        p2 = new Predicates.dollar_genUnifyVar_4(a11, a12, a5, a14, p1);
        return new Predicates.dollar_assignReg_5(a7, a11, a12, a3, a13, p2);
    }
}
}

