/*
 * *** Please do not edit ! ***
 * @(#) dollar_generateCs_2.cs
 * @procedure $generate_cs/2 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_generateCs_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("}");

    public Term arg1, arg2;

    public dollar_generateCs_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_generateCs_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        Predicate p1, p2, p3, p4;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        p1 = new Predicates.dollar_nl_1(a1, cont);
        p2 = new Predicates.Write_2(a1, s1, p1);
        p3 = new Predicates.dollar_nl_1(a1, p2);
        p4 = new Predicates.Write_2(a1, s1, p3);
        return new Predicates.dollar_writeCs0_2(a1, a2, p4);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$generate_cs(" + arg1 + ", " + arg2 + ")";
    }
}
}

