/*
 * *** Please do not edit ! ***
 * @(#) dollar_generateSw_7.cs
 * @procedure $generate_sw/7 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_generateSw_7 : Predicate {
    static internal readonly Predicate dollar_generateSw_7_1 = new Predicates.dollar_generateSw_7_1();
    static internal readonly Predicate dollar_generateSw_7_2 = new Predicates.dollar_generateSw_7_2();
    static internal readonly Predicate dollar_generateSw_7_sub_1 = new Predicates.dollar_generateSw_7_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6, arg7;

    public dollar_generateSw_7(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Term a7, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        arg7 = a7; 
        this.cont = cont;
    }

    public dollar_generateSw_7(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        arg7 = args[6]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.aregs[7] = arg7;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_generateSw_7_1, dollar_generateSw_7_sub_1);
    }

    public override int arity() { return 7; }

    public override string ToString() {
        return "$generate_sw(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ", " + arg7 + ")";
    }
}

sealed class dollar_generateSw_7_sub_1 : dollar_generateSw_7 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSw_7_2);
    }
}

sealed class dollar_generateSw_7_1 : dollar_generateSw_7 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("var");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        Term[] h4 = {a3, s3};
        a10 = new StructureTerm(f2, h4);
        p1 = new Predicates.dollar_unify_2(a7, a6, cont);
        p2 = new Predicates.dollar_unify_2(a5, a10, p1);
        p3 = new Predicates.dollar_cut_1(a8, p2);
        p4 = new Predicates.dollar_unify_2(a9, a4, p3);
        p5 = new Predicates.dollar_selectType_4(a1, a2, s1, a9, p4);
        return new Predicates.dollar_getLevel_1(a8, p5);
    }
}

sealed class dollar_generateSw_7_2 : dollar_generateSw_7 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_generateSw1_6(a8, a2, a3, a5, a6, a7, cont);
        return new Predicates.dollar_selectType_4(a1, a2, s1, a8, p1);
    }
}
}

