/*
 * *** Please do not edit ! ***
 * @(#) dollar_islower_1.cs
 * @procedure $islower/1 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_islower_1 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(97);
    static internal readonly IntegerTerm s2 = new IntegerTerm(122);

    public Term arg1;

    public dollar_islower_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_islower_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1;
        Predicate p1;
        a1 = arg1.dereference();

        p1 = new Predicates.dollar_lessOrEqual_2(a1, s2, cont);
        return new Predicates.dollar_lessOrEqual_2(s1, a1, p1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$islower(" + arg1 + ")";
    }
}
}

