/*
 * *** Please do not edit ! ***
 * @(#) dollar_makeDummyName_2.cs
 * @procedure $make_dummy_name/2 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_makeDummyName_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("$dummy_");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("_");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");

    public Term arg1, arg2;

    public dollar_makeDummyName_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_makeDummyName_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a8 = new ListTerm(a1, s3);
        a7 = new ListTerm(s2, a8);
        a6 = new ListTerm(a4, a7);
        a5 = new ListTerm(s1, a6);
        p1 = new Predicates.dollar_listToString_2(a5, a2, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_fileName_1(a4, p2);
        p4 = new Predicates.dollar_integer_1(a1, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$make_dummy_name(" + arg1 + ", " + arg2 + ")";
    }
}
}

