/*
 * *** Please do not edit ! ***
 * @(#) dollar_memq_2.cs
 * @procedure $memq/2 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_memq_2 : Predicate, FcoPredicate {
    static internal readonly System.Type EntryCodeType = typeof( dollar_memq_2 );
    static internal readonly Predicate dollar_memq_2_1 = new Predicates.dollar_memq_2_1();
    static internal readonly Predicate dollar_memq_2_2 = new Predicates.dollar_memq_2_2();
    static internal readonly Predicate dollar_memq_2_sub_1 = new Predicates.dollar_memq_2_sub_1();

    public Term arg1, arg2;

    public dollar_memq_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_memq_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.SetEntryCode( EntryCodeType, this );
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_memq_2_1, dollar_memq_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$memq(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_memq_2_sub_1 : dollar_memq_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_memq_2_2);
    }
}

sealed class dollar_memq_2_1 : dollar_memq_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).car;
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a3, engine.makeVariable()), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_equalityOfTerm_2(a1, a3, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_memq_2_2 : dollar_memq_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(engine.makeVariable(), a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a1;
        engine.aregs[2] = a3;
        engine.cont = cont;
        return engine.GetEntryCode( EntryCodeType ).call( engine );
    }
}
}

