/*
 * *** Please do not edit ! ***
 * @(#) dollar_precompileBody_3.cs
 * @procedure $precompile_body/3 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_precompileBody_3 : Predicate {
    static internal readonly Predicate dollar_precompileBody_3_1 = new Predicates.dollar_precompileBody_3_1();
    static internal readonly Predicate dollar_precompileBody_3_2 = new Predicates.dollar_precompileBody_3_2();
    static internal readonly Predicate dollar_precompileBody_3_var = new Predicates.dollar_precompileBody_3_var();

    public Term arg1, arg2, arg3;

    public dollar_precompileBody_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_precompileBody_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_precompileBody_3_var,
                                   dollar_precompileBody_3_2,
                                   dollar_precompileBody_3_2,
                                   dollar_precompileBody_3_var,
                                   dollar_precompileBody_3_2
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$precompile_body(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_precompileBody_3_var : dollar_precompileBody_3 {
    static internal readonly Predicate dollar_precompileBody_3_var_1 = new Predicates.dollar_precompileBody_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_precompileBody_3_1, dollar_precompileBody_3_var_1);
    }
}

sealed class dollar_precompileBody_3_var_1 : dollar_precompileBody_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_precompileBody_3_2);
    }
}

sealed class dollar_precompileBody_3_1 : dollar_precompileBody_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("true", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("cont");
    static internal readonly Term[] h6 = {s2};
    static internal readonly StructureTerm s3 = new StructureTerm(f1, h6);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("execute", 1);
    static internal readonly Term[] h7 = {s2};
    static internal readonly StructureTerm s5 = new StructureTerm(f4, h7);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s3.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates._C_3(a2, s5, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_precompileBody_3_2 : dollar_precompileBody_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("execute", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a4 = new ListTerm(a5, a6);
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = new ListTerm(a5, a7);
        Term[] h2 = {a9};
        a11 = new StructureTerm(f1, h2);
        p1 = new Predicates._C_3(a8, a11, a3, cont);
        p2 = new Predicates.eq_stop_stop_2(a9, a10, p1);
        p3 = new Predicates.dollar_precompCall_5(a5, a6, a7, a2, a8, p2);
        return new Predicates.eq_stop_stop_2(a1, a4, p3);
    }
}
}

