/*
 * *** Please do not edit ! ***
 * @(#) dollar_readInProgram_1.cs
 * @procedure $read_in_program/1 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_readInProgram_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("read");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("end_of_file");

    public Term arg1;

    public dollar_readInProgram_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_readInProgram_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_close_1(a3, cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_equalityOfTerm_2(a4, s2, p2);
        p4 = new Predicates.dollar_assertClause_1(a4, p3);
        p5 = new Predicates.Read_2(a3, a4, p4);
        p6 = new Predicates.Repeat_0(p5);
        p7 = new Predicates.Open_3(a1, s1, a3, p6);
        return new Predicates.dollar_getLevel_1(a2, p7);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$read_in_program(" + arg1 + ")";
    }
}
}

