/*
 * *** Please do not edit ! ***
 * @(#) dollar_unifyListR_4.cs
 * @procedure $unify_list_r/4 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_unifyListR_4 : Predicate {
    static internal readonly Predicate dollar_unifyListR_4_1 = new Predicates.dollar_unifyListR_4_1();
    static internal readonly Predicate dollar_unifyListR_4_2 = new Predicates.dollar_unifyListR_4_2();
    static internal readonly Predicate dollar_unifyListR_4_3 = new Predicates.dollar_unifyListR_4_3();
    static internal readonly Predicate dollar_unifyListR_4_4 = new Predicates.dollar_unifyListR_4_4();
    static internal readonly Predicate dollar_unifyListR_4_5 = new Predicates.dollar_unifyListR_4_5();
    static internal readonly Predicate dollar_unifyListR_4_6 = new Predicates.dollar_unifyListR_4_6();
    static internal readonly Predicate dollar_unifyListR_4_sub_1 = new Predicates.dollar_unifyListR_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public dollar_unifyListR_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_unifyListR_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_unifyListR_4_1, dollar_unifyListR_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$unify_list_r(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_unifyListR_4_sub_1 : dollar_unifyListR_4 {
    static internal readonly Predicate dollar_unifyListR_4_sub_2 = new Predicates.dollar_unifyListR_4_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_unifyListR_4_2, dollar_unifyListR_4_sub_2);
    }
}

sealed class dollar_unifyListR_4_sub_2 : dollar_unifyListR_4 {
    static internal readonly Predicate dollar_unifyListR_4_sub_3 = new Predicates.dollar_unifyListR_4_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_unifyListR_4_3, dollar_unifyListR_4_sub_3);
    }
}

sealed class dollar_unifyListR_4_sub_3 : dollar_unifyListR_4 {
    static internal readonly Predicate dollar_unifyListR_4_sub_4 = new Predicates.dollar_unifyListR_4_sub_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_unifyListR_4_4, dollar_unifyListR_4_sub_4);
    }
}

sealed class dollar_unifyListR_4_sub_4 : dollar_unifyListR_4 {
    static internal readonly Predicate dollar_unifyListR_4_sub_5 = new Predicates.dollar_unifyListR_4_sub_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_unifyListR_4_5, dollar_unifyListR_4_sub_5);
    }
}

sealed class dollar_unifyListR_4_sub_5 : dollar_unifyListR_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_unifyListR_4_6);
    }
}

sealed class dollar_unifyListR_4_1 : dollar_unifyListR_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_void", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
        } else if (a4.isVariable() ){
            Term[] args = {engine.makeVariable()};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_unifyListR_4_2 : dollar_unifyListR_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_var", 1);
    static internal readonly IntegerTerm s2 = new IntegerTerm(12);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(" = ");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("((ListTerm)");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol(").");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol(";");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s8 = new ListTerm(s6, s7);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a5 = args[0];
        } else if (a4.isVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        a12 = new ListTerm(a2, s8);
        a11 = new ListTerm(s5, a12);
        a10 = new ListTerm(a3, a11);
        a9 = new ListTerm(s4, a10);
        a8 = new ListTerm(s3, a9);
        a7 = new ListTerm(a6, a8);
        p1 = new Predicates.dollar_writelnStream_3(a1, s2, a7, cont);
        p2 = new Predicates.dollar_createRegName_2(a5, a6, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_unifyListR_4_3 : dollar_unifyListR_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_val", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a5 = args[0];
        } else if (a4.isVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyListR4_4(a1, a2, a3, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_unifyListR_4_4 : dollar_unifyListR_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_int", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a5 = args[0];
        } else if (a4.isVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyListR4_4(a1, a2, a3, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_unifyListR_4_5 : dollar_unifyListR_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_con", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a5 = args[0];
        } else if (a4.isVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyListR4_4(a1, a2, a3, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_unifyListR_4_6 : dollar_unifyListR_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_ground", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a5 = args[0];
        } else if (a4.isVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyListR4_4(a1, a2, a3, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}
}

