/*
 * *** Please do not edit ! ***
 * @(#) dollar_unifyStrW_3.cs
 * @procedure $unify_str_w/3 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_unifyStrW_3 : Predicate {
    static internal readonly Predicate dollar_unifyStrW_3_1 = new Predicates.dollar_unifyStrW_3_1();
    static internal readonly Predicate dollar_unifyStrW_3_2 = new Predicates.dollar_unifyStrW_3_2();
    static internal readonly Predicate dollar_unifyStrW_3_sub_1 = new Predicates.dollar_unifyStrW_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_unifyStrW_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_unifyStrW_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_unifyStrW_3_1, dollar_unifyStrW_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$unify_str_w(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_unifyStrW_3_sub_1 : dollar_unifyStrW_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_unifyStrW_3_2);
    }
}

sealed class dollar_unifyStrW_3_1 : dollar_unifyStrW_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a4 = ((ListTerm)a2).car;
            if ( !s1.unify(((ListTerm)a2).cdr, engine.trail) )
                return engine.fail();
        } else if ( a2.isVariable() ){
            a4 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a4, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            a5 = ((ListTerm)a3).car;
            if ( !s1.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a5, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyStrW0_3(a1, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_unifyStrW_3_2 : dollar_unifyStrW_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol(", ");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a4 = ((ListTerm)a2).car;
            a5 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            a6 = ((ListTerm)a3).car;
            a7 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.isList() ){
            if ( !s1.unify(((ListTerm)a7).car, engine.trail) )
                return engine.fail();
            a8 = ((ListTerm)a7).cdr;
        } else if ( a7.isVariable() ){
            a8 = engine.makeVariable();
            if ( !a7.unify(new ListTerm(s1, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyStrW_3(a1, a5, a8, cont);
        return new Predicates.dollar_unifyStrW0_3(a1, a4, a6, p1);
    }
}
}

