/*
 * *** Please do not edit ! ***
 * @(#) dollar_wjGetListWrite_3.cs
 * @procedure $wj_get_list_write/3 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_wjGetListWrite_3 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s2 = new IntegerTerm(12);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("if ( !");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(".unify(new ListTerm(");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol(", ");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("), ");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("engine.trail) )");
    static internal readonly ListTerm s8 = new ListTerm(s7, s1);
    static internal readonly ListTerm s9 = new ListTerm(s6, s8);
    static internal readonly IntegerTerm s10 = new IntegerTerm(16);
    static internal readonly SymbolTerm s11 = SymbolTerm.makeSymbol("return engine.fail();");
    static internal readonly ListTerm s12 = new ListTerm(s11, s1);

    public Term arg1, arg2, arg3;

    public dollar_wjGetListWrite_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_wjGetListWrite_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        if ( a3.isList() ){
            a4 = ((ListTerm)a3).car;
            a5 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.isList() ){
            a6 = ((ListTerm)a5).car;
            if ( !s1.unify(((ListTerm)a5).cdr, engine.trail) )
                return engine.fail();
        } else if ( a5.isVariable() ){
            a6 = engine.makeVariable();
            if ( !a5.unify(new ListTerm(a6, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a14 = new ListTerm(a8, s9);
        a13 = new ListTerm(s5, a14);
        a12 = new ListTerm(a7, a13);
        a11 = new ListTerm(s4, a12);
        a10 = new ListTerm(a2, a11);
        a9 = new ListTerm(s3, a10);
        p1 = new Predicates.dollar_writelnStream_3(a1, s10, s12, cont);
        p2 = new Predicates.dollar_writelnStream_3(a1, s2, a9, p1);
        p3 = new Predicates.dollar_unifyListW_3(a1, a6, a8, p2);
        return new Predicates.dollar_unifyListW_3(a1, a4, a7, p3);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$wj_get_list_write(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

