/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeCsArity_2.cs
 * @procedure $write_cs_arity/2 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeCsArity_2 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(4);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("public override int arity() { return ");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(";");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(" }");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);
    static internal readonly ListTerm s7 = new ListTerm(s3, s6);

    public Term arg1, arg2;

    public dollar_writeCsArity_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_writeCsArity_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a4 = new ListTerm(a2, s7);
        a3 = new ListTerm(s2, a4);
        p1 = new Predicates.dollar_writelnStream_3(a1, s1, a3, cont);
        return new Predicates.dollar_nl_1(a1, p1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$write_cs_arity(" + arg1 + ", " + arg2 + ")";
    }
}
}

