/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeCsCont_3.cs
 * @procedure $write_cs_cont/3 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeCsCont_3 : Predicate {
    static internal readonly Predicate dollar_writeCsCont_3_1 = new Predicates.dollar_writeCsCont_3_1();
    static internal readonly Predicate dollar_writeCsCont_3_2 = new Predicates.dollar_writeCsCont_3_2();
    static internal readonly Predicate dollar_writeCsCont_3_sub_1 = new Predicates.dollar_writeCsCont_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_writeCsCont_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_writeCsCont_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_writeCsCont_3_1, dollar_writeCsCont_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$write_cs_cont(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_writeCsCont_3_sub_1 : dollar_writeCsCont_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_writeCsCont_3_2);
    }
}

sealed class dollar_writeCsCont_3_1 : dollar_writeCsCont_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("$FCO");
    static internal readonly IntegerTerm s2 = new IntegerTerm(1);
    static internal readonly IntegerTerm s3 = new IntegerTerm(8);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("return engine.GetEntryCode( EntryCodeType ).call( engine );");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_writelnStream_3(a1, s3, s6, cont);
        p2 = new Predicates.dollar_wjFcoCont_3(a1, a3, s2, p1);
        p3 = new Predicates.dollar_cut_1(a4, p2);
        p4 = new Predicates.dollar_equalityOfTerm_2(a2, s1, p3);
        return new Predicates.dollar_getLevel_1(a4, p4);
    }
}

sealed class dollar_writeCsCont_3_2 : dollar_writeCsCont_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(8);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("return new ");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h3 = {a2, a5};
        a6 = new StructureTerm(f2, h3);
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a10 = new ListTerm(a7, a8);
        a9 = new ListTerm(s5, a10);
        p1 = new Predicates.dollar_writelnStream_3(a1, s4, a9, cont);
        p2 = new Predicates.dollar_createContArgs_2(a3, a8, p1);
        p3 = new Predicates.dollar_createQualifiedName_2(a6, a7, p2);
        p4 = new Predicates.dollar_minus_3(a4, s1, a5, p3);
        return new Predicates.Length_2(a3, a4, p4);
    }
}
}

