/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeCsGet4_3.cs
 * @procedure $write_cs_get4/3 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeCsGet4_3 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(8);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("if ( !");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(".unify(");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(", ");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("engine.trail) ) return engine.fail();");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s7 = new ListTerm(s5, s6);
    static internal readonly ListTerm s8 = new ListTerm(s4, s7);

    public Term arg1, arg2, arg3;

    public dollar_writeCsGet4_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_writeCsGet4_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a9 = new ListTerm(a5, s8);
        a8 = new ListTerm(s3, a9);
        a7 = new ListTerm(a4, a8);
        a6 = new ListTerm(s2, a7);
        p1 = new Predicates.dollar_writelnStream_3(a1, s1, a6, cont);
        p2 = new Predicates.dollar_createRegName_2(a3, a5, p1);
        return new Predicates.dollar_createRegName_2(a2, a4, p2);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$write_cs_get4(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

