/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeCsSetArgument_1.cs
 * @procedure $write_cs_set_argument/1 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeCsSetArgument_1 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(4);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("public override void setArgument( Term[] args, Predicate cont ) { }");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s4 = new ListTerm(s2, s3);

    public Term arg1;

    public dollar_writeCsSetArgument_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_writeCsSetArgument_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1;
        Predicate p1;
        a1 = arg1.dereference();

        p1 = new Predicates.dollar_writelnStream_3(a1, s1, s4, cont);
        return new Predicates.dollar_nl_1(a1, p1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$write_cs_set_argument(" + arg1 + ")";
    }
}
}

