/*
 * *** Please do not edit ! ***
 * @(#) Plcomp_2.cs
 * @procedure plcomp/2 in plcs.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Plcomp_2 : Predicate {
    static internal readonly Predicate Plcomp_2_1 = new Predicates.Plcomp_2_1();
    static internal readonly Predicate Plcomp_2_2 = new Predicates.Plcomp_2_2();
    static internal readonly Predicate Plcomp_2_sub_1 = new Predicates.Plcomp_2_sub_1();

    public Term arg1, arg2;

    public Plcomp_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Plcomp_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(Plcomp_2_1, Plcomp_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "plcomp(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class Plcomp_2_sub_1 : Plcomp_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(Plcomp_2_2);
    }
}

sealed class Plcomp_2_1 : Plcomp_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$compile_to_writer", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {engine.makeVariable()};
        a3 = new StructureTerm(f1, h2);
        a4 = engine.makeVariable();
        Term[] h3 = {a4};
        a5 = new StructureTerm(f1, h3);
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        Term[] h4 = {engine.makeVariable()};
        a8 = new StructureTerm(f1, h4);
        p1 = new Predicates.Retractall_1(a8, cont);
        p2 = new Predicates.dollar_loadAssembly_1(a7, p1);
        p3 = new Predicates.dollar_csc_3(a6, a2, a7, p2);
        p4 = new Predicates.dollar_resultStringWriter_2(a4, a6, p3);
        p5 = new Predicates.Plcs_1(a1, p4);
        p6 = new Predicates.Assert_1(a5, p5);
        p7 = new Predicates.dollar_newStringWriter_1(a4, p6);
        return new Predicates.Retractall_1(a3, p7);
    }
}

sealed class Plcomp_2_2 : Plcomp_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$compile_to_writer", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {engine.makeVariable()};
        a3 = new StructureTerm(f1, h2);
        p1 = new Predicates.dollar_fail_0(cont);
        return new Predicates.Retractall_1(a3, p1);
    }
}
}

