/*
 * *** Please do not edit ! ***
 * @(#) WaitForOne_1.cs
 * @procedure wait_for_one/1 in wf.pl
 */

/*
 * @version P# 1.1.2, on Feb 16 2003;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using JJC.Psharp.Lang.Resource;
	using Predicates = JJC.Psharp.Predicates;
	using Resources = JJC.Psharp.Resources;

	public class ZapQueue_1 : Predicate {

		public Term arg1;

		public ZapQueue_1(Term a1, Predicate cont) {
			arg1 = a1; 
			this.cont = cont;
		}

		public ZapQueue_1(){}
		public override void setArgument(Term[] args, Predicate cont) {
			arg1 = args[0]; 
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			engine.setB0();
			Term a1, root;
			Predicate p1;
			a1 = arg1.dereference();
			root = engine.makeVariable( );

			p1 = new Predicates.GlobalRetractall_1(
				new StructureTerm( 
				SymbolTerm.makeSymbol( "msg", 2 ),
				new Term[] { root, engine.makeVariable( ) } ), cont );
			return new Predicates.dollar_getConcurrentRoot_2( a1, root, p1 );
		}

		public override int arity() { return 1; }

		public override string ToString() {
			return "zap_queue(" + arg1 + ")";
		}
	}
}

