/*
 * @(#) dollar_clearTable_1.cs
 * $B=R8l(B $clear_table/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.Collections;

	public sealed class dollar_clearTable_1 : Predicate {
		public static SymbolTerm SYM_user = SymbolTerm.makeSymbol("user");
		Term arg1;

		public dollar_clearTable_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_clearTable_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.dereference();
			object obj;

			if ( a1.isVariable() ) {
				return engine.abort("{INSTANTIATION ERROR: " + this + "}\n");
				//	    return null;
			}
			if ( a1.Equals(SYM_user) ) {
				engine.user_table.Clear();
				return cont;
			}
			if (! a1.isCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" -arg 1: expected table, found " +
					a1 + "}\n");
				//return null;
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is Hashtable) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" -arg 1: expected table, found " +
					a1 + "}\n");
				//	    return null;
			}
			((Hashtable)obj).Clear();
			return cont;
		}

		public override int arity() { return 1; }

		public override string ToString() {
			return "$clear_table(" + arg1 + ")";
		}
	}

}