/*
 * @(#)dollar_compare_3.cs
 * $B=R8l(B $compare/3
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_compare_3 : Predicate {
		private static SymbolTerm equal  = SymbolTerm.makeSymbol("=");
		private static SymbolTerm before = SymbolTerm.makeSymbol("<");
		private static SymbolTerm after  = SymbolTerm.makeSymbol(">");
		Term arg1, arg2, arg3;

		public dollar_compare_3(Term a1, Term a2, Term a3, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			arg3 = a3;
			this.cont = cont;
		}
		public dollar_compare_3() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			arg3 = args[2];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.dereference();

			Term t;
			int result = Prolog.compareTerm(arg2, arg3);

			if( result == 0 ) t = equal;
			else if( result < 0 ) t = before;
			else t = after;		
			if ( !a1.unify(t, engine.trail) ) 
				return engine.fail();
			return cont;
		}

		public override int arity() { return 3; }

		public override string ToString() {
			return "$compare(" + arg1 + "," + arg2 + "," + arg3 + ")";
		}
	}

}