/*
 * @(#)PRED_I36java_method_3.java
 * $B=R8l(B $java_method/3
 */
// import java.util.*;
// import java.lang.*;
// import java.lang.reflect.*;

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using System;
	using System.Reflection;

	public sealed class dollar_csMethod_3 : Predicate {
		Term arg1, arg2, arg3;

		public dollar_csMethod_3(Term a1, Term a2, Term a3, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			arg3 = a3;
			this.cont = cont;
		}

		public dollar_csMethod_3() {}
    
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			arg3 = args[2];
			this.cont = cont;
		}

		private bool callable(System.Reflection.ParameterInfo[] paraInfo, object[] args){
			Type[] paraTypes = new Type[ paraInfo.Length ];
			for( int i = 0; i < paraInfo.Length; i++ )	
				paraTypes[ i ] = paraInfo[ i ].ParameterType;

			int arity = paraTypes.Length;
			if (arity != args.Length)
				return false;
			for (int i=0; i<arity; i++) {

				/*
				if ( paraTypes[i].Equals(AssemblyList.GetAnyType("System.Int32")) ){
					if ( args[i] is Int32 )
						continue;
					else
						return false;
				}
				if ( paraTypes[i].Equals("System.Boolean") ){
					if ( args[i] is Boolean )
						continue;
					else
						return false;
				}
				*/
				
				if( !( paraTypes[ i ].IsInstanceOfType( args[ i ] ) ) )
					return false;

				//if (! paraTypes[i].isInstance(args[i]) )
				//	 return false;
			}
			return true;
		}


		/*

		private boolean callable(Class[] paraTypes, Object[] args){
			int arity = paraTypes.Length;
			if (arity != args.Length)
				return false;
			for (int i=0; i<arity; i++) {
				if ( paraTypes[i].equals(Integer.TYPE) ){
					if ( Integer.class.isInstance(args[i]) )
									 continue;
		else
			return false;
		}
		if ( paraTypes[i].equals(Boolean.TYPE) ){
		if ( Boolean.class.isInstance(args[i]) )
			continue;
		else
			return false;
		}
		if (! paraTypes[i].isInstance(args[i]) )
		return false;
	}
	return true;
	}

		*/
		
		public override Predicate exec( Prolog engine ) {
			Term a1, a2, a3;
			a1 = arg1.dereference();
			a2 = arg2.dereference();
			a3 = arg3.dereference();

			// Class clazz = null;
			Type type = null;
			object obj = null;
			object value = null;
			try {
				if ( a1.isSymbol() ) { //$BBh0l0z?t$O%/%i%9L>(B(symbol)$B$+%$%s%9%?%s%9(B(java term)
					type = AssemblyList.GetAnyType( ((SymbolTerm)a1).name );
				}
				else if ( a1.isCsObject() ) {
					obj = ((CsObjectTerm)a1).Object( );
					type = obj.GetType();
				}
				else {
					return engine.abort("{TYPE ERROR: " + this +
						" expected class or instance, found " + 
						a1 + "}\n");
				}
				// $BBhFs0z?t$O%a%=%C%I(B
				
				/*
				if ( a2.isSymbol() ) {    // $B0z?t$J$7$N%a%=%C%I(B
					Method meth = clazz.getMethod(((SymbolTerm)a2).name(), null);
					value = meth.invoke(obj, null);
				}
				
				else */ 
				if ( a2.isSymbol() || a2.isStructure() ) {  // $B0z?tM-$j$N%a%=%C%I(B
					string functor; 
					Term[] args;
					int arity;
					if( a2.isSymbol() ) {
						functor = ((SymbolTerm)a2).name;
						args = null;
						arity = 0;
					} else {
						functor = ((StructureTerm)a2).functor.name;
						args = ((StructureTerm)a2).args;
						arity = ((StructureTerm)a2).arity;
					}
					object[] initArgs = new object[arity];
					for (int i=0; i<arity; i++) {
						initArgs[i] = args[i].toCsObject();
					}
					MethodInfo[] ms = type.GetMethods( );
					// Method[] ms = clazz.getMethods();
					if ( ms.Length == 0 )
						return engine.fail();
					MethodInfo m = null;
					for (int i=0; i<ms.Length; i++){
						if ( ms[i].Name.Equals( functor )  
							&&  
							callable(ms[i].GetParameters(), initArgs) ){
							m = ms[i];
							break;
						}
					}
					if (m == null)
						return engine.fail();
					value = m.Invoke(obj, initArgs); //$B%a%=%C%I$N<B9T(B
				}
				else {
					return engine.abort("{TYPE ERROR: " + this +
						" expected method, found " + 
						a2 + "}\n");
				}

				/*
			} catch (NoSuchMethodException e1) {
				e1.printStackTrace();
				return engine.abort("{NO SUCH METHOD ERROR: " + this + "}\n");
			} catch (SecurityException e2) {
				e2.printStackTrace();
				return engine.abort("{SECURITY ERROR: " + this + 
					" expected accessible method, found " + a2 + "}\n");
			} catch (IllegalArgumentException e3) {
				e3.printStackTrace();
				return engine.abort("{ILLEGAL ARGUMENT ERROR: " + this + "}\n");
			} catch (InvocationTargetException e4) {
				e4.printStackTrace();
				return engine.abort("{INVOCATION TARGET ERROR: " + this + "}\n");
			} catch (NullPointerException e5) {
				e5.printStackTrace();
				return engine.abort("{NULL POINTER ERROR: " + this + "}\n");
			} catch (IllegalAccessException e6) {
				e6.printStackTrace();
				return engine.abort("{ILLEGAL ACCESS ERROR: " + this + "}\n");
				*/
			} catch (Exception e) {
				// e.printStackTrace();
				return engine.abort("{CS ERROR: " + this + "}\n" + e);
			}
			// $BBh;00z?t$HJV$jCM$r(Bunify
			if ( value == null ) 
				return cont;
			if ( !a3.unify(new CsObjectTerm(value), engine.trail) )
				return engine.fail();
			return cont; 
			//	if ( !a3.unify(engine.toPrologTerm(value), engine.trail) ) 
			//	    return engine.fail();
			//	return cont; 
		}

		public override int arity() { return 3; }
		public override string ToString() {
			return "$cs_method(" + arg1 + "," + arg2 + "," + arg3 + ")";
		}
	}
}