namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using System.Collections;

	public sealed class dollar_globalTable_2 : Predicate {
		Term arg1;
		Term arg2;

		static Hashtable global_table = Hashtable.Synchronized( new Hashtable( ) );
        static CsObjectTerm global_table_lock = new CsObjectTerm( new TableSynchObj( ) );

		public dollar_globalTable_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_globalTable_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			Term a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();
			CsObjectTerm jTerm1, jTerm2;
	
			jTerm1 = new CsObjectTerm(global_table);
			jTerm2 = global_table_lock; // new CsObjectTerm(global_table_lock);
			if ( !a1.unify(jTerm1, engine.trail ) ) 
				return engine.fail();
			if ( !a2.unify(jTerm2, engine.trail ) )
				return engine.fail();
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$global_table(" + arg1 + ", " + arg2 + ")";
		}
	}

	class TableSynchObj {
		public override string ToString( ) {
			return "TableSynch: " + this.GetHashCode( );
		}
	}


}