namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_lock_1 : Predicate {

		Term arg1;

		public dollar_lock_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_lock_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1 = arg1.dereference( );
			if( a1.isVariable( ) )
				if( ( (VariableTerm)a1 ).concurrentRoot != null )
					a1 = ( (VariableTerm)a1 ).concurrentRoot.csObject;
			object to_lock;
			if( a1.isCsObject( ) )
				to_lock = a1.toCsObject( );
			else
				to_lock = a1;

			System.Threading.Monitor.Enter( a1.toCsObject( ) );
			engine.reportLock( a1.toCsObject( ) );
		
			//engine.user_output.WriteLine( "Lock/1 ing: " + to_lock );
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$lock(" + arg1 + ")";
		}	
	}

}