/*
 * @(#)dollar_putTerm_3.cs
 * $B=R8l(B $put_term/3
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.Collections;

	public sealed class dollar_putTerm_3 : Predicate {
		private static SymbolTerm SYM_user = SymbolTerm.makeSymbol("user");
		Term arg1, arg2, arg3;

		public dollar_putTerm_3(Term a1, Term a2, Term a3, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			arg3 = a3;
			this.cont = cont;
		}
		public dollar_putTerm_3() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			arg3 = args[2];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Hashtable table = null;
			string key;
			object obj;
			Term a1, a2, a3;
			a1 = arg1.dereference();
			a2 = arg2.dereference();
			a3 = arg3.dereference();

			if ( a1 == SYM_user )
				table = engine.user_table;
			else if ( a1.isCsObject() ) {
				obj = ((CsObjectTerm)a1).Object();
				if ( !(obj is Hashtable) ) {
					return engine.abort("{TYPE ERROR: " + this +
						" -arg 1: expected table, found " + a1 + "}");
				}
				table = (Hashtable)obj;
			}
			else {
				return engine.abort("{TYPE ERROR: " + this +
					" -arg 1: expected table, found " + a1 + "}");
			}
			key = a2.ToString();
			if( table.ContainsKey(key) )
				table.Remove(key);
			table.Add(key, a3);
			return cont;
		}

		public override int arity() { return 3; }
		public override string ToString() {
			return "$put_term(" + arg1 + "," + arg2 + "," + arg3 + ")";
		}
	}

}