/*
 *  @(#)dollar_readToken0_2.cs
 *  $B=R8l(B $read_token0/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_readToken0_2 : Predicate {
		Term arg1, arg2;
  
		public dollar_readToken0_2(Term a1, Term a2, Predicate cont){ 
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_readToken0_2(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();
			int type;
			Term token = null;
			System.Text.StringBuilder s = new System.Text.StringBuilder();

			try {
				type = Token.read_token(s, engine.current_input);
				switch(type) {
					case 'I':
						token = new IntegerTerm(System.Int32.Parse(s.ToString())); 
						break;
					case 'S':
						token = SymbolTerm.makeSymbol(s.ToString());
						break;
					default :
						token = SymbolTerm.makeSymbol(s.ToString());
						break;
				}
				if ( !a1.unify(new IntegerTerm(type), engine.trail) 
					|| 
					!a2.unify(token, engine.trail) )
					return engine.fail();
			} catch (IOException) {
				return engine.abort("{IO ERROR: " + this + "}\n");
			}
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$read_token0(" + arg1 + ", " + arg2 + ")";
		}
	}

}