/*
 * @(#)dollar_rightshift_3.cs
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_rightshift_3 : Predicate {
		Term arg1, arg2, arg3;

		public dollar_rightshift_3(Term a1, Term a2, Term a3, Predicate cont){
			arg1 = a1;
			arg2 = a2;
			arg3 = a3;
			this.cont = cont;
		}
		public dollar_rightshift_3(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			arg3 = args[2];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ){
			Term a3;
			a3 = arg3.dereference();
			try {
				int x = engine.evalTerm(arg1);
				int y = engine.evalTerm(arg2);
				if( !a3.unify(new IntegerTerm((int)(x>>y)), engine.trail) )
					return engine.fail();
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + this +  "}\n");
			}
			return cont;

		}

		public override int arity() { return 3; }
		public override string ToString() {
			return "$rightshift(" + arg1 + "," + arg2 + "," + arg3 + ")";
		}
	}

}