namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_sleep_1 : Predicate {
		Term arg1;

		public dollar_sleep_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_sleep_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1 = arg1.dereference( );
			if( a1.isInteger( ) ) {
				System.Threading.Thread.Sleep( (int)( a1.toCsObject( ) ) );
				return cont;
			} else
				return engine.fail( );
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$pause(" + arg1 + ")";
		}	
	}

}