namespace JJC.Psharp.Lang {

	using System;
	using System.Collections;
	using System.Reflection;	

	public sealed class AssemblyList {
		
		static ArrayList list = new ArrayList( );
		static ArrayList nameList = new ArrayList( );

		public static void Clear( ) {
			list = new ArrayList( );
			nameList = new ArrayList( );
		}

		public static void Add( Assembly a, string name ) {
			lock( typeof( AssemblyList ) ) 
				list.Insert( 0, a );
				nameList.Insert( 0, name );
		}

		public static void Promote( string name ) {
			lock( typeof( AssemblyList ) ) {
				int ind = nameList.IndexOf( name );
				Assembly a = (Assembly)( list[ ind ] );
				list.RemoveAt( ind );
				nameList.RemoveAt( ind );
				list.Insert( 0, a );
				nameList.Insert( 0, name );
			}
		}

		public static void Promote( Assembly a1 ) {
			lock( typeof( AssemblyList ) ) {
				int ind = list.IndexOf( a1 );
				string name = (string)( nameList[ ind ] );
				list.RemoveAt( ind );
				nameList.RemoveAt( ind );
				list.Insert( 0, a1 );
				nameList.Insert( 0, name );
			}
		}

		public static bool IsLoaded( string name ) {
			lock( typeof( AssemblyList ) ) {
				foreach( object o in nameList )
					if( o != null )
						if( ((string)o).Equals( name ) ) 
							return true;
				return false;
			}
		}

		public static bool IsLoaded( Assembly a1 ) { 
			lock( typeof( AssemblyList ) ) {
				foreach( Assembly a2 in list ) {
					if( a2.Equals( a1 ) )
						return true;
				}
				return false;
			}
		}

		public static Type GetAnyType( string name ) {
			lock( typeof( AssemblyList ) ) {
				Type t = Type.GetType( name );
				if( t != null )
					return t;
				foreach ( object o in list )
					if( ( t = ((Assembly)o).GetType( name ) ) != null )
						return t;
				return null;
			}
		}
	}

}
