/*
 *  @(#)IntegerTerm.cs
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 */

namespace JJC.Psharp.Lang {

	public sealed class IntegerTerm : Term {
		private int val;

		public IntegerTerm(int i) {	val = i; }

		public int value() { return val; }

		public override bool unify( Term t, Trail trail ) {
			t = t.dereference();
			if ( t.isVariable() )
				return ((VariableTerm)t).unify(this, trail);
			if ( !t.isInteger() )
				return false;
			return val == ((IntegerTerm)t).value();
		}

		public override bool Equals(Term t) {
			//	t = t.dereference();
			if( !t.isInteger() )
				return false;
			return val == ((IntegerTerm)t).value();
		}

		//    public Term copyTerm(Hashtable table) {
		//	return new IntegerTerm(val);
		//    }

		public override Term copyTerm(Prolog engine) {
			return new IntegerTerm(val);
		}

		/* START JJC */
		public override Term cloneTerm(Prolog oldEngine, Prolog newEngine, bool makeConc ) {
			return new IntegerTerm(val);
		}
		/* END JJC */

		/*
		public Class getJavaType() {
		return java.lang.Integer.TYPE;
		}*/
		public override object toCsObject() {
			return val;
		}

		public override string ToString() {
			return val.ToString( );
		}
	}

}