/*
 * @(#)PrologMain.cs
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 */

namespace JJC.Psharp.Lang {

	using System;
	using System.Reflection;
	
	using JJC.Psharp.Predicates;

	public sealed class PrologMain {

		public static void Main( String[] argv ) {

			if( !Assembly.GetCallingAssembly( ).Equals( Assembly.GetExecutingAssembly( ) ) )
				AssemblyList.Add( Assembly.GetCallingAssembly( ), null );

			System.Console.WriteLine( "\nP# 1.1.2 - [concurrent]" );
			System.Console.WriteLine( "Copyright(C) 2003 J.J.Cook" );
			System.Console.WriteLine( "\nBased on:" );
			System.Console.WriteLine( "\n" + "Prolog Cafe 0.44");
			//	System.Console.WriteLine(new java.util.Date());
			System.Console.WriteLine("Copyright(C) 1997-1999 M.Banbara and N.Tamura");
			//	PrologInterface p = new PrologInterface();
			//	Predicate cont = new ReturnJava(p);
			Prolog engine = new Prolog();
			Predicate cont = new Fail_0(null); 
			Predicate code;
			if (argv.Length == 0)
				code = makePredicate("Cafeteria"); //$B%$%s%?%W%j%?(B
			else 
				code = makePredicate(argv[0]);     //$B;XDj$5$l$?=R8l(B
			code.setArgument(null, cont);
			//	p.setPredicate(code);
			//	for (boolean r = p.call(); r; r = p.redo()) {}
			try {
				while (true) {
					if (code == null) 
						break;
					//code.setEngine(engine);
					//System.Console.WriteLine( code );
					
					code = code.exec( engine ); // engine);
					code = engine.ServiceQueue( code );
				}
			}
			catch (AbortException e){
				System.Console.WriteLine(e.Message);
			}		
		}

		public static Predicate makePredicate(String pred){
			String className = "JJC.Psharp.Predicates." + pred + "_" + 0;
			Type clazz;
			Predicate code = null;
			try {
				clazz = AssemblyList.GetAnyType( className );	
				code = (Predicate)Activator.CreateInstance( clazz );
			} catch( Exception ) {
				System.Console.WriteLine("{EXISENTCE ERROR: procedure " + pred + "/0" +
					" does not exist}\n");
				throw new PrologException( );
			}
			return code;
		}

		private static readonly SymbolTerm Nil = SymbolTerm.makeSymbol("[]");

		public static Term makeList(int n){
			Term t = Nil;
			for (int i=n; i>0; i--){
				t = new ListTerm(new IntegerTerm(i), t);
			}
			return t;
		}
	}

}