/*
 * @(#)Term.cs
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 */

namespace JJC.Psharp.Lang {

	using JJC.Psharp.Lang.Resource;

	public abstract class Term {

		public virtual Term dereference(){
			return this;
		}

		public bool isNil(){
			return Prolog.Nil.Equals( this );
			//return this == Prolog.Nil;
		}

		public bool isVariable(){
			return this is VariableTerm;
		}

		public bool isSymbol(){
			return this is SymbolTerm;
		}

		public bool isInteger(){
			return this is IntegerTerm;
		}
		//    public bool isFloat() {
		//	return this is FloatTerm;
		//    }
		public bool isList(){
			return this is ListTerm;
		}

		public bool isStructure(){
			return this is StructureTerm;
		}

		public bool isCsObject(){
			return this is CsObjectTerm;
		}

		public bool isResIndex(){
			return this is ResIndexTerm;
		}

		public bool isClosure(){
			return this is ClosureTerm;
		}
		/*
		public Class getJavaType(){
		return java.lang.Object.class;
		}*/
		public virtual object toCsObject(){
			return this;
		}
		//    public Term copyTerm(java.util.Hashtable table){ 
		//	return this; 
		//    }
		public virtual Term copyTerm(Prolog engine){ 
			return this; 
		}

		/* START JJC */
		public virtual Term cloneTerm(Prolog oldEngine, Prolog newEngine, bool makeConc ) {
			return this; // careful!
		}
		/* END JJC */

		abstract public bool unify( Term t, Trail trail );
		abstract public bool Equals( Term t );
	}

}