/* 
 *  @(#)ResIndexTerm.cs
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 */

// import java.util.*;

namespace JJC.Psharp.Lang.Resource {

	using JJC.Psharp.Lang;

	public sealed class ResIndexTerm : Term {
		private int index;

		public ResIndexTerm(int i) { index = i; }

		public int getIndex() { return index; }

		public override bool unify(Term t, Trail trail) {
			t = t.dereference();
			if ( t.isVariable() )
				return ((VariableTerm)t).unify(this, trail);
			if ( !t.isResIndex() )
				return false;
			return index == ((ResIndexTerm)t).getIndex();
		}

		public override bool Equals(Term t) {
			//	t = t.dereference();
			if( !t.isResIndex() )
				return false;
			return index == ((ResIndexTerm)t).getIndex();
		}

		//    public Term copyTerm(Hashtable table) {
		//	return new ResIndexTerm(index);
		//    }

		public override Term copyTerm(Prolog engine) {
			return new ResIndexTerm(index);
		}

		/*
		public Class getJavaType() {
		return java.lang.Integer.TYPE;
		}*/
		public override object toCsObject() {
			return index;
		}

		public override string ToString() {
			return index.ToString();
		}
	}

}