/*
 *  @(#)dollar_addRes_2.cs
 *  $B=R8l(B $add_res/2
 */

/* 
 * @author Mutsunori Banbara 
 *         banbara@pascal.seg.kobe-u.ac.jp
 *         Nara National College of Technology
 * @author Naoyuki Tamura 
 *         tamura@kobe-u.ac.jp
 *         Kobe University
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using JJC.Psharp.Lang.Resource;

	public sealed class dollar_addRes_2 : Predicate {
		Term arg1, arg2;

		public dollar_addRes_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_addRes_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();

			if ( !a2.isClosure() ){
				return engine.abort("{TYPE ERROR: " + this + "}\n");
				//return engine.fail();
			}
			engine.addRes(a1,(ClosureTerm)a2);
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$add_res(" + arg1 + ", " + arg2 + ")";
		}
	}

}